/*
* --------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2003
* All rights reserved.
*
* Program : Header file for all crypto sources
* Abstract : This file includes all common definitions of crypto engine.
* $Id: crypto.h,v 1.1.1.1 2006/07/26 05:38:21 blue Exp $
* $Log: crypto.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:21  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:01  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:40  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.3  2005/09/08 14:07:00  yjlou
* *: fixed the porting bugS of software DES in re865x/crypto: We always use Linux kernel's DES library.
*
* Revision 1.2  2004/12/22 08:48:08  yjlou
* +: add 16 NOPs when polling AuthEngine
*
* Revision 1.1  2004/06/23 09:18:57  yjlou
* +: support 865xB CRYPTO Engine
*   +: CONFIG_RTL865XB_EXP_CRYPTOENGINE
*   +: basic encry/decry functions (DES/3DES/SHA1/MAC)
*   +: old-fashion API (should be removed in next version)
*   +: batch functions (should be removed in next version)
*
*
*
* --------------------------------------------------------------------
*/

#ifndef __CRYPTO_H__
#define __CRYPTO_H__

#define UNCACHED_MALLOC(x)  (void *) (0xa0000000 | (uint32) rtlglue_malloc(x))
#define UNCACHED_FREE(x)  rtlglue_free( (void *) (~0x20000000 & (uint32) x ) )

#include <rtl_glue.h>

#define IDLE_CPU() \
	do {\
		asm( "\
			nop; nop; nop; nop; nop; nop; nop; nop; \
			nop; nop; nop; nop; nop; nop; nop; nop; \
			"); \
	} while (0) 

#endif// __CRYPTO_H__
