/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* Abstract: This file provides header stamp access routines.
*
* $Author: blue $
* $id$
*/
#include "rtl_types.h"
#include "types.h"
#include "asicRegs.h"
#include "assert.h"
#include "hsModel.h"
#ifdef RTL865X_MODEL_USER
#include "rtl_utils.h"
#include "rtl_glue.h"
#endif


int32 modelGetHsb( hsb_t* hsb )
{
	memcpy( hsb, (void*)HSB_BASE, sizeof(*hsb) );
	return SUCCESS;
}

int32 modelSetHsb( hsb_t* hsb )
{
	memcpy( (void*)HSB_BASE, hsb, sizeof(*hsb) );
	return SUCCESS;
}


int32 modelGetHsa( hsa_t* hsa )
{
	memcpy( hsa, (void*)HSA_BASE, sizeof(*hsa) );
	return SUCCESS;
}

int32 modelSetHsa( hsa_t* hsa )
{
	memcpy( (void*)HSA_BASE, hsa, sizeof(*hsa) );
	return SUCCESS;
}


