/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Header File of Model Code for 865xC
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: icTest.h,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#ifndef _MODEL_TEST_
#define _MODEL_TEST_

#include "hsModel.h"

//int32 testModel_PktParser1(uint32 caseNo);
int32 runModelTest(uint32 userId,  int32 argc,int8 **saved);



/* Bitmask for test code and model export */
#define AUTO_CASE_NO 0 /* auto-increased Case No */
#define GRP_ALL             0x00000001
#define GRP_PKT_PARSER      0x00000002
#define GRP_PKT_TRANSLATOR  0x00000004
#define GRP_PRE_CORE        0x00000008
#define GRP_L2              0x00000010
#define GRP_L34             0x00000020
#define GRP_POST_CORE       0x00000040
#define GRP_GDMA			0x00000080
#define GRP_NIC			0x00000100


int32 compHsa( hsa_t* hsa1, hsa_t* hsa2 );
int32 compHsb( hsb_t* hsb1, hsb_t* hsb2 );
void modelCPUport(hsb_t*,hsa_t* );
int32 testLayer2FIDLearning(uint32 caseNo);
int32 testLayer2UniLearning(uint32);
int32 testLayer2UniLRULearning(uint32);
int32 testLayer2UnwareVlan(uint32);
int32 testLayer2VlanNoExist(uint32);
int32 testLayer2UnkonwUniCast(uint32);
int32 testLayer2UnKnownMulticast(uint32);
int32 testLayer28021XPortBase(uint32);
int32 testLayer3Routing(uint32);
int32 testLayer3MTU(uint32);
int32 testServerPort(uint32);
int32 testALG(uint32);
int32 testLocalPublic(uint32);
int32 testLocalPublicIP(uint32);
#endif
