/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Header File for Layer3/4 Model Code
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: l34Model.h,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#ifndef _L34_MODEL_
#define _L34_MODEL_

enum MODEL_RETURN_VALUE modelLayer3Switching( hsb_t* hsb, hsa_t* hsa );
enum MODEL_ACTION_VALUE modelLayer4Switching( hsb_t* hsb, hsa_t* hsa ,uint8);
enum MODEL_ACTION_VALUE
{
	/* 0*/	MACT_FORWARD = 0,
	/* 1*/	MACT_L3ROUTING,
	/* 2*/	MACT_TOCPU,
};

enum MODEL_ACTION_VALUE modelMatchInternalServerPort( hsb_t* hsb, hsa_t* hsa);
enum MODEL_ACTION_VALUE modelMatchExternalServerPort( hsb_t* hsb, hsa_t* hsa);
enum MODEL_RETURN_VALUE modelAlgCheck( hsb_t* hsb, hsa_t* hsa,int  );

#endif

