/*
* Copyright c                  Realtek Semiconductor Corporation, 2004 
* All rights reserved.
* 
* Program : CuSeeMe
* Abstract : 
* Creator : 
* Author :
* $Id: rtl8651_alg_cuseeme.h,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_cuseeme.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.4  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.3  2004/03/16 07:53:50  tony
* support endian free for test module.
*
* Revision 1.2  2004/03/16 03:52:18  tony
* fix bug: CUseeMe ALG support endian free for test module
*
* Revision 1.1  2004/03/12 07:34:44  tony
* add new ALG for CUseeMe
*
*
*
*/

#ifndef _RTL8651_ALG_CUSEEME
#define _RTL8651_ALG_CUSEEME



struct cu_header{
	uint16 	dest_family;
	uint16 	dest_port;
	uint32  	dest_addr;
	int16 	family;
	uint16 	port;
	uint32	addr;
	uint32	seq;
	uint16 	msg;
	uint16	data_type;
	uint16	packet_len;
} ;

/* Open Continue Header */
struct oc_header{
	uint16 	dest_family;
	uint16 	dest_port;
	uint32  	dest_addr;
	int16 	family;
	uint16 	port;
	uint32	addr;
	uint32	seq;
	uint16 	msg;
	uint16	data_type;
	uint16	packet_len;
	uint16 	client_count; 
	uint32	seq_no;
	char		user_name[20];
	char		stuff[4];
};

/* client info structures */
struct client_info{
	uint32		address; 
	char	       	stuff[8];
};


int32 rtl8651_l4AliasHandleCUseeMeClientOutbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);
int32 rtl8651_l4AliasHandleCUseeMeClientInbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);


#endif /* _RTL8651_ALG_CUSEEME */
