/*
* Copyright c                  Realtek Semiconductor Corporation, 2003  
* All rights reserved.
* 
* Program : L2TP ALG
* Abstract : 
* Creator : 
* Author :
* $Id: rtl8651_alg_l2tp.h,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_l2tp.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.3  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/19 08:12:53  tony
* make IPSec, PPTP, L2TP are able to set session numbers dynamically by user.
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.4  2004/01/09 08:03:21  tony
* make the code architecture of ALG is able to support multiple dial session.
*
* Revision 1.3  2003/12/31 04:59:26  tony
* fix bug: turn L2TP ALG on/off dynamically.
*
* Revision 1.2  2003/12/16 12:07:22  tony
* fix bug: make DirectX ALG support game AOE2.
*
* Revision 1.1  2003/12/08 03:37:26  tony
* add new ALG: L2TP v2 multiple-session
*
*
*
*/

#ifndef _RTL8651_ALG_L2TP
#define _RTL8651_ALG_L2TP



int32 rtl8651_l4AliasL2tpInit(void*);
int32 rtl8651_l4AliasHandleL2tpClientInbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);
int32 rtl8651_l4AliasHandleL2tpClientOutbound(struct rtl_pktHdr *, struct ip *,struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *);

struct l2tp_header
{
	uint16 flag;
	uint16 length;
	uint16 tunnel_id;
	uint16 session_id;
};

struct l2tp_session
{
	uint32 redirect_ip;
	uint16 tunnel_id;
};


#endif /* _RTL8651_ALG_L2TP */
