#ifndef TYPES_H
#define TYPES_H

#ifdef INTRA_DIR
//typedef unsigned __int64	uint64;
//typedef __int64				int64;
typedef unsigned int		uint32;
typedef int					int32;
typedef unsigned short		uint16;
typedef short				int16;

typedef unsigned char		uint8;
typedef char				int8;
typedef uint32				memaddr;	
typedef uint32				ip4a;

//#define _LITTLE_ENDIAN

#define swapl32(x)\
        ((((x) & 0xff000000U) >> 24) | \
         (((x) & 0x00ff0000U) >>  8) | \
         (((x) & 0x0000ff00U) <<  8) | \
         (((x) & 0x000000ffU) << 24))
#define swaps16(x)        \
        ((((x) & 0xff00) >> 8) | \
         (((x) & 0x00ff) << 8))

#ifdef _LITTLE_ENDIAN
	#define ntohs(x)   (swaps16(x))
	#define ntohl(x)   (swapl32(x))
	#define htons(x)   (swaps16(x))
	#define htonl(x)   (swapl32(x))
#else
	#define ntohs(x)	(x)
	#define ntohl(x)	(x)
	#define htons(x)	(x)
	#define htonl(x)	(x)
#endif

#ifndef NULL
#define NULL	0
#endif

#else /* INTRA_DIR */

#include "rtl_types.h"

#endif /* INTRA_DIR */

#endif

