

/* NAPT */
#ifdef CONFIG_RTL865XB_EXP_HASH2
int32 AddNaptConnectionErrors(uint32 caseNo);
int32 NaptInterfaceRoute(uint32 caseNo);
int32 NaptInterfaceRoute2(uint32 caseNo);
int32 NaptTypicalCase(uint32 caseNo);
int32 NaptTypicalCaseButHash2Accelerated(uint32 caseNo);
int32 NaptTypicalCaseButHalfAccelerated(uint32 caseNo);
int32 NaptTypicalCaseWith4Way(uint32 caseNo);
int32 NaptTestL04(uint32 caseNo);
int32 NaptTestL04UdpForCDRouter(uint32 caseNo);
int32 NaptTest4096Connections(uint32 caseNo);
int32 testNapt4WayHash(uint32 caseNo);
int32 testAgeOfHash2PortReused(uint32 caseNo);
int32 DMZHostUsingHash1(uint32 caseNo);
int32 DMZHostUsingHash2(uint32 caseNo);
int32 Hash2BestCase(uint32 caseNo);
int32 Hash2WorstCase(uint32 caseNo);
int32 ServerPortUsingOneHash2Entry(uint32 caseNo);
int32 ServerPortUsingTwoHash2Entries(uint32 caseNo);
int32 TestNaptAlgConnection(uint32 caseNo);
int32 TestUpdateNaptConnection1Way(uint32 caseNo);
int32 TestUpdateNaptConnection4Way(uint32 caseNo);
int32 TestUpdateNaptConnectionHybrid1(uint32 caseNo);
int32 TestUpdateNaptConnectionHybrid2(uint32 caseNo);
#else//CONFIG_RTL865XB_EXP_HASH2
int32 NaptTypicalCase(uint32 caseNo);
int32 NaptTypicalCaseRandomTest(uint32 caseNo);
int32 NaptHash1Hash2RandomTest(uint32 caseNo);
int32 NaptAddConnectionError(uint32 caseNo);
int32 NaptPortRangeBug(uint32 caseNo);
int32 NaptAddAlgCtrlConnectionRandomTest(uint32 caseNo);
int32 NaptAddAlgCtrlConnectionError(uint32 caseNo);
#endif//CONFIG_RTL865XB_EXP_HASH2
int32 testChangeNaptIpAndPort(uint32 caseNo);

int32 testGetOutboundNaptFlow(uint32 caseNo );
int32 testNewlyAddedHash2Udp(uint32 caseNo );
int32 AddConnPerSec_Hash1(uint32 caseNo );
int32 AddConnPerSec_Hash2(uint32 caseNo );
int32 NaptTestAddNaptConnectiondBug(uint32 caseNo );
int32 ServerPortAndNewHash1(uint32 caseNo);
int32 NaptTestMoreThan4096Connections(uint32 caseNo);
int32 NaptTestIpEntryReferenceCount(uint32 caseNo);
int32 Hash2_2pairs(uint32 caseNo);
int32 Hash2_Outbound_Ambigious(uint32 caseNo);

/* Server Port */
int32 NaptAddServerPortError(uint32 caseNo);
int32 NaptAddDelServerPort(uint32 caseNo);
int32 NaptAddDelServerPortRandomTest(uint32 caseNo);
int32 NaptAddDelServerPortRandomTest2(uint32 caseNo);
int32 NaptFlushNaptServerPortbyExtIpRandomTest(uint32 caseNo);
int32 testServerPortParkTcpUdp(uint32 caseNo);

/* DMZHost */
int32 NaptDMZHostError(uint32 caseNo);
int32 NaptAddDMZHost(uint32 caseNo);
int32 NaptAddDMZHost2(uint32 caseNo);
int32 NaptAddDMZHostRandomTest(uint32 caseNo);

/* ALG */
int32 AddDelALGError(uint32 caseNo);
int32 AddDelALGBug(uint32 caseNo);
int32 AddDelALGRandomTest(uint32 caseNo);

/* ICMP */
int32 AddDelIcmpError(uint32 caseNo);
int32 AddDelIcmpRandomTest(uint32 caseNo);

