/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_utility.h,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract:
*
* $Log: pg_utility.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:12  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:43  danwu
* init
*
* Revision 1.2  2003/12/19 02:22:22  danwu
* no message
*
* Revision 1.1  2002/08/28 03:44:28  orlando
* packet generation module initial check-in.
*
*-------------------------------------------------------------------------
*/

#ifndef _PG_UTILITY_H_
#define _PG_UTILITY_H_

#include "../../rtl_types.h"


void memDump(void *start, uint32 size, int8 * strHeader);
uint16 ipcsum(uint16 *ptr, uint32 len, uint16 resid);
uint16 ipadjcsum(uint16 old, uint32 diff);


struct in_addr
{
	uint32    s_addr;
};


#define	INADDR_NONE	0xffffffff	/* -1 return */

//Network order part
int32 inet_aton(const int8 *cp, struct in_addr *addr);
/*deprecated.*/
uint32 inet_addr(const int8 *cp);
int8 *inet_ntoa(struct in_addr ina);

/*int isdigit( int c );
int isascii( int c );
int islower( int c );
int isspace( int c );
int isxdigit( int c );*/

#endif /* _PG_UTILITY_H_ */
