#ifndef __CP_TOOLS_H__
#define __CP_TOOLS_H__

int strlen(const char* str);
char *strcpy(char * dst, const char * src);
void *memcpy(void *out, const void *in, unsigned int n);
void *memset(void *out, const int in, unsigned int n);
void delay_s(int n);
void MyWrite(char* pStr);
char* itoa(unsigned int nValue, unsigned int nRadix, char* pStr, int nBufSize);
void WriteNumber(unsigned int nNumber);
void WriteNumberHex(unsigned int nNumber, int bPrefix);
void WriteNumberLongLongHex(unsigned long long nNumber, int bPrefix);
unsigned long long ll_mul(unsigned long long x, unsigned long long y);
unsigned long long ll_div(unsigned long long x, unsigned long long y);
unsigned long long ll_mod(unsigned long long x, unsigned long long y);
void cp3_set_counter_usage(int counter, unsigned int usage);
void cp3_get_counters(void);
const char* cp3_get_usage_title(int counter);
void cp3_show_counter(int counter, int peer_counter);

#endif
