#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define LpcOrder	10
#define SubFrLen	60
#define PitchMax	145
#define Frame		240

	.data
	.align	4
ScfTab:
	.half	9170, 9170, 9170, 9170
	.half	10289,11544,12953,14533
	.half	16306,18296,20529

/*
Flag Comp_Vad(Word16 *Dpnt)
	s0->Dpnt
local:
	Tm0->s1
	Tm1->s2
	Tm2->s3
	VadState->s4
	pVadStat->s5
	pCodStat->s6	
	Tmp[]->PastX
	32(sp)->mmd
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Comp_Vads
	.ent	Comp_Vads
Comp_Vads:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 36(sp)
	sw		s4, 40(sp)
	sw		s5, 44(sp)
	sw		s6, 48(sp)
	sw		ra, 52(sp)
	mfru	t4, mmd	
	move	s0, a0		//s0->Dpnt	
	sw		t4, 32(sp)
	///////////////////	
	//lw		s6, pCodStat//s6->pCodStat
	.extern pCoderMem
	lw		s6, pCoderMem
	lh		t0, UseVx
	addu	s6, s6, 784	//s6=pCoderMem->CodStat
	beqz	t0, 5f
	li		s4, 1		//VadState=1	
	/* Find Minimum pitch period */	
	//lw		s5, pVadStat//s5->pVadStat
	.extern pCoderMem
	lw		s5, pCoderMem	
	li		t9, PitchMax//t9=Minp
	mux2.ll	t9, t9, t9	
	addu	s5, s5, 2264//s5-pCoderMem->VadStat
	addu	a1, s5, 16	//a1->pVadStat->Polp[0]
	lw		t0, 0(a1)	//t0=Polp[0:1]
	lw		t1, 4(a1)	//t1=Polp[2:3]
	min		t9, t9, t0
	min		t9, t9, t1
	mux2.hl	t8, zero, t9
	sra		t7, t9, 16
	min		t9, t7, t8
	/* Check that all are multiples of the minimum */
	li		v0, 4	;li		s3, 0 //v0=i, s3=Tm2
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t8, 8-1	;addu	a1, s5, 16	//a1->VadStat.Polp[0]	
3:	
	lhp		t4, (a1)+2;move	s2, t9		//s2=Tm1
	mtru	t8, lpc0  ;li	t5, 3
1:
	sub		s1, s2, t4
	absr.s	s1, s1	
	addi	t1, s3, 1	//Tm2++
	sle		t0, s1, t5
	cmvnez	s3, t1, t0
	add		s2, s2, t9
2:	
	// end i
	sub		v0, v0, 1
	bgtz	v0, 3b
	nop
	
	/* Update adaptation enable counter if not periodic and not sine */
	.align	8
	lh		t9, 12(s5)	//t9=VadStat.Aen		
	sub		t0, s3, 4	//t0=Tm2-4	
	lh		t1, 14(s6)	//t1=SinDet
	seq		t0, t0, zero
	slt		t1, t1, zero	;add	t2, t9, 2
	add		t0, t0, t1		;sub	t9, t9, 1	
	cmvnez	t9, t2, t0
	/* Clip it */
	li		t0, 6
	min		t9, t9, t0
	max		t9, t9, zero
	sh		t9, 12(s5)
	
	/* Inverse filter the data */
	addu	a0, s5, 24	//a0->VadStat.NLpc[0]
	la		a2, PastX	
	addu	a2, a2, (LpcOrder-2)*2//a2->Tmp[8]
	lwp		t0, (a0)+4
	lwp		t1, (a0)+4
	lwp		t2, (a0)+4	;mux2.lh	t0, t0, t0
	lwp		t3, (a0)+4	;mux2.lh	t7, t1, t1
	lwp		t4, (a0)+4	;mux2.lh	t6, t2, t2
	swp		t0, (a2)-8	;mux2.lh	t3, t3, t3
	stp		t6, (a2)-8	;mux2.lh	t2, t4, t4
	st		t2, 0(a2)	//a2->Tmp[0]
	sw		zero, (LpcOrder*2)(a2)	
	
	li		t4, 0x6	;multa2	m2h,zero,zero//m2h=Acc1=0
	mtru	t4, mmd	;li	t9, (Frame-SubFrLen)/2//t9=i
	la		t0, 1f	//fractional mode
	la		t1, 2f-4
	li		t8, (LpcOrder+2)/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	
	addu	a3, s0, (SubFrLen-1-(LpcOrder-1))*2	
	li		t7, 0x20002000	
3:	// for(i=SubFrLen; i<Frame; i++)
	move	a0, a3	//a0->Dpnt[50]
	move	a1, a2	//a1->Tmp[0]
	mtru	t8, lpc0
	//D: t0:[50 51]t1:[52 53]t4:[54 55]
	//T: t2:[0 1]t3:[2 3]
	lwp		t0, (a0)+4
	ltp		t2, (a1)+8	;multa2	m0,zero,zero
	lwp		t1, (a0)+4	;multa2	m1,zero,zero
	lwp		t4, (a0)+4	
	.align 	3
1:		//for(j=0; j<LpcOrder; j++)	
	msuba2.s m0, t0, t2	;mux2.lh	t5, t0, t1
	msuba2.s m0, t1, t3	;mux2.lh	t6, t2, t3
	msuba2.s m1, t5, t2	;move		t0, t4
	msuba2.s m1, t6, t3	;lwp		t1, (a0)+4
	lwp		t4, (a0)+4	//t4=Dpnt[i,i+1]	
	ltp		t2, (a1)+8	
2:		//end j
	madda2.s m0h, t4, t7	;madda2.s m1l, t4, t7
	addma.s	m0l,m0l,m0h		;addma.s m1l,m1l,m1h
	li		t4, 0x00008000	;mfa	t0, m0l
	addr.s	t0, t0, t4		;mfa	t1, m1l
	addr.s	t1, t1, t4		;madda2.s m2h, t0, t0
	madda2.s m2h, t1, t1	
	
	addu	a3, a3, 4	//move Dpnt[] to next 2 samples
	// end i
	sub		t9, t9, 1
	bgtz	t9, 3b
	nop	
	/* Scale the residual energy */	
	mfa		a0, m2h		
	li		a1, 2913
	li		t4, 0x2	//integer mpy	
	jal		L_mls	//v0 = Acc1
	mtru	t4, mmd	
	li		t4, 0x6
	mtru	t4, mmd	//fractional mpy
	move	s6, v0	//s6=Acc1
	/* Clip noise level in any cse */
	lw		t0, 4(s5)	//Penr
	lw		t1, 8(s5)	//Nlev
	lh		t5, 12(s5)	//t5=Aen
	sub		t2, t1, t0
	blez	t2, 1f
	sra		t3, t0, 2
	subr.s	v0, t0, t3
	sra		t4, t1, 2
	addr.s	t1, v0, t4	//t1=Nlev
1:
	/* Update the noise level, if adaptation is enabled */
	sra		t2, t1, 5
	sra		t3, t1, 11
	addr.s	t2, t1, t2
	subr.s	t3, t1, t3
	move	t1, t3
	cmveqz	t1, t2, t5	//t1=Nlev
	
	/*Update previous energy */
	sw		s6, 4(s5)
	
	/* Clip Noise Level */
	li		t4, 0x00000080
	li		t0, 0x0001ffff
	max		t1, t1, t4
	min		t1, t1, t0	//t1=Nlev
	sw		t1, 8(s5)
	/*Compute the threshold */	
	sll		s3, t1, 13	//s3=Acc0
	jal		norm_l
	move	a0, s3	
	move	s1, v0		//s1=Tm0	
	sll		t0, s3, v0
	li		t4, 0x3f000000
	and		t0, t0, t4
	sll		t0, t0, 1	
	sra		s2, t0, 16	//s2=Tm1
	la		a0, ScfTab	//a0=ScfTab
	sll		t2, s1, 1
	addu	t2, t2, a0
	lh		t3, 0(t2)	//t3=ScfTab[Tm0]
	lh		t4, -2(t2)	//t4=ScfTab[Tm0-1]
	sll		v0, t3, 16	//v0=Acc0
	multa2	m0l, s2, t4
	lw		t1, 8(s5)
	msuba2.s m0l, s2, t3	
	mfa		t4, m0l	
	addr.s	v0, v0, t4
	sra		s2, v0, 16	//s2=Tm1
	sra		s1, t4, 2
	multa2	m0l, s2, s1
	mfa		v0, m0l
	sra		v0, v0, 11	//v0=Acc0
	/* Compare with the threshold */
	sgt		t0, v0, s6
	cmvnez	s4, zero, t0
	/* Do the various counters */
	lh		t1, 2(s5)	//t1=Vcnt
	lh		t2, 0(s5)	//t2=Hcnt
	// if (VadState)
	beqz	s4, 1f
	nop
	add		t1, t1, 1	
	j		2f
	add		t2, t2, 1
1:		
	sub		t1, t1, 1
	slt		t0, t1, zero
	cmvnez	t1, zero, t0
	
2:	//if(Vcnt >= 2)
	sub		t0, t1, 2
	bltz	t0, 3f
	li		t3, 3
	li		t2, 6	
	min		t1, t1, t3
	
3:	//if(pVadStat->Hcnt)	
	beqz	t2, 4f
	sub		t3, t2, 1
	li		s4, 1	//VadState=1
	seq		t0, t1, zero	
	cmvnez	t2, t3, t0

4:	
	mux2.ll	t1, t2, t1
	sw		t1, 0(s5)	//store Hcnt and Vcnt back
	
	//Update Periodicy detector */
	lw		t0, 20(s5)
	nop
	sw		t0, 16(s5)
5:
	move	v0, s4		//return VadState
		
	///////////////////
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 36(sp)
	lw		s4, 40(sp)
	lw		s5, 44(sp)
	lw		s6, 48(sp)
	lw		t4, 32(sp)	//mmd
	lw		ra, 52(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	
	.end	Comp_Vads	
	
