#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define L_SUBFR	40
#define NB_POS	8
#define MSIZE	64
#define STEP	5
#define MAX_16	0x00007fff
#define MIN_16	0xffff8000

#define _1_2    16384
#define _1_4     8192
#define _1_8     4096
#define _1_16    2048

#define i0i0	(0)
#define i1i1	(NB_POS)*2
#define i2i2	(NB_POS*2)*2
#define i3i3	(NB_POS*3)*2
#define i4i4	(NB_POS*4)*2
#define i0i1	(NB_POS*5)*2
#define i0i2	(NB_POS*5+MSIZE)*2
#define i0i3	(NB_POS*5+MSIZE*2)*2
#define i0i4	(NB_POS*5+MSIZE*3)*2
#define i1i2	(NB_POS*5+MSIZE*4)*2
#define i1i3	(NB_POS*5+MSIZE*5)*2
#define i1i4	(NB_POS*5+MSIZE*6)*2
#define i2i3	(NB_POS*5+MSIZE*7)*2
#define i2i4	(NB_POS*5+MSIZE*8)*2

/*
void Cor_h(Word16 *H, Word16 *rr)
	s0->H[]		align 8
	s1->rr[]	align 4
local:
	h->g729_TmpVct[0]	//s2
	
*/
	.text
	//.section ".text.g729_Cor_hs"
	.set	noreorder
	.globl	g729_Cor_hs
	.ent	g729_Cor_hs
g729_Cor_hs:
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0//s0=H[]
	sw		s3, 40(sp)	;move	s1, a1//s1=rr[]
	sw		s4, 44(sp)
	sw		s5, 48(sp)
	sw		s6, 52(sp)
	sw		s7, 56(sp)
	/////////////////
	li		t4, 0x6	//frac mpy
	mfru	t5, mmd
	mtru	t4, mmd
	sw		t5, 24(sp)
	/* scaling h[] for maximum precision */
	multa2	m0,zero,zero
	ltp		t4, (a0)+8
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/8-1	
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	.align	3
1:
	madda2.s m0, t4, t4	;ltp	t6, (a0)+8
	madda2.s m0, t5, t5	;nop
	madda2.s m0, t6, t6	;ltp	t4, (a0)+8
	madda2.s m0, t7, t7	;nop
2:
	addma.s m0l,m0l,m0h	;li		t4, 32000
	mfa		v0, m0l		//v0=cor
	sra		t0, v0, 16
	sub		t0, t0, t4	
	.extern g729_TmpVct
	la		s2, g729_TmpVct	//s2=h->g729_TmpVct
	
	blez	t0, 3f
	move	a0, s0	//a0->H[]
	//if(cor > 32000)
	ltp		t4, (a0)+8
	li		t6, 1	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/8-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	move	a2, s2	//a2->h[]
1:
	srav2	t4, t4, t6	;ltp	t0, (a0)+8
	srav2	t5, t5, t6	;ltp	t2, (a0)+8
	stp		t4, (a2)+8	;srav2 	t0, t0, t6
	srav2	t1, t1, t6	;move	t4, t2	
	stp		t0, (a2)+8	;move	t5, t3
2:	
	j		5f
	nop	
3:	//else	
	//jal		norm_l
	//move	a0, v0
	cls		a0, v0
	cmveqz	a0, zero, v0
	move	v0, a0
	
	sra		v0, v0, 1	//v0=k
	bltz	v0, 4f
	move	a0, s0		//a0->H[]
	ltp		t4, (a0)+8	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/8-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	move	a2, s2	//a2->h[]
1:
	sllv2	t4, t4, v0	;ltp	t0, (a0)+8
	sllv2	t5, t5, v0	;ltp	t2, (a0)+8
	stp		t4, (a2)+8	;sllv2	t0, t0, v0
	sllv2	t1, t1, v0	;move	t4, t2	
	stp		t0, (a2)+8	;move	t5, t3
2:
	j		5f
	nop	
4:	//else
	ltp		t4, (a0)+8
	li		t6, 1
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/8-1
	mtru	t0, lps0
	mtru	t1, lpe0	;sub	v0, zero, v0//v0=-k
	mtru	t2, lpc0
	move	a2, s2	//a2->h[]
1:
	srav2	t4, t4, v0	;ltp	t0, (a0)+8
	srav2	t5, t5, v0	;ltp	t2, (a0)+8
	stp		t4, (a2)+8	;srav2	t0, t0, v0
	srav2	t1, t1, v0	;move	t4, t2	
	stp		t0, (a2)+8	;move	t5, t3
2:	
	
5: /*
 	(1) compute rri0i0...
	*/	
	/* Init pinters */
	/* Init pointer to last position of rrixix[] */
	addu	t0, s1, (NB_POS-1)*2	//t0=p0
	addu	t1, s1, (NB_POS*2-1)*2	//t1=p1
	addu	t2, s1, (NB_POS*3-1)*2	//t2=p2
	addu	t3, s1, (NB_POS*4-1)*2	//t3=p3
	addu	t4, s1, (NB_POS*5-1)*2	//t4=p4
	move	a0, s2		//a0->ptr_h1
	multa2	m0,zero,zero
	lhp		t8, (a0)+2	//t8=h[0]
	lhp		t9, (a0)+2	//t9=h[1]
	la		t5, 1f
	la		t6, 2f-4
	li		t7, NB_POS-1
	mtru	t5, lps0
	mtru	t6, lpe0
	mtru	t7, lpc0	
	.align	3
1:
	madda2.s m0l, t8, t8;lhp	t6, (a0)+2
	mfa		v0, m0l		;lhp	t7, (a0)+2
	sra		v0, v0, 16	;madda2.s m0l, t9, t9
	shp		v0, (t4)-2	;move	t8, t6
	mfa		v1, m0l		;move	t9, t7
	sra		v1, v1, 16	;lhp	t6, (a0)+2
	shp		v1, (t3)-2	;madda2.s m0l, t8, t8
	move	t8, t6		;lhp	t7, (a0)+2
	mfa		v0, m0l		;nop
	sra		v0, v0, 16	;madda2.s m0l, t9, t9
	shp		v0, (t2)-2	;move	t9, t7
	mfa		v1, m0l		;nop
	sra		v1, v1, 16	;lhp	t6, (a0)+2
	shp		v1, (t1)-2	;madda2.s m0l, t8, t8
	mfa		v0, m0l		;move	t8, t9
	sra		v0, v0, 16	;move	t9, t6
	shp		v0, (t0)-2	;nop
2:	
	/*
	(2) compute rri2i3 ...
	*/
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;li		s3, 0	//s3=k
	mtru	t1, lpe0	;move	s6, s2	//s6=ptr_hd	
	li		s4, (MSIZE-1)*2	//s4=l_fin_sup
	li		s5, (MSIZE-2)*2	//s5=l_fin_inf	
	addu	s7, s2, 2		//s7=ptr_hf	
	.align	3
3:	//for(k=0;k<NB_POS;k++) {
	move	a0, s6	//a0->ptr_h1	
	move	a1, s7	//a1->ptr_h2			
	lhp		t4, (a0)+2	
	addu	t3, s1, (NB_POS*5+MSIZE*7)*2
	lhp		t5, (a1)+2
	addu	t3, t3, s4	//t3=p3
	addu	t2, s1, i1i2	;li		t9, NB_POS
	addu	t2, t2, s4		;add	t8, s3, 1//t2=p2
	addu	t1, s1, i0i1	;sub	t9, t9, t8
	addu	t1, t1, s4		;sub	t9, t9, 1//t1=p1
	addu	t0, s1, i0i4	;mtru	t9, lpc0
	addu	t0, t0, s5	//t0=p0	
	lhp		t6, (a0)+2
	multa2	m0,zero,zero	
	lhp		t7, (a1)+2
	
	bltz	t9, 2f	//check if k==7, then bypass loop
	nop
	//h1 t4:[3] t6:[4] t8:[2]
	//h2 t5:[3] t7:[4] t9:[2]
	.align	3
1:	
	madda2.s m0l, t4, t5	;lhp	t8, (a0)+2
	madda2.s m0l, t6, t7	;lhp	t9, (a1)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t4, (a0)+2
	shp		v0, (t3)-((NB_POS+1)*2);madda2.s m0l, t8, t9
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t2)-((NB_POS+1)*2);nop
	madda2.s m0l, t4, t5	;lhp	t6, (a0)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t7, (a1)+2
	shp		v0, (t1)-((NB_POS+1)*2);nop
	madda2.s m0l, t6, t7	;lhp	t4, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t0)-((NB_POS+1)*2)	;nop
	lhp		t6, (a0)+2		;nop
	lhp		t7, (a1)+2		;nop
2:
	madda2.s m0l, t4, t5	;lhp	t8, (a0)+2
	madda2.s m0l, t6, t7	;lhp	t9, (a1)+2
	lhp		t4, (a0)+2
	lhp		t5, (a1)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;madda2.s m0l, t8, t9
	sh		v0, 0(t3)		;nop
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;madda2.s m0l, t4, t5
	sh		v1, 0(t2)		;subu	s4, s4, (NB_POS*2)//l_fin_sup -=NB_POS
	mfa		v0, m0l			;subu	s5, s5, 2	//l_fin_inf --
	sra		v0, v0, 16		;addu	s7, s7, (STEP*2)//ptr_hf += STEP
	sh		v0, 0(t1)		;sub	t0, s3, NB_POS-1
	// }	
	bltz	t0, 3b
	addi	s3, s3, 1
	
	/*
	(3) compute rri2i4 ...
	*/
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;li		s3, 0	//s3=k
	mtru	t1, lpe0	;move	s6, s2	//s6=ptr_hd=h
	li		s4, (MSIZE-1)*2	//s4=l_fin_sup
	li		s5, (MSIZE-2)*2	//s5=l_fin_inf	
	addu	s7, s2, 4		//s7=ptr_hf	
	.align	3
3:	//for(k=0;k<NB_POS;k++) {
	move	a0, s6	//a0->ptr_h1	
	move	a1, s7	//a1->ptr_h2			
	lhp		t4, (a0)+2	
	addu	a2, s1, i2i4
	addu	a2, a2, s4	//a2=p4
	addu	t3, s1, i1i3
	lhp		t5, (a1)+2
	addu	t3, t3, s4	//t3=p3
	addu	t2, s1, i0i2	;li		t9, NB_POS
	addu	t2, t2, s4		;add	t8, s3, 1//t2=p2
	addu	t1, s1, i1i4	;sub	t9, t9, t8
	addu	t1, t1, s5		;sub	t9, t9, 1//t1=p1
	addu	t0, s1, i0i3	;mtru	t9, lpc0
	addu	t0, t0, s5	//t0=p0	
	lhp		t6, (a0)+2
	multa2	m0,zero,zero	
	lhp		t7, (a1)+2
	
	bltz	t9, 2f	//check if k==7, then bypass loop
	nop
	//h1 t4:[3] t6:[4] t8:[2]
	//h2 t5:[3] t7:[4] t9:[2]
	.align	3
1:	
	madda2.s m0l, t4, t5	;lhp	t8, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t9, (a1)+2	
	shp		v1, (a2)-((NB_POS+1)*2);madda2.s m0l, t6, t7
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t4, (a0)+2
	shp		v0, (t3)-((NB_POS+1)*2);madda2.s m0l, t8, t9
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t2)-((NB_POS+1)*2);nop
	madda2.s m0l, t4, t5	;lhp	t6, (a0)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t7, (a1)+2
	shp		v0, (t1)-((NB_POS+1)*2);nop
	madda2.s m0l, t6, t7	;lhp	t4, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t0)-((NB_POS+1)*2)	;nop
	lhp		t6, (a0)+2		;nop
	lhp		t7, (a1)+2		;nop
2:
	madda2.s m0l, t4, t5	;lhp	t8, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t9, (a1)+2	
	sh		v1, 0(a2)		;madda2.s m0l, t6, t7
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;madda2.s m0l, t8, t9
	sh		v0, 0(t3)		;subu	s4, s4, (NB_POS*2)//l_fin_sup -=NB_POS
	mfa		v1, m0l			;subu	s5, s5, 2	//l_fin_inf --
	sra		v1, v1, 16		;addu	s7, s7, (STEP*2)//ptr_hf += STEP
	sh		v1, 0(t2)		;sub	t0, s3, NB_POS-1
	// }	
	bltz	t0, 3b
	addi	s3, s3, 1
	
	/*
	(4) compute rri1i4 ...
	*/
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;li		s3, 0	//s3=k
	mtru	t1, lpe0	;move	s6, s2	//s6=ptr_hd=h
	li		s4, (MSIZE-1)*2	//s4=l_fin_sup
	li		s5, (MSIZE-2)*2	//s5=l_fin_inf	
	addu	s7, s2, 6		//s7=ptr_hf	
	.align	3
3:	//for(k=0;k<NB_POS;k++) {
	move	a0, s6	//a0->ptr_h1	
	move	a1, s7	//a1->ptr_h2			
	lhp		t4, (a0)+2	
	addu	a2, s1, i1i4
	addu	a2, a2, s4	//a2=p4
	addu	t3, s1, i0i3
	lhp		t5, (a1)+2
	addu	t3, t3, s4	//t3=p3
	addu	t2, s1, i2i4	;li		t9, NB_POS
	addu	t2, t2, s5		;add	t8, s3, 1//t2=p2
	addu	t1, s1, i1i3	;sub	t9, t9, t8
	addu	t1, t1, s5		;sub	t9, t9, 1//t1=p1
	addu	t0, s1, i0i2	;mtru	t9, lpc0
	addu	t0, t0, s5	//t0=p0	
	lhp		t6, (a0)+2
	multa2	m0,zero,zero	
	lhp		t7, (a1)+2
	
	bltz	t9, 2f	//check if k==7, then bypass loop
	nop
	//h1 t4:[3] t6:[4] t8:[2]
	//h2 t5:[3] t7:[4] t9:[2]
	.align	3
1:	
	madda2.s m0l, t4, t5	;lhp	t8, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t9, (a1)+2	
	shp		v1, (a2)-((NB_POS+1)*2);madda2.s m0l, t6, t7
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t4, (a0)+2
	shp		v0, (t3)-((NB_POS+1)*2);madda2.s m0l, t8, t9
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t2)-((NB_POS+1)*2);nop
	madda2.s m0l, t4, t5	;lhp	t6, (a0)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t7, (a1)+2
	shp		v0, (t1)-((NB_POS+1)*2);nop
	madda2.s m0l, t6, t7	;lhp	t4, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t0)-((NB_POS+1)*2)	;nop
	lhp		t6, (a0)+2		;nop
	lhp		t7, (a1)+2		;nop
2:
	madda2.s m0l, t4, t5	;subu	s4, s4, (NB_POS*2)//l_fin_sup -=NB_POS
	mfa		v1, m0l			;subu	s5, s5, 2	//l_fin_inf --
	sra		v1, v1, 16		;madda2.s m0l, t6, t7
	sh		v1, 0(a2)		;addu	s7, s7, (STEP*2)//ptr_hf += STEP
	mfa		v0, m0l			;sub	t0, s3, NB_POS-1
	sra		v0, v0, 16		
	sh		v0, 0(t3)		
	// }	
	bltz	t0, 3b
	addi	s3, s3, 1
	
	/*
	(5) compute rri0i4 ...
	*/
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;li		s3, 0	//s3=k
	mtru	t1, lpe0	;move	s6, s2	//s6=ptr_hd	
	li		s4, (MSIZE-1)*2	//s4=l_fin_sup
	li		s5, (MSIZE-2)*2	//s5=l_fin_inf	
	addu	s7, s2, 8		//s7=ptr_hf	
	.align	3
3:	//for(k=0;k<NB_POS;k++) {
	move	a0, s6	//a0->ptr_h1	
	move	a1, s7	//a1->ptr_h2			
	lhp		t4, (a0)+2	
	addu	t3, s1, i0i4
	lhp		t5, (a1)+2
	addu	t3, t3, s4	//t3=p3
	addu	t2, s1, i2i3	;li		t9, NB_POS
	addu	t2, t2, s5		;add	t8, s3, 1//t2=p2
	addu	t1, s1, i1i2	;sub	t9, t9, t8
	addu	t1, t1, s5		;sub	t9, t9, 1//t1=p1
	addu	t0, s1, i0i1	;mtru	t9, lpc0
	addu	t0, t0, s5	//t0=p0	
	lhp		t6, (a0)+2
	multa2	m0,zero,zero	
	lhp		t7, (a1)+2
	
	bltz	t9, 2f	//check if k==7, then bypass loop
	nop
	//h1 t4:[3] t6:[4] t8:[2]
	//h2 t5:[3] t7:[4] t9:[2]
	.align	3
1:	
	madda2.s m0l, t4, t5	;lhp	t8, (a0)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t9, (a1)+2
	shp		v0, (t3)-((NB_POS+1)*2);madda2.s m0l, t6, t7		
	madda2.s m0l, t8, t9	;lhp	t4, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t2)-((NB_POS+1)*2);nop
	madda2.s m0l, t4, t5	;lhp	t6, (a0)+2
	mfa		v0, m0l			;nop
	sra		v0, v0, 16		;lhp	t7, (a1)+2
	shp		v0, (t1)-((NB_POS+1)*2);nop
	madda2.s m0l, t6, t7	;lhp	t4, (a0)+2
	mfa		v1, m0l			;nop
	sra		v1, v1, 16		;lhp	t5, (a1)+2
	shp		v1, (t0)-((NB_POS+1)*2)	;nop
	lhp		t6, (a0)+2		;nop
	lhp		t7, (a1)+2		;nop
2:
	madda2.s m0l, t4, t5	;subu	s4, s4, (NB_POS*2)//l_fin_sup -=NB_POS
	mfa		v0, m0l			;subu	s5, s5, 2	//l_fin_inf --
	sra		v0, v0, 16		;addu	s7, s7, (STEP*2)//ptr_hf += STEP
	sh		v0, 0(t3)		;sub	t0, s3, NB_POS-1	
	// }	
	bltz	t0, 3b
	addi	s3, s3, 1
	
	
	/////////////////
	lw		ra, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128
	.set	reorder
	.end	g729_Cor_hs

/*
Word16 D4i40_17_fast(
	Word16 dn[], 	align 4
	Word16 rr[], 	align 4
	Word16 h[],  	align 8
	Word16 cod[], 	align 4
	Word16 y[],		align 4
	Word16 *sign
local:
	sign_dn[]->g729_TmpVct[0]
	sign_dn_inv[]->g729_TmpVct[40]
	psk,alpk->g729_TmpVct[80]
	ip0~3->g729_TmpVct[84~87]
	tmp_vect->g729_TmpVct[88~]
	i1_offset->g729_TmpVct[100]
	h[]->60(sp)
	cod[]->64(sp)
	y[]->68(sp)
	sign->72(sp)
	76(sp)->backup of s0
	80(sp)->backup of s1
	84(sp)->backup of t9
	88(sp)->backup of s4
*/
	.text
	//.section ".text.D4i40_17_fasts"
	.set	noreorder
	.globl	D4i40_17_fasts
	.ent	D4i40_17_fasts
D4i40_17_fasts:
	lw		t0, 16(sp)	//for GNU, load y[] from stack
	lw		t1, 20(sp)	//for GNU, load *sign from stack
	nop
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0//s0->dn[]
	sw		s3, 40(sp)	;move	s1, a1//s1->rr[]
	sw		s4, 44(sp)	
	sw		s5, 48(sp)	
	sw		s6, 52(sp)	
	sw		s7, 56(sp)
	sw		a2, 60(sp)	//push h[] to stack
	sw		a3, 64(sp)	//push cod[] to stack
	sw		t0, 68(sp)	//push y[] to stack
	sw		t1, 72(sp)	//push sign to stack
	////////////////
	/* chose the sign of the impulse */
	.extern	g729_TmpVct
	la		s2, g729_TmpVct	//s2->g729_TmpVct[0]
	move	t7, s2		//t7->sign_dn[]
	addu	t8, s2, 40*2//t8->sign_dn_inv[]
	la		t4, 1f
	la		t5,2f-4
	lh		t0, 0(a0)	//t0=dn[]
	li		t6, L_SUBFR-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0	
	.align	3
1:
	slt		t9, t0, zero;subr.s	t1, zero, t0//t1=-dn[0]
	li		t2, MAX_16	;li		t4, MIN_16	//t2=sign_dn[]
	li		t3, MIN_16	;lh		t6, 2(a0)//t3=sign_dn_inv[]	
	cmvnez	t0, t1, t9	;li		t5, MAX_16
	cmvnez	t2, t4, t9	;shp	t0, (a0)+2
	cmvnez	t3, t5, t9	;shp	t2, (t7)+2
	shp		t3, (t8)+2	;move	t0, t6	
2:
	sw		s0, 76(sp)	;nop//backup s0

	/*
	modification of rrixiy[] to take signs into account 
	*/
	// (1)
	addu	a0, s1, i0i1;addu	a1, s1, i0i2//a0=p0
	addu	a2, s1, i0i3;addu	a3, s1, i0i4//a2=p2
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0	;li		t9, 0	//t9=i0
	mtru	t5, lpe0	;move	t7, s2	//t7=sign_dn[]	
3:	
	lhp		v0, (t7)+(STEP*2)	;move	t8, s2
	li		t4, L_SUBFR/(STEP*2)-1	;addu	t5, s2, 40*2
	slt		t6, v0, zero		;mtru	t4, lpc0
	cmvnez	t8, t5, t6			//t8=psign	
	// psign: t4:[10 11] t5:[12 13] t6:[10 11]
	// s3:p0[3 2], s4:p1[2 3], s5:p2[1 0],s6:p3[0 1]	
	lwp		s3, (a0)+4	
	lwp		t4, (t8)+4
	lwp		s4, (a1)+4	
	lwp		t5, (t8)+4	;mux2.lh	s3, s3, s3
	.align	3
1:	
	multa2	m0l, t4, s3	;lwp	s5, (a2)+4//p0*s[1]
	multa2	m1h, t5, s4	;lwp	s6, (a3)+4//p1*s[2]
	lwp		t6, (t8)+4	;mux2.lh s5, s5, s5
	multa2	m1l, t5, s5	;mfa	t0, m0l	//p2*s[3]
	multa2	m2h, t6, s6	;mfa	t1, m1h	//p3*s[4]
	sra		t0, t0, 15	;lwp	t4, (t8)+4
	sra		t1, t1, 15	;lwp	t5, (t8)+4
	mfa		t2, m1l		;multa2	m0h, t4, s3//s[6]*p0
	mfa		t3, m2h		;sra	t2, t2, 15
	multa2	m1l, t4, s4	;lwp	t6, (t8)+4//s[7]*p1
	sra		t3, t3, 15	;lwp	s3, (a0)+4
	multa2	m1h, t5, s5	;lwp	s4, (a1)+4//s[8]*p2
	move	t4, t6		;multa2	m2l, t5, s6//s[9]*p3
	mfa		v0, m0h		;mux2.lh s3, s3, s3
	lwp		t5, (t8)+4	;nop
	mfa		v1, m1l		;sra	v0, v0, 15
	mfa		s7, m1h		;sra	v1, v1, 15
	mfa		s0, m2l		;sra	s7, s7, 15
	mux2.ll t0, t0, v0	;sra	s0, s0, 15
	mux2.ll	t1, t1, v1	;sw		t0, -8(a0)
	mux2.ll	t2, t2, s7	;sw		t1, -8(a1)
	mux2.ll	t3, t3, s0	;sw		t2, -4(a2)
	nop					;sw		t3, -4(a3)	
2:	
	subu	a0, a0, 4	;subu	a1, a1, 4		
	sub		t4, t9, L_SUBFR-5
	bltz	t4, 3b
	addu	t9, t9, STEP
	
	// (2)
	addu	a0, s1, i1i2;addu	a1, s1, i1i3//a0=p0
	addu	a2, s1, i1i4					//a2=p2
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0	;li		t9, 1	//t9=i1
	mtru	t5, lpe0	;addu	t7, s2, 2//t7=sign_dn[1]	
3:	
	lhp		v0, (t7)+(STEP*2)	;move	t8, s2//t8->sign_dn[]
	li		t4, L_SUBFR/(STEP*2)-1	;addu	t5, s2, 40*2
	slt		t6, v0, zero		;mtru	t4, lpc0
	cmvnez	t8, t5, t6			//t8=psign		
	// psign: t4:[6 7] t5:[8 9] t6:[10 11]
	// s3:p0[0 1], s4:p1[0 1], s5:p2[0 1]
	// t3:p1[1 0]
	lwp		s3, (a0)+4	
	addu	t8, t8, 4	//t8->psign[2]
	lwp		s4, (a1)+4		
	lwp		t4, (t8)+4	
	lwp		t5, (t8)+4	
	.align	3
1:	
	multa2	m0h, t4, s3	;mux2.lh t3, s4, s4//p0*s[2]
	multa2	m0l, t4, t3	;lwp	s5, (a2)+4//p1*s[3]
	lwp		t6, (t8)+4	;nop
	multa2	m1h, t5, s5	;mfa	t0, m0h	//p2*s[4]
	sra		t0, t0, 15	;mfa	t1, m0l	
	move	t4, t6		;lwp	t5, (t8)+4
	sra		t1, t1, 15	;lwp	t6, (t8)+4
	mfa		t2, m1h		;nop
	multa2	m0l, t4, s3	;sra	t2, t2, 15//s[7]*p0
	multa2	m1h, t5, t3	;lwp	t4, (t8)+4//s[8]*p1
	multa2	m1l, t5, s5	;lwp	s3, (a0)+4//s[9]*p2
	mfa		v0, m0l		
	lwp		s4, (a1)+4	
	mfa		v1, m1h		;sra	v0, v0, 15
	mfa		s7, m1l		;sra	v1, v1, 15
	mux2.ll t0, t0, v0	;sra	s7, s7, 15
	mux2.ll	t1, t1, v1	;lwp	t5, (t8)+4	
	mux2.ll	t2, t2, s7	;sw		t0, -8(a0)
	sw		t1, -8(a1)
	sw		t2, -4(a2)	
2:	
	subu	a0, a0, 4	;subu	a1, a1, 4		
	sub		t4, t9, L_SUBFR-4
	bltz	t4, 3b
	addu	t9, t9, STEP
	// (3)
	addu	a0, s1, i2i3;addu	a1, s1, i2i4//a0=p0,a1=p1
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0	;li		t9, 2	//t9=i2
	mtru	t5, lpe0	;addu	t7, s2, 4//t7=sign_dn[2]	
3:	
	lhp		v0, (t7)+(STEP*2)	;move	t8, s2//t8->sign_dn[]
	li		t4, L_SUBFR/(STEP*2)-1	;addu	t5, s2, 40*2
	slt		t6, v0, zero		;mtru	t4, lpc0
	cmvnez	t8, t5, t6			//t8=psign		
	// psign: t4:[8 9] t5:[10 11] t6:[12 13]
	// s3:p0[0 1], s4:p1[0 1], s5:p2[]
	// t3:p0[1 0]
	lwp		s3, (a0)+4	
	addu	t8, t8, 4	//t8->psign[2]
	lwp		s4, (a1)+4		
	lwp		t4, (t8)+4	
	lwp		t5, (t8)+4	;mux2.lh t3, s3, s3
	.align	3
1:
	multa2	m0l, t4, t3	;lwp	t6, (t8)+4//p0*s[3]
	multa2	m0h, t5, s4	;lwp	t4, (t8)+4//p1*s[4]		
	mfa		t0, m0l		;nop
	mfa		t1, m0h		;sra	t0, t0, 15
	multa2	m1h, t4, t3	;lwp	t5, (t8)+4//p0*s[8]	
	sra		t1, t1, 15	;lwp	t6, (t8)+4	
	multa2	m1l, t4, s4	;lwp	s3, (a0)+4//p1*s[9]
	move	t4, t6		;lwp	s4, (a1)+4
	lwp		t5, (t8)+4	;mux2.lh t3, s3, s3
	mfa		v0, m1h		;nop
	mfa		v1, m1l		;sra	v0, v0, 15
	mux2.ll t0, t0, v0	;sra	v1, v1, 15	
	mux2.ll	t1, t1, v1	;sw		t0, -8(a0)
	sw		t1, -8(a1)	;nop
2:	
	subu	a0, a0, 4	;subu	a1, a1, 4		
	sub		t4, t9, L_SUBFR-3
	bltz	t4, 3b
	addu	t9, t9, STEP
	
	lw		s0, 76(sp)		//s0=dn[]
 /*-------------------------------------------------------------------*
  * Search the optimum positions of the four pulses which maximize    *
  *     square(correlation) / energy                                  *
  *-------------------------------------------------------------------*/
	li		t4, 0xffff0001	//t4=[-1 1] in 16 bits
	sw		t4, (160)(s2)	//g729_TmpVct[80,81]=psk, alpk
	// ptr_rri0i3_i4=rri0i3=s1+i0i3
	// ptr_rri1i3_i4=rri1i3=s1+i1i3
	// ptr_rri2i3_i4=rri2i3=s1+i2i3
	// ptr_rri3i3_i4=rri3i3=s1+i3i3
	li		t0, 0x00000001
	li		t1, 0x00020003
	st		t0, (168)(s2)	//g729_TmpVct[84~87]=ip0,ip1,ip2,ip3
	li		s3, 0			//s3=[ix iy]
	li		s4, 0			//s4=[x ps]
	/* search 2 times: track 3 and 4 */
	li		t9, 3			//t9 = track
9:	// for(track=3; track<5; track++) {
	/*--------------------------------------------
	 *depth first search 3, phase A: track 2 and 3/4.
	 *--------------------------------------------*/
	li		t8, 0xffff0001	//t8=[sq alp]
	/* i0 loop: 2 positions in track 2 */
	li		t7, -1			//t7=prev_i0
	li		v1, 2			//v1=i	
3:	// for i=0 i<2; i++)
	li		v0, -1			//v0=max
	addu	a0, s0, 4		//a0->dn[2]
	li		a1, 2			//a1->j
	/* search "dn[]" maximum position in track 2 */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/STEP-1
	lhp		t4, (a0)+(2*STEP)//t4=dn[j]
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align	3
1:	
	sgt		t0, t4, v0	;sne	t1, t7, a1
	and		t0, t0, t1	;lhp	t5, (a0)+(2*STEP)
	cmvnez	v0, t4, t0	;cmvnez	s5, a1, t0	//s5=i0	
	addi	a1, a1, STEP;move	t4, t5
2:	
	move	t7, s5		;li		t0, 6554
	multa2	m0l, s5, t0	;addu	t2, s0, s5
	addu	t2, t2, s5	;mfa	t1, m0l		//t2->dn[i0]
	lh		t6, 0(t2)	;sra	t1, t1, 15	//t1=j,t6=ps1	
	addu	t0, s1, i2i2;li		t3, _1_4
	addu	t0, t0, t1
	addu	t0, t0, t1	//t0=p0
	lh		t0, 0(t0)	//t0=*p0
	sll		t1, t1, 3+1	//t1=j<<(3+1)
	multa2	m0l, t0, t3
	addma.s m0l,m0l,m0l
	mfa		t5, m0l		//t5=alp1
	/* i1 loop: 8 positions in track 2 */
	addu	a2, s1, i2i3				//a2=p0
	addu	t0, s1, i2i4;sub	t2, t9, 4
	cmveqz	a2, t0, t2	;addu	a3, s1, i3i3//a3=p1
	addu	t0, s1, i4i4;addu	a2, a2, t1
	cmveqz	a3, t0, t2//if track==4, ptr_i3i3_i4=rri4i4
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/STEP-1
	mtru	t0, lps0	;move	s6, t9	//s6=i1
	mtru	t1, lpe0	;addu	a0, s0, t9
	mtru	t2, lpc0	;addu	a0, a0, t9	//a0->dn[i1]
	.align	3
1:
	lhp		t0, (a0)+(2*STEP);li	t1, _1_2//t0=dn[i1]
	lhp		t2, (a2)+2	;li		t3, _1_4	//t2=*p0
	addr.s	v0, t6, t0	;lhp	t4, (a3)+2	//v0=ps2 t4=*p1
	//multa2	m0l, t2, t1	;li		t0, 0x00008000
	 sll		t1, t2, (14+1);li	t0, 0x00008000//t1=*p0 * _1_2
	//multa2	m1l, t4, t3	;addma.s m0l,m0l,m0l
	 sll		t3, t4, (13+1)
	/*addma.s m1l,m1l,m1l	;*/multa2	m2l, v0, v0
	//addma.s m0l,m0l,m1l	;mfa	t2, m2l	
	 addr.s	t1, t1, t3	;mfa	t2, m2l
	nop;/*mfa		t1, m0l		;*/sra	t2, t2, 15//t2=sq2
	multa2	m0l, t8, t2	;addr.s t1, t1, t5//t1=alp2
	addma.s m0l,m0l,m0l	;addr.s t1, t1, t0
	multa2 	m0h, t8, t1	;sra	t3, t1, 16//t3=alp_16						
	addma.s m0h,m0h,m0h	;mux2.ll t2, t2, t3//t2=[sq2 alp_16]
	subma.s m0l,m0l,m0h	;mux2.ll t4, s5, s6//t4=[i0 i1]
	mfa		t0, m0l
	sgt		t0, t0, zero
	cmvnez	t8, t2, t0	;cmvnez	s3, t4, t0
	cmvnez	s4, v0, t0	;addi	s6, s6, STEP
2:	
	// } end i
	sub		v1, v1, 1
	bgtz	v1, 3b
	nop	
   /*------------------------------------------------------------------*
    * depth first search 3, phase B: track 0 and 1.                    *
    *------------------------------------------------------------------*/
	move	s5, s3					//s5=[i0 i1]
	move	t6, s4		;li	t4, _1_4//t6=ps0
	multa2	m0l,t8,t4	;li	t5, 0x199a199a	//6554,6554		
	addma.s m0l,m0l,m0l	;li	t8, 0xffff0001	//t8=[sq alp]	
	/* build vector for next loop to decrease complexity */
	multa2	m1, s5, t5	;addu	a0, s1, i1i2	
	addu	a1, s1, i1i3;mfa	t7, m0l	//t7=alp0
	addu	t0, s1, i1i4;sub	t1, t9, 4
	cmveqz	a1, t0, t1	;nop//if track==4, ptr_i1i3_i4=rri1i4
	addu	a2, s1, i1i1;addu	a3, s2, 88*2//a2=p2 a3=p3
	mfa		v0, m1h		;li		s6, 0x00008000
	mfa		v1, m1l		;sra	v0, v0, 15
	sra		v1, v1, 15	;sll	v0, v0, 1	//v0=mult(i0,6554)*2
	sll		v1, v1, 1	;addu	a0, a0, v0	//a0=p0 v1=mult(i1,6554)*2
	addu	a1, a1, v1	//;li		t5, (_1_8*32768+_1_8)//a1=p1
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/(STEP*2)-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	lhp		t0, (a0)+(NB_POS*2)//t4=_1_4
	lhp		t1, (a1)+(NB_POS*2)//t5=_1_8
	.align	3
	//t2:[p20 p21]
1:
	sll		t4,t0,(13+1);lhp	t2, (a2)+2
	sll		t5,t1,(13+1);lhp	t0, (a0)+(NB_POS*2)
	addr.s 	t4, t4, t5	;lhp	t1, (a1)+(NB_POS*2)
	sll		t3, t2, 12+1;li		t5, 0x00008000
	addr.s	t4, t4, t3	;lhp	t2, (a2)+2
	addr.s	t4, t4, t5	;sll	t0, t0, (13+1)
	sll		t1,t1,(13+1);sll	t2, t2, (12+1)
	addr.s	t3, t0, t1	;addr.s	t2, t2, t5
	addr.s	t3, t3, t2	;lhp	t0, (a0)+(NB_POS*2)
	mux2.hh	t4, t4, t3	;lhp	t1, (a1)+(NB_POS*2)	
	swp		t4, (a3)+4	;nop
/*	lwp		t2, (a2)+4	;multa2	m0l, t0, t4
	madda2.s m0l, t1, t4;lhp	t0, (a0)+(NB_POS*2)
	multa2.s m0h, t2, t5;lhp	t1, (a1)+(NB_POS*2)
	addma.s m0l,m0l,m0h	;multa2	m1l, t0, t4
	addma.s m0l,m0l,m0l	;madda2.s m1l, t1, t4
	mfa		t3, m0l		;madda2.s m1l, t2, t5
	addr.s	t3, t3, s6	;mfa	s7, m1l
	addr.s	s7, s7, s6	;lhp	t0, (a0)+(NB_POS*2)
	mux2.ll	t3, t3, s7	;lhp	t1, (a1)+(NB_POS*2)
	swp		t3, (a3)+4	;nop
*/	
2:	
	/* i2 loop: 8 positions in track 0 */
	addu	a0, s1, i0i2;addu	a1, s1, i0i3
	addu	t0, s1, i0i4;sub	t1, t9, 4
	cmveqz	a1, t0, t1	;nop//if track==4, ptr_i0i3_i4=rri0i4	
	addu	a0, a0, v0	;addu	a1, a1, v1	//a0=p0 a1=p1
	addu	a2, s1, i0i0;addu	a3, s1, i0i1//a2=p2 a3=p3
	li		t5, 0		;addu	s6, s0, 0//t5=i2 s6=dn[i2]
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	sw		s1, 80(sp)	//backup s1
	sw		t9, 84(sp)	//backup t9
	sw		s4, 88(sp)	//backup s4
	.align	3
	
3:	//for(i2=0; i2<L_SUBFR; i2+=STEP) {
	lhp		t0, (s6)+(STEP*2)
	lhp		t1, (a0)+(NB_POS*2)
	lhp		t2, (a1)+(NB_POS*2);addr.s	t9, t0, t6//t9=ps1
	lhp		t3, (a2)+2		;sll		t1, t1, (12+1)	
	sll		t2, t2, (12+1)	;addr.s		s7, t7, t1
	sll		t3, t3, (11+1)	;addr.s		s7, s7, t2
	addr.s	s7, s7, t3	//s7=alp1
	/* i3 loop: 8 positions in track 1 */
	li		t2, (L_SUBFR/STEP-1)
	lhp		t1, (a3)+2		;addu	v0, s0, 2//v0=dn[i3]	
	lhp		t0, (v0)+(STEP*2);li	v1, 1//v1=i3 	
	addu	t4, s2, 88*2	;mtru	t2, lpc0//t4=p4	
	.align	3
1:		
	lhp		t2, (t4)+2	;addr.s	s4, t9, t0//s4=ps2
	sll		t1, t1, (12+1);multa2	m0l, s4, s4
	addr.s	t1, t1, s7	;sll	t2, t2, (14+1)
	addr.s	t1, t1, t2	;li		t0, 0x00008000//t1=alp2
	addr.s	t1, t1, t0	;mfa	t2, m0l//t1=[alp_16 x]
	multa2	m0h, t8, t1	;sra	t2, t2, 15//t2=sq2
	multa2	m0l, t8, t2	;mux2.lh s1, t2, t1//s1=[sq2 alp_16]
	subma.s m0l, m0l, m0h;lhp	t0, (v0)+(STEP*2)
	addma.s m0l,m0l,m0l	;lhp	t1, (a3)+2
	mfa		t3, m0l		;mux2.ll t2, t5, v1//t0=s t2=[i2 i3]
	sgt		t3, t3, zero;addi	v1, v1, STEP
	cmvnez	t8, s1, t3	;cmvnez	s3, t2, t3
2:
	subu	a3, a3, 2
	// } end i2
	sub		t4, t5, L_SUBFR-5
	bltz	t4, 3b
	addu	t5, t5, STEP
	
	lw		s1, 80(sp)	//load s1
	lw		t9, 84(sp)	//load t9
	lw		s4, 88(sp)	//load s4
	
   /*----------------------------------------------------------------*
    * depth first search 3: compare codevector with the best case.   *
    *----------------------------------------------------------------*/
	lw		t0, 160(s2)	//t0=[psk alpk]
	mux2.lh	t1, t8, t8	//t1=[alp sq]
	lw		t2, 168(s2)	//t2=[ip0 ip1]	
	multa2	m0, t0, t1
	lw		t3, 172(s2)	//t3=[ip2 ip3]
	subma.s m0l, m0l, m0h
	addma.s m0l,m0l,m0l
	mfa		t1, m0l
	sgt		t1, t1, zero
	cmvnez	t0, t8, t1	
	cmvnez	t2, s3, t1	;sw		t0, 160(s2)
	cmvnez	t3, s5, t1	;nop
	st		t2, 168(s2)
	
   /*------------------------------------------------------------------*
    * depth first search 4, phase A: track 3 and 0.                    *
    *------------------------------------------------------------------*/
	li		t8, 0xffff0001	//t8=[sq alp]
	/* i0 loop: 2 positions in track 3/4 */
	li		t7, -1			//t7=prev_i0
	li		v1, 2			//v1=i	
3:	// for i=0 i<2; i++)
	li		v0, -1			//v0=max
	sll		t0, t9, 1
	addu	a0, s0, t0		//a0->dn[track]
	move	a1, t9			//a1->j
	/* search "dn[]" maximum position in track 3/4 */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/STEP-1
	lhp		t4, (a0)+(2*STEP)//t4=dn[j]
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align	3
1:	
	sgt		t0, t4, v0	;sne	t1, t7, a1
	and		t0, t0, t1	;lhp	t5, (a0)+(2*STEP)
	cmvnez	v0, t4, t0	;cmvnez	s5, a1, t0	//s5=i0	
	addi	a1, a1, STEP;move	t4, t5
2:	
	move	t7, s5		;li		t0, 6554	//prev_i0=i0
	multa2	m0l, s5, t0	;addu	t2, s0, s5
	addu	t2, t2, s5	;mfa	t1, m0l		//t2->dn[i0]
	lh		t6, 0(t2)	;sra	t1, t1, 15	//t1=j,t6=ps1	
	addu	t0, s1, i3i3;li		t3, _1_4	
	addu	v0, s1, i4i4;sub	t4, t9, 4
	cmveqz	t0, v0, t4//if track==4,ptr_i3i3_i4=rri4i4
	addu	t0, t0, t1
	addu	t0, t0, t1	//t0=p0
	lh		t0, 0(t0)	//t0=*p0
	sll		t1, t1, 1	//t1=j<<1
	multa2	m0l, t0, t3		//L_mult(*p0, _1_4)
	addma.s m0l,m0l,m0l
	mfa		t5, m0l		//t5=alp1
	/* i1 loop: 8 positions in track 0 */
	addu	a2, s1, i0i3				//a2=p0
	addu	t0, s1, i0i4;sub	t2, t9, 4
	cmveqz	a2, t0, t2	;nop//if track==4,ptr_rri0i3_i4=rri0i4	
	addu	a3, s1, i0i0;addu	a2, a2, t1//a3=p1
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/STEP-1
	mtru	t0, lps0	;li		s6, 0	//s6=i1
	mtru	t1, lpe0	;addu	a0, s0, 0//a0->dn[i1]
	mtru	t2, lpc0
	.align	3
1:
	lhp		t0, (a0)+(2*STEP);li	t1, _1_2//t0=dn[i1]
	lhp		t2, (a2)+(NB_POS*2)	;li		t3, _1_4	//t2=*p0
	addr.s	v0, t6, t0	;lhp	t4, (a3)+2	//v0=ps2 t4=*p1
	//multa2	m0l, t2, t1	;li		t0, 0x00008000
	 sll		t1, t2, (14+1);li	t0, 0x00008000//t1=*p0 * _1_2
	//multa2	m1l, t4, t3	;addma.s m0l,m0l,m0l
	 sll		t3, t4, (13+1)
	/*addma.s m1l,m1l,m1l	;*/multa2	m2l, v0, v0
	//addma.s m0l,m0l,m1l	;mfa	t2, m2l	
	 addr.s	t1, t1, t3	;mfa	t2, m2l
	nop;/*mfa		t1, m0l		;*/sra	t2, t2, 15//t2=sq2
	multa2	m0l, t8, t2	;addr.s t1, t1, t5//t1=alp2
	addma.s m0l,m0l,m0l	;addr.s t1, t1, t0
	multa2 	m0h, t8, t1	;sra	t3, t1, 16//t3=alp_16						
	addma.s m0h,m0h,m0h	;mux2.ll t2, t2, t3//t2=[sq2 alp_16]
	subma.s m0l,m0l,m0h	;mux2.ll t4, s5, s6//t4=[i0 i1]
	mfa		t0, m0l
	sgt		t0, t0, zero
	cmvnez	t8, t2, t0	;cmvnez	s3, t4, t0
	cmvnez	s4, v0, t0	;addi	s6, s6, STEP//s4=ps
2:	
	// } end i
	sub		v1, v1, 1
	bgtz	v1, 3b
	nop		
	/*------------------------------------------------------------------*
    * depth first search 4, phase B: track 1 and 2.                    *
    *------------------------------------------------------------------*/
    .align	3
	move	s5, s3		;li	t5, 6554//s5=[i0 i1]
	multa2	m0l, s5, t5	//i1*6554
	mfa		v1, m0l
	sra		v1, v1, 12	//v1=i1_offset
	sh		v1, 200(s2)	//i1_offset	
	move	t6, s4		;li	t4, _1_4//t6=ps0
	multa2	m0l,t8,t4	;li	t5, 0x199a199a	//6554,6554		
	addma.s m0l,m0l,m0l	;li	t8, 0xffff0001	//t8=[sq alp]	
	/* build vector for next loop to decrease complexity */
	multa2	m1, s5, t5	;addu	a0, s1, i2i3
	addu	t1, s1, i2i4;sub	t0, t9, 4
	cmveqz	a0, t1, t0	;nop//if track==4, ptr_rri2i3_i4=rri2i4	
	addu	a1, s1, i0i2;addu	a2, s1, i2i2//a2=p2
	addu	a3, s2, 88*2;sll	v1, v1, 1// a3=p3,v1=i1_offset*2
	mfa		t7, m0l		;addu	a1, a1, v1//t7=alp0
	mfa		v0, m1h		;li		s6, 0x00008000
	/*mfa		v1, m1l		;*/sra	v0, v0, 15
	/*sra		v1, v1, 15	;*/sll	v0, v0, 1	//v0=mult(i0,6554)*2
	/*sll		v1, v1, 1	;*/addu	a0, a0, v0	//a0=p0 v1=mult(i1,6554)*2
	//addu	a1, a1, v1	//;li		t5, (_1_8*32768+_1_8)//a1=p1
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/(STEP*2)-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	lhp		t0, (a0)+(NB_POS*2)
	lhp		t1, (a1)+2
	.align	3
	//t2:[p20 p21]
1:
	sll		t4,t0,(13+1);lhp	t2, (a2)+2
	sll		t5,t1,(13+1);lhp	t0, (a0)+(NB_POS*2)
	addr.s 	t4, t4, t5	;lhp	t1, (a1)+2
	sll		t3, t2, 12+1;li		t5, 0x00008000
	addr.s	t4, t4, t3	;lhp	t2, (a2)+2
	addr.s	t4, t4, t5	;sll	t0, t0, (13+1)
	sll		t1,t1,(13+1);sll	t2, t2, (12+1)
	addr.s	t3, t0, t1	;addr.s	t2, t2, t5
	addr.s	t3, t3, t2	;lhp	t0, (a0)+(NB_POS*2)
	mux2.hh	t4, t4, t3	;lhp	t1, (a1)+2
	swp		t4, (a3)+4	;nop
/*	lwp		t2, (a2)+4	;multa2	m0l, t0, t4
	madda2.s m0l, t1, t4;lhp	t0, (a0)+(NB_POS*2)
	multa2.s m0h, t2, t5;lhp	t1, (a1)+(NB_POS*2)
	addma.s m0l,m0l,m0h	;multa2	m1l, t0, t4
	addma.s m0l,m0l,m0l	;madda2.s m1l, t1, t4
	mfa		t3, m0l		;madda2.s m1l, t2, t5
	addr.s	t3, t3, s6	;mfa	s7, m1l
	addr.s	s7, s7, s6	;lhp	t0, (a0)+(NB_POS*2)
	mux2.ll	t3, t3, s7	;lhp	t1, (a1)+(NB_POS*2)
	swp		t3, (a3)+4	;nop
*/	
2:	
	/* i2 loop: 8 positions in track 1 */
	sub		t0, t9, 4	;addu	a0, s1, i1i3	
	addu	t1, s1, i1i4;addu	a1, s1, i0i1
	cmveqz	a0, t1, t0	;nop//if track==4, ptr_rri1i3_i4=rri0i4	
	
	addu	a0, a0, v0	;addu	a1, a1, v1	//a0=p0 a1=p1
	addu	a2, s1, i1i1;addu	a3, s1, i1i2//a2=p2 a3=p3
	li		t5, 1		;addu	s6, s0, 2//t5=i2 s6=dn[i2]
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	
	sw		s1, 80(sp)	//backup s1
	sw		t9, 84(sp)	//backup t9
	sw		s4, 88(sp)	//backup s4
	.align	3
	
3:	//for(i2=0; i2<L_SUBFR; i2+=STEP) {
	lhp		t0, (s6)+(STEP*2)
	lhp		t1, (a0)+(NB_POS*2)
	lhp		t2, (a1)+2		;addr.s	t9, t0, t6//t9=ps1
	lhp		t3, (a2)+2		;sll	t1, t1, (12+1)	
	sll		t2, t2, (12+1)	;addr.s	s7, t7, t1
	sll		t3, t3, (11+1)	;addr.s	s7, s7, t2
	addr.s	s7, s7, t3	//s7=alp1
	/* i3 loop: 8 positions in track 1 */
	li		t2, (L_SUBFR/STEP-1)
	lhp		t1, (a3)+2		;addu	v0, s0, 4//v0=dn[i3]	
	lhp		t0, (v0)+(STEP*2);li	v1, 2//v1=i3 	
	addu	t4, s2, 88*2	;mtru	t2, lpc0//t4=p4	
	.align	3
1:		
	lhp		t2, (t4)+2	;addr.s	s4, t9, t0//s4=ps2
	sll		t1, t1, (12+1);multa2	m0l, s4, s4
	addr.s	t1, t1, s7	;sll	t2, t2, (14+1)
	addr.s	t1, t1, t2	;li		t0, 0x00008000//t1=alp2
	addr.s	t1, t1, t0	;mfa	t2, m0l//t1=[alp_16 x]
	multa2	m0h, t8, t1	;sra	t2, t2, 15//t2=sq2
	multa2	m0l, t8, t2	;mux2.lh s1, t2, t1//t1=[sq2 alp_16]
	subma.s m0l, m0l, m0h;lhp	t0, (v0)+(STEP*2)
	addma.s m0l,m0l,m0l	;lhp	t1, (a3)+2
	mfa		t3, m0l		;mux2.ll t2, t5, v1//t0=s t2=[i2 i3]
	sgt		t3, t3, zero;addi	v1, v1, STEP
	cmvnez	t8, s1, t3	;cmvnez	s3, t2, t3
2:
	subu	a3, a3, 2
	// } end i2
	sub		t4, t5, L_SUBFR-5
	bltz	t4, 3b
	addu	t5, t5, STEP
	
	lw		s1, 80(sp)	//load s1
	lw		t9, 84(sp)	//load t9
	lw		s4, 88(sp)	//load s4
	
   /*----------------------------------------------------------------*
    * depth first search 1: compare codevector with the best case.   *
    *----------------------------------------------------------------*/
	lw		t0, 160(s2)	//t0=[psk alpk]
	mux2.lh	t1, t8, t8	//t1=[alp sq]
	lw		t2, 168(s2)	//t2=[ip0 ip1]	
	multa2	m0, t0, t1
	lw		t3, 172(s2)	//t3=[ip2 ip3]
	subma.s m0l, m0l, m0h
	addma.s m0l,m0l,m0l
	mux2.lh v0, s5, s3	//v0=[i1 ix]
	mux2.lh	v1, s3, s5	//v1=[iy i0]
	mfa		t1, m0l	
	sgt		t1, t1, zero
	cmvnez	t0, t8, t1	
	cmvnez	t2, v0, t1	;sw		t0, 160(s2)
	cmvnez	t3, v1, t1	;nop
	st		t2, 168(s2)
	
	// } end track
	sub		t4, t9, 4
	bltz	t4, 9b
	addi	t9, t9, 1	
/*	
	Word16 dn[], 	align 4
	Word16 rr[], 	align 4
	Word16 h[],  	align 8
	Word16 cod[], 	align 4
	Word16 y[],		align 4
	Word16 *sign
local:
	sign_dn[]->g729_TmpVct[0]
	sign_dn_inv[]->g729_TmpVct[40]
	psk,alpk->g729_TmpVct[80]
	ip0~3->g729_TmpVct[84~87]
	tmp_vect->g729_TmpVct[88~]
	i1_offset->g729_TmpVct[100]
	h[]->60(sp)
	cod[]->64(sp)
	y[]->68(sp)
	sign->72(sp)
	76(sp)->backup of s0
	80(sp)->backup of s1
	84(sp)->backup of t9
	88(sp)->backup of s4
	*/
	/* Set the sign of impulses */
	.align	3
	lt		t2, 168(s2)	//t2=[ip0 ip1] t3=[ip2 ip3]
	li		t6, L_SUBFR/8-1
	la		t4, 1f
	la		t5, 2f-4		
	mtru	t4, lps0	;mux2.lh	t0,zero,t2
	mtru	t5, lpe0	;mux2.hl	t1,zero,t2
	mtru	t6, lpc0	;mux2.lh	t2,zero,t3
	mux2.hl	t3,zero,t3	;sll		t0, t0, 1 //t0=ip0<<1
	addu	t4, t0, s2	;sll		t1, t1, 1 //t1=ip1<<1
	lh		t4, 0(t4)	;addu		t5, t1, s2
	lh		t5, 0(t5)	;sll		t2, t2, 1 //t2=ip2<<1
	addu	t6, t2, s2	;sll		t3, t3, 1 //t3=ip3<<1
	lh		t6, 0(t6)	;addu		t7, t3, s2	
	lh		t7, 0(t7)	;sra		s4, t4, 2
	lw		s3, 64(sp)	;sra		s5, t5, 2//s3->cod[]	
	sra		s6, t6, 2	;sra		s7, t7, 2
1:
	swp		zero, (s3)+4
	swp		zero, (s3)+4
	swp		zero, (s3)+4
	swp		zero, (s3)+4
2:
	subu	s3, s3, L_SUBFR*2
	addu	a0, t0, s3	//a0->cod[ip0]
	addu	a1, t1, s3	;sh		s4, 0(a0)//a1->cod[ip1]
	addu	a2, t2, s3	;sh		s5, 0(a1)//a2->cod[ip2]
	addu	a3, t3, s3	;sh		s6, 0(a2)//a3->cod[ip3]
	sh		s7, 0(a3)	;sra	t0, t0, 1//t0=ip0
	sra		t1, t1, 1	;sra	t2, t2, 1//t1=ip1 t2=ip2
	sra		t3, t3, 1	;lw		s4, 68(sp)//s4->y[] t3=ip3
										//t4=i0 t5=i1
										//t6=i2 t7=i3
	/* find the filtered codeword */
	la		a0, 1f
	la		a1, 2f-4
	sub		a2, t0, 1
	bltz	a2, 3f		//if a2<0, skip this loop
	mtru	a0, lps0
	mtru	a1, lpe0
	mtru	a2, lpc0
	li		v0, 0
1:
	shp		zero, (s4)+2
	addu	v0, v0, 2
2:
	subu	s4, s4, v0	//s4->y[0]
	.align	3
3:	//i0	
	la		a0, 1f
	la		a1, 2f-4	//s5->h[]
	lw		s5, 60(sp)	;sgt	t8, t4, zero//check i0 > 0 ?
	mtru	a0, lps0	;li		a2, L_SUBFR
	lhp		t9, (s5)+2	;sub	a2, a2, t0	//t0=ip0
	mtru	a1, lpe0	;sub	a2, a2, 1	
	mtru	a2, lpc0	;sll	v1, t0, 1
	addu	a1, s4, v1	;nop//a1->y[ip0]	
1:		
	lhp		v1, (s5)+2	;move	a3, t9
	sub		v0, zero, t9
	cmveqz	a3, v0, t8	
	shp		a3, (a1)+2	;move	t9, v1
2:
	//i1
	la		a0, 1f
	la		a1, 2f-4	//s5->h[]
	lw		s5, 60(sp)	;sgt	t8, t5, zero//check i1 > 0 ?
	mtru	a0, lps0	;li		a2, L_SUBFR
	lhp		t9, (s5)+2	;sub	a2, a2, t1	//t1=ip1
	mtru	a1, lpe0	;sub	a2, a2, 1	
	mtru	a2, lpc0	;sll	v1, t1, 1
	addu	a1, s4, v1	//a1->y[ip1]
	lh		s0, 0(a1)	//s0=y[ip1]
1:		
	lhp		v1, (s5)+2	;addr2.s a3, s0, t9//y[i]+h[j]
	subr2.s v0, s0, t9	;lh		s1, 2(a1)
	cmveqz	a3, v0, t8	;move	t9, v1
	shp		a3, (a1)+2	;move	s0, s1
2:
	//i2
	la		a0, 1f
	la		a1, 2f-4	//s5->h[]
	lw		s5, 60(sp)	;sgt	t8, t6, zero//check i2 > 0 ?
	mtru	a0, lps0	;li		a2, L_SUBFR
	lhp		t9, (s5)+2	;sub	a2, a2, t2	//t2=ip2
	mtru	a1, lpe0	;sub	a2, a2, 1	
	mtru	a2, lpc0	;sll	v1, t2, 1
	addu	a1, s4, v1	//a1->y[ip2]
	lh		s0, 0(a1)	//s0=y[ip2]
1:		
	lhp		v1, (s5)+2	;addr2.s a3, s0, t9//y[i]+h[j]
	subr2.s v0, s0, t9	;lh		s1, 2(a1)
	cmveqz	a3, v0, t8	;move	t9, v1
	shp		a3, (a1)+2	;move	s0, s1
2:
	//i3
	la		a0, 1f
	la		a1, 2f-4	//s5->h[]
	lw		s5, 60(sp)	;sgt	t8, t7, zero//check i3 > 0 ?
	mtru	a0, lps0	;li		a2, L_SUBFR
	lhp		t9, (s5)+2	;sub	a2, a2, t3	//t3=ip3
	mtru	a1, lpe0	;sub	a2, a2, 1	
	mtru	a2, lpc0	;sll	v1, t3, 1
	addu	a1, s4, v1	//a1->y[ip3]
	lh		s0, 0(a1)	//s0=y[ip3]
1:		
	lhp		v1, (s5)+2	;addr2.s a3, s0, t9//y[i]+h[j]
	subr2.s v0, s0, t9	;lh		s1, 2(a1)
	cmveqz	a3, v0, t8	;move	t9, v1
	shp		a3, (a1)+2	;move	s0, s1
2:	

	/* find codebook index: 17-bit address */
	li		v0, 0		;addi	v1, v0, 1//v0=i
	sgt		t8, t4, zero;nop
	cmvnez	v0, v1, t8	;sgt	t9, t5, zero
	addi	v1, v0, 2	;sgt	t8, t6, zero
	cmvnez	v0, v1, t9	;nop
	addi	v1, v0, 4	;sgt	t9, t7, zero
	cmvnez	v0, v1, t8	;lw		s0, 72(sp)	//s0->sign[]
	addi	v1, v0, 8	;li		t4, 0x199a199a//t4=[6554 6554]
	cmvnez	v0, v1, t9	;mux2.ll t5, t0, t1//t5=[ip0 ip1]
	sh		v0, 0(s0)	;mux2.ll t6, t2, t3// *sign=i
	multa2	m0, t4, t5	
	multa2	m1, t4, t6
	mfa		t0, m0h		;nop
	mfa		t1, m0l		;sra	t0, t0, 15//t0=ip0
	mfa		t2, m1h		;sra	t1, t1, 15//t1=ip1
	mfa		v0, m1l		;sra	t2, t2, 15//t2=ip2
	sra		v0, v0, 15//v0=i
	sll		v1, v0, 2
	add		v1, v0, v1	;sll	t5, v0, 1//v1=j
	add		t4, v1, 3	;sll	t1, t1, 3	//ip1<<3
	sub		v1, t3, t4	;sll	t2, t2, 6	//ip2<<6
	add		t3, t5, v1	;add	v0, t0, t1//t3=ip3
	sll		t3, t3, 9	//ip3<<9	
	add		t2, t2, t3
	add		v0, v0, t2	//v0=i	

	////////////////
	lw		ra, 20(sp)
	//lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	//mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128
	.set	reorder
	.end	D4i40_17_fasts


