#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define	L_SUBFR	40

/*
void Gain_predict(Word16 past_qua_en[], Word16 code[],Word16 *gcode0, Word16 *exp_gcode0
	a0->past_qua_en		//align	8
	a1->code			//align 4
	a2->gcode0
	a3->exp_gcode0
local:
	60(sp)->exp
	62(sp)->frac	
*/
	.text
	//.section ".text.Gain_predicts"
	.set	noreorder
	.globl	Gain_predicts
	.ent	Gain_predicts
Gain_predicts:
	.align	3
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0//s0=past_qua_en
	sw		s3, 40(sp)	;move	s1, a2//s1=gcode0
	move	s2, a3//s2=exp_gcode0
	/////////////////
	/* energy coming from code */
	la		t0, 1f
	lwp		t4, (a1)+4	
	la		t1, 2f-4
	lwp		t5, (a1)+4	;li		t2, L_SUBFR/4-1
	mtru	t0, lps0	;multa2	m0, zero,zero
	mtru	t1, lpe0	
	mtru	t2, lpc0
	.align	3
1:	
	madda2.s m0, t4, t4	;lwp	t6, (a1)+4
	madda2.s m0, t5, t5	;lwp	t7, (a1)+4
	move	t4, t6		
	move	t5, t7
2:
	addma.s m0l,m0l,m0h
	addma.s m0l,m0l,m0l
	mfa		a0, m0l	//a0=L_tmp
	/* compute: means_ener - 1=log10(ener_code/L_SUBFR) */
	addu	a1, sp, 60
	jal		Log2
	addu	a2, sp, 62
	
	lh		a0, 60(sp)
	lh		a1, 62(sp)	
	jal		Mpy_32_16
	li		a2, -24660
	
	li		t0, 0x1fd300	//L_mult(32588, 32)
	addr.s	v0, v0, t0		//v0=L_tmp
	/* compute gcode0 */
	sll		v0, v0, 10	;lt		t4, 0(s0)	//t4=[0 1] t5=[2 3]
	li		t0, 0x15c3128f//t0=5571,4751
	li		t1, 0x0ae10614//t1=2785,1556
	multa2	m0, t0, t4
	madda2.s m0, t1, t5
	addma.s m0l,m0l,m0h
	addma.s m0l,m0l,m0l
	mfa		v1, m0l
	addr.s	v0, v0, v1	//v0=L_tmp v0h=*gcode0
	
	/* gcode0 = pow(10.0, gcode0/20) */
	li		t0, 0x2a7e0000//high part=5439*2
	multa2	m0h, v0, t0
	mfa		a0, m0h, 8	//a0=L_tmp
	//L_Extract	
	sra		s3, a0, 16	
	sra		a1, a0, 1	;sll	a3, s3, 14+1//s3=exp
	li		a0, 14
	jal		Pow2
	subr.s	a1, a1, a3		//a1=frac
	sh		v0, 0(s1)		//*gcode0
	li		t0, 14
	sub		t0, t0, s3
	sh		t0, 0(s2)		//*exp_gcode0	
	/////////////////
	lw		ra, 20(sp)
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)	
	jr		ra
	addu	sp, sp, 128
	.set	reorder
	.end	Gain_predicts

