#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define UP_SAMP		3
#define L_INTER10	10
#define L_SUBFR		40
#define PIT_MAX		143
#define M			10

	.bss
	//.section ".bss.Fac1"
	.align	3
	.globl	Fac1
Fac1:
	.space	2*(L_INTER10+2)
	
	//.section ".bss.Fac2"
	.align	3
	.globl	Fac2
Fac2:
	.space	2*(L_INTER10+2)
	
	//.section ".bss.xl"
	.align	3
	.globl	xl
xl:
	.space	2*(L_SUBFR+PIT_MAX+2*M)
	
	//.section ".bss.xr"
	.align	3
	.globl	xr
xr:
	.space  2*(L_SUBFR+PIT_MAX+2*M)
	
/*	.section ".bss.blanks"
	.align	3
	.globl	blanks		//put DRAM work correctly
blanks:
	.space	4096*2
	*/

/*
void Pred_lt_3(Word16 exc[], Word16 T0, Word16 frac, Word16 L_subfr)
	s0->exc[]
	a1->T0
	a2->frac
	a3->L_subfr
local:
	Fac1->fac1[]
	Fac2->fac2[]
	xl->xl[]
	xr->xr[]
	
*/
	.text
	//.section ".text.Pred_lt_3s"
	.set	noreorder
	.globl	Pred_lt_3s
	.ent	Pred_lt_3s
Pred_lt_3s:
	subu	sp, sp, 128
	sw		ra, 20(sp)	
	sw		s0, 28(sp)	//s0->exc[]
	sw		s1, 32(sp)	//s1->T0,dis
	sw		s2, 36(sp)	//s2->x0	
	sw		s3, 40(sp)	//s3->fac1
	sw		s4, 44(sp)	//s4->fac2
	sw		s5, 48(sp)
	sw		s6, 52(sp)
	sw		s7, 56(sp)
	//sw		s8, 60(sp)
	move	s0, a0
	///////////////////
	sll		t4, a1, 1	;sub	a2, zero, a2	//a2=-frac
	subu	s2, a0, t4	;add	t1, a2, UP_SAMP	//s2=x0	
	slt		t0, a2, zero;subu	t2, s2, 2
	cmvnez	a2, t1, t0	//a2=frac
	cmvnez	s2, t2, t0	//s2=x0
	subu	s1, a0, s2	//s1=dis (in bytes)
	sra		s1, s1, 1	//s1=dis (in word16)
	.extern inter_3l
	la		t4, inter_3l
	sll		t5, a2, 1	;li		t6, UP_SAMP
	addu	t8, t4, t5	;sub	t6, t6, a2
	sll		t6, t6, 1	//t8=c1
	addu	t9, t4, t6	//t9=c2
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_INTER10-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.extern Fac1
	.extern Fac2
	la		s3, Fac1	//s3=fac1
	la		s4, Fac2	//s4=fac2
	addu	a0, s3, 2*(L_INTER10-1)	
	mfru	t0, mmd
	move	a1, s4
	sw		t0, 24(sp)	//mmd
1:
	lhp		t4, (t8)+(2*UP_SAMP)
	lhp		t5, (t9)+(2*UP_SAMP)
	shp		t4, (a0)-2
	shp		t5, (a1)+2
2:
	sw		zero, 20(s3)
	sw		zero, 20(s4)
	/* copy data */
	.extern xl
	.extern xr
	la		s5, xl	//s5=xl
	la		s6, xr	//s6=xr
	subu	a0, s2, 18;move	a1, s5
	jal		Copy50
	li		a2, (L_SUBFR+L_INTER10)
	addu	a0, s2, 2	;move	a1, s6
	jal		Copy50
	li		a2, (L_SUBFR+L_INTER10)
	
	move	t8, s5	//t8=px1
	move	t9, s6	//t9=px2
	add		s2, s1, 9//s2=dis+9
	sub		s1, s1, 1//s1=dis-1
	sll		t0, s2, 1
	sll		t1, s1, 1
	addu	s5, s5, t0//s5=xl[dis+9]
	addu	s6, s6, t1//s6=xr[dis-1]	
	li		a0, L_SUBFR/4	//a0=j
	li		t4, 0x6		//fractional and 32 sature
	mtru	t4, mmd	
	.align	3
3:	
	//f1: t0:[0 1]t1:[2 3]t2:[0 1]t3:[2 3]
	//x1: t4:[8 9]t5:[10 11]t6:[12 13]t7:[14 15]
	//	  s7:[x5 x6]v0:[x3 x4]	
	la		t0, 1f
	la		t1, 2f-4	
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t2, (L_INTER10+2)/4-1
	mtru	t2, lpc0
	ltp		t2, (s3)+8	;multa2	m0,zero,zero	
	ltp		t4, (t8)+8	;multa2	m1,zero,zero
	lt		t6, 0(t8)	;multa2	m2,zero,zero
	move	t0, t2		;multa2	m3,zero,zero
	.align	3
1:	
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (s3)+8
	madda2.s m2, t0, t5	;mux2.lh s7, t4, t5
	madda2.s m2, t1, t6	;mux2.lh v0, t5, t6
	madda2.s m1, t0, s7	;ltp	t4, (t8)+8
	madda2.s m1, t1, v0	;mux2.lh s7, t6, t7
	madda2.s m3, t0, v0	;lt		t6, 0(t8)
	madda2.s m3, t1, s7	;move	t0, t2	
2:
	//f2: t0:[0 1]t1:[2 3]t2:[0 1]t3:[2 3]
	//x2: t4:[8 9]t5:[10 11]t6:[12 13]t7:[14 15]
	//	  s7:[x5 x6]v0:[x3 x4]
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;subu	s3, s3, 32	
	mtru	t1, lpe0	;subu	t8, t8, (32-8)
	li		t2, (L_INTER10+2)/4-1
	mtru	t2, lpc0
	ltp		t4, (t9)+8
	ltp		t2, (s4)+8	
	lt		t6, 0(t9)	;move	t0, t2
	.align	3
1:	
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (s4)+8
	madda2.s m2, t0, t5	;mux2.lh s7, t4, t5
	madda2.s m2, t1, t6	;mux2.lh v0, t5, t6
	madda2.s m1, t0, s7	;ltp	t4, (t9)+8
	madda2.s m1, t1, v0	;mux2.lh s7, t6, t7
	madda2.s m3, t0, v0	;lt		t6, 0(t9)
	madda2.s m3, t1, s7	;move	t0, t2	
2:
	addma.s m0l,m0l,m0h	;subu	s4, s4, 32
	addma.s m1l,m1l,m1h	;subu	t9, t9, (32-8)
	addma.s m2l,m2l,m2h	;addma.s m3l,m3l,m3h
	mfa		t0, m0l		;li		t4, 0x00008000
	mfa		t1, m1l		;addr.s	t0, t0, t4
	mfa		t2, m2l		;addr.s t1, t1, t4
	mfa		t3, m3l		;addr.s t2, t2, t4
	addr.s	t3, t3, t4	;sra	t0, t0, 16
	sra		t1, t1, 16	;sra	t2, t2, 16
	sra		t3, t3, 16	;shp	t0, (s0)+2
	shp		t1, (s0)+2	;shp	t2, (s0)+2
	shp		t3, (s0)+2
	shp		t0, (s5)+2
	shp		t1, (s5)+2
	shp		t2, (s5)+2
	shp		t3, (s5)+2
	shp		t0, (s6)+2
	shp		t1, (s6)+2
	shp		t2, (s6)+2
	shp		t3, (s6)+2
	
	sub		a0, a0, 1
	bgtz	a0, 3b
	nop
	
	///////////////////
	lw		ra, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	//lw		s8, 60(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128	
	.set	reorder
	.end	Pred_lt_3s

