#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define MAX_32	0x7fffffff
#define NC0		128
#define NC1		32
#define M		10

/*
void Lsp_pre_select(Word16 rbuf[], Word16 lspcb1[][M], Word16 *cand)
	a0->rbuf[]		//align 4
	a1->lspcb1[][M]	//align 8
	a2->*cand
*/
	.text
	//.section ".text.Lsp_pre_selects"
	.set	noreorder
	.globl	Lsp_pre_selects
	.ent	Lsp_pre_selects
Lsp_pre_selects:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	.align	3
	/////////////////
	lwp		t0, (a0)+4	;li		t9, 0	//t9=*cand
	lwp		t1, (a0)+4	;li		t8, MAX_32	//t8=L_dmin
	la		t4, 1f
	la		t5, 2f-4
	ltp		t2, (a1)+8	;li		t6, NC0-1//t2=[0 1]t3=[2 3]
	mtru	t4, lps0	;li		s0, 0	//s0=i
	mtru	t5, lpe0	;nop
	mtru	t6, lpc0	;multa2	m0,zero,zero
1:	
	subr2.s	t4, t0, t2	;lwp	t6, (a0)+4
	subr2.s t5, t1, t3	;lwp	t7, (a0)+4
	madda2.s m0, t4, t4	;lwp	t2, (a1)+4//t2=[4 5]
	madda2.s m0, t5, t5	;lwp	t3, (a1)+4//t3=[6 7]
	subr2.s	t4, t6, t2	;lwp	t0, (a0)+4
	subr2.s t5, t7, t3	;lwp	t1, (a0)+4
	madda2.s m0, t4, t4	;lwp	t2, (a1)+4//t2=[8 9]
	madda2.s m0, t5, t5	;subu	a0, a0, 24
	subr2.s	t4, t0, t2	
	madda2.s m0, t4, t4	
	addma.s m0l,m0l,m0h	;lwp	t0, (a0)+4
	addma.s m0l,m0l,m0l	;lwp	t1, (a0)+4//shift left 1 bit(frac mpy)
	mfa		v0, m0l		;multa2	m0,zero,zero
	subr.s	t4, v0, t8	;lwp	t2, (a1)+4//t2=[10 11]t3=[12 13]
	slt		t4, t4, zero;lwp	t3, (a1)+4
	cmvnez	t8, v0, t4	;cmvnez	t9, s0, t4
	addi	s0, s0, 1	;nop//s0=i	
2:
	sh		t9, 0(a2)	//update *cand
	/////////////////
	lw		s0, 20(sp)	
	jr		ra
	addu	sp, sp, 64

	.set	reorder
	.end	Lsp_pre_selects

/*
void Lsp_select_1(Word16 rbuf[], Word16 lspcb1[], Word16 wegt[], Word16 lspcb2[][M])
	a0->rbuf
	a1->lspcb1
	a2->wegt[]
	a3->lspcb2[][]
*/
	.text
	//.section ".text.Lsp_select_1s"
	.set	noreorder
	.globl	Lsp_select_1s
	.ent	Lsp_select_1s
Lsp_select_1s:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)
	sw		s3, 36(sp)
	sw		s4, 40(sp)	
	/////////////////
	lw		t0, 0(a0)	//t0=rbuf[0 1]
	lw		t1, 0(a1)	//t1=lspcb1[0 1]
	lw		t2, 4(a0)
	lw		t3, 4(a1)
	lw		t4, 8(a0)	
	lw		t5, 8(a1)	
	subr2.s	t7,t0,t1	//t7=buf[0 1]
	mfru	t0, mmd
	li		t1, 0x6		//frac mpy and 32 bit sature	
	sw		t0, 24(sp)
	subr2.s	t8,t2,t3	//t8=buf[2 3]
	mtru	t1, mmd
	subr2.s t9,t4,t5	//t9=buf[4 x]	
	/* avoid the worst case */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, NC1-1	
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	li		v0, 0		//v0=index
	li		v1, MAX_32	//v1=L_dmin
	li		t6, 0		//t6=k1
	//for(k1=0; k1<NC1; k1++) {
	.align	3
1:	
	lw		t0, 0(a3)	//t0=lspcb2[k1][0 1]
	lw		t1, 0(a2)	//t1=wegt[0 1]
	subr2.s	t2, t7, t0	;lw		s0, 4(a3)//t2=tmp[0 1]
	multa2	m0, t1, t2	;lw		s1, 4(a2)
	nop					;nop
	mfa		t3, m0h		;subr2.s s2, t8, s0//%hi(t3)=tmp2[0]
	mfa		t4, m0l		;multa2	m2, s1, s2
	mux2.hh	t3, t3, t4	;mfa	s3, m2h//t3=tmp2[0 1]	
	multa2	m1, t3, t2	;mfa	s4, m2l
	addma.s m1l,m1h,m1l	;mux2.hh s3, s3, s4//m1l=L_dist[0]+L_dist[1]
	lw		t0, 8(a3)	;multa2	m3, s3, s2
	lw		t1, 8(a2)	;addma.s m3l,m3l,m3h
	subr2.s	t2, t9, t0	;addma.s m1l, m1l, m3l
	multa2	m0, t1, t2	;addu	a3, a3, M*2
	mfa		t3, m0h		
	multa2	m1h, t3, t2
	addma.s m1l,m1l,m1h
	mfa		t0, m1l		//t0=L_dist
	subr.s	t1, t0, v1
	slt		t1, t1, zero
	cmvnez	v1, t0, t1
	cmvnez	v0, t6, t1	
	addi	t6, t6, 1
2:		
	// } end k1
	
	/////////////////
	lw		s0, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	lw		s3, 36(sp)
	lw		s4, 40(sp)	
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64	
	.set	reorder
	.end	Lsp_select_1s

/*
 Word16 Lsp_select_2(Word16 rbuf[], Word16 lspcb1[], Word16 wrgt[], Word16 lspcb2[][M])
	a0->rbuf[]
 	a1->lspcb1[]
 	a2->wegt[]
 	a3->lspcb2[][M]
*/
	.text
	//.section ".text.Lsp_select_2s"
	.set	noreorder
	.globl	Lsp_select_2s
	.ent	Lsp_select_2s
Lsp_select_2s:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)
	sw		s3, 36(sp)
	sw		s4, 40(sp)	
	/////////////////
	addu	a0, a0, 8	//a0->rbuf[4]
	addu	a1, a1, 8	//a1->lspcb1[4]		
	lw		t0, 0(a0)	//t0=rbuf[4 5]
	lw		t1, 0(a1)	//t1=lspcb1[4 5]
	lw		t2, 4(a0)	;addu	a2, a2, 8//a2->wegt[4]
	lw		t3, 4(a1)	;addu	a3, a3, 8//a3->lspcb2[][4]	
	lw		t4, 8(a0)	
	lw		t5, 8(a1)	
	subr2.s	t7,t0,t1	//t7=buf[4 5]
	mfru	t0, mmd
	li		t1, 0x6		//frac mpy and 32 bit sature	
	sw		t0, 24(sp)
	subr2.s	t8,t2,t3	//t8=buf[6 7]
	mtru	t1, mmd
	subr2.s t9,t4,t5	//t9=buf[8 9]	
	/* avoid the worst case */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, NC1-1	
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	li		v0, 0		//v0=index
	li		v1, MAX_32	//v1=L_dmin
	li		t6, 0		//t6=k1
	//for(k1=0; k1<NC1; k1++) {
	.align	3
1:	
	lw		t0, 0(a3)	//t0=lspcb2[k1][4 5]
	lw		t1, 0(a2)	//t1=wegt[4 5]
	subr2.s	t2, t7, t0	;lw		s0, 4(a3)//t2=tmp[0 1]
	multa2	m0l, t1, t2	;lw		s1, 4(a2)
	nop					;nop
	mfa		t4, m0l		;subr2.s s2, t8, s0//%hi(t3)=tmp2[0]
	lw		t0, 8(a3)	;multa2	m2, s1, s2
	mux2.hh	t3, zero,t4	;mfa	s3, m2h//t3=tmp2[0 1]	
	multa2	m1l, t3, t2	;mfa	s4, m2l	
	lw		t1, 8(a2)	;mux2.hh s3, s3, s4//m1l=L_dist[0]+L_dist[1]
	subr2.s	t2, t9, t0	;multa2	m3, s3, s2
	multa2	m0, t1, t2	;addma.s m3l,m3l,m3h
	mfa		t3, m0h		;addma.s m1l, m1l, m3l
	mfa		t4, m0l		;addu	a3, a3, M*2			
	mux2.hh	t3, t3, t4
	multa2	m0, t3, t2
	addma.s m0l,m0l,m0h
	addma.s m1l,m1l,m0l
	mfa		t0, m1l		//t0=L_dist
	subr.s	t1, t0, v1
	slt		t1, t1, zero
	cmvnez	v1, t0, t1
	cmvnez	v0, t6, t1	
	addi	t6, t6, 1
2:		
	// } end k1
	
	/////////////////
	lw		s0, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	lw		s3, 36(sp)
	lw		s4, 40(sp)	
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64	
	.set	reorder
	.end	Lsp_select_2s


