#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

/*
void Copy50(Word16 x[],Word16 y[],Word16 L)
	a0->x[]	align 2/4/8
	a1->y[]	align 8
	a2->L=50
*/
	.text
	//.section ".text.Copy50"
	.set	noreorder
	.globl	Copy50
	.ent	Copy50
Copy50:
	and		t0, a0, 0x00000007
	sub		t1, t0, 2
	beqz	t1, 2f
	sub		t2, t0, 4
	beqz	t2, 4f
	sub		t3, t0, 6
	beqz	t3, 6f
	li		t2, 50/8-1
	//case 0(align 8)
	la		t0, 11f
	la		t1, 12f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
11:
	ltp		t4, (a0)+8
	ltp		t6, (a0)+8
	stp		t4, (a1)+8
	stp		t6, (a1)+8
12:
	lw		t4, 0(a0)
	nop
	j		10f
	sw		t4, 0(a1)		
2:	//case 2
	subu	a0, a0, 2	//a0->x[-1]
	la		t4, 11f	
	lwp		t0, (a0)+4	//t0=x[-1 0]
	la		t5, 12f-4
	li		t6, 48/8-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	.align	3
11:
	lwp		t1, (a0)+4	//t1=x[1 2]
	ltp		t2, (a0)+8	//t2=x[3 4] t3=x[5 6]
	lwp		t4, (a0)+4;mux2.lh t0, t0, t1//t4=x[7 8]
	mux2.lh	t1, t1, t2;nop
	mux2.lh t2, t2, t3;stp	t0, (a1)+8
	mux2.lh	t3, t3, t4;move	t0, t4
	stp		t2, (a1)+8;nop
12:
	lw		t1, 0(a0)
	nop
	mux2.lh	t0, t0, t1
	j		10f
	sw		t0, 0(a1)
4:  //case 4
	la		t4, 11f
	lwp		t0, (a0)+4
	la		t5, 12f-4
	li		t6, 48/8-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0	
	.align	3
11:
	ltp		t2, (a0)+8
	ltp		t4, (a0)+8
	move	t1, t2	;nop
	move	t6, t3	;stp	t0, (a1)+8
	move	t7, t4	;move	t0, t5
	stp		t6, (a1)+8;nop
12:
	j		10f
	sw		t0, 0(a1)
6:	//case 6	
	subu	a0, a0, 2
	la		t4, 11f
	lwp		t0, (a0)+4	//t0=x[-1 0]
	la		t5, 12f-4
	li		t6, 48/8-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	.align	3
11:
	ltp		t2, (a0)+8	//t2=x[1 2]t3=x[3 4]
	ltp		t4, (a0)+8	//t4=x[5 6]t5=x[7 8]
	mux2.lh	t0, t0, t2	;mux2.lh t1, t2, t3
	stp		t0, (a1)+8	;mux2.lh t6, t3, t4
	mux2.lh	t7, t4, t5	;move	 t0, t5
	stp		t6, (a1)+8	;nop
12:
	lw		t1, 0(a0)
	nop
	mux2.lh	t0, t0, t1
	sw		t0, 0(a1)
10:	jr		ra
	nop

	.set	reorder
	.end	Copy50


/*
void Copy_a8_m8(Word16 x[], Word16 y[], Word16 L)
	a0->x[]	align 8
	a1->y[] align 8
	a2->L = multiple of 8
*/
	.text
	//.section ".text.Copy_a8_m8"
	.set	noreorder
	.globl	Copy_a8_m8
	.ent	Copy_a8_m8
Copy_a8_m8:
	la		t0, 1f
	la		t1, 2f-4
	sra		t2, a2, 3
	sub		t2, t2, 1	//t2=L/8-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
1:
	ltp		t0, (a0)+8
	ltp		t2, (a0)+8
	stp		t0, (a1)+8
	stp		t2, (a1)+8
2:
	jr		ra
	nop

	.set	reorder
	.end	Copy_a8_m8

/*
void Copy_a8_154(Word16 x[], Word16 y[], Word16 L)
	a0->x[]	align 8
	a1->y[] align 8
	a2->L
*/
	.text
	//.section ".text.Copy_a8_154"
	.set	noreorder
	.globl	Copy_a8_154
	.ent	Copy_a8_154
Copy_a8_154:
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 154/8-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
1:
	ltp		t0, (a0)+8
	ltp		t2, (a0)+8
	stp		t0, (a1)+8
	stp		t2, (a1)+8
2:
	lw		t0, 0(a0)
	nop
	jr		ra
	sw		t0, 0(a1)

	.set	reorder
	.end	Copy_a8_154

/*
void Copy_a4_154(Word16 x[], Word16 y[], Word16 L)
*/
	.text
    //.section ".text.Copy_a4_154"
	.set	noreorder
	.globl	Copy_a4_154
	.ent	Copy_a4_154
Copy_a4_154:
	lwp		t0, (a0)+4
	la		t4, 1f
	la		t5, 2f-4
	swp		t0, (a1)+4
	li		t6, (154-2)/8-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
1:
	ltp		t4, (a0)+8
	ltp		t6, (a0)+8
	stp		t4, (a1)+8
	stp		t6, (a1)+8
2:
	jr		ra
	nop	

	.set	reorder
	.end	Copy_a4_154

/*void Copy(Word16 x[], Word16 y[], Word16 L)
	y[]-> align 4
*/
	.text
	//.section ".text.Copy"
	.set	noreorder
	.globl	Copy
	.ent	Copy
Copy:
	andi	t4, a2, 0x1
	bnez	t4, 3f
	nop	

	// L is even	
	la		t0, 1f
	la		t1, 2f-4
	sra		a2, a2, 1
	sub		a2, a2, 1	//L/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	a2, lpc0
1:
	lhp		t4, (a0)+2
	lhp		t5, (a0)+2
//	lwp		t4, (a0)+4
//	nop
//	swp		t4, (a1)+4
//	nop
	shp		t4, (a1)+2
	shp		t5, (a1)+2
2:	
	j		4f
	nop

3:	// L is odd
	la		t0, 1f
	la		t1, 2f-4
	sub		a2, a2, 1	//L-1
	sra		a2, a2, 1
	sub		a2, a2, 1	//(L-1)/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	a2, lpc0
1:
//	lwp		t4, (a0)+4
//	nop
//	swp		t4, (a1)+4
//	nop
	lhp		t4, (a0)+2
	lhp		t5, (a0)+2
	shp		t4, (a1)+2
	shp		t5, (a1)+2
2:	
	lhp		t4, (a0)+4
	nop
	shp		t4, (a1)+4	
4:	
	jr		ra
	nop
	
	.set	reorder
	.end	Copy	


/*
Word16 Randoms(Word16 *seed)
*/
	.text
	//.section ".text.Randoms"
	.set	noreorder
	.globl	Randoms
	.ent	Randoms
Randoms:
	.align	3
	/* seed=seed*31821+13849 */
	lh		t4, 0(a0)	;li		t5, 31821
	multa2	m0l, t4, t5	;li		t6, 13849
	addma.s m0l,m0l,m0l
	mfa		v0, m0l, 1
	addr.s	v0, v0, t6
	sll		v0, v0, 16
	sra		v0, v0, 16
	jr		ra
	sh		v0, 0(a0)
	
	.set	reorder
	.end	Randoms


