/*
* Copyright c                  Realtek Semiconductor Corporation, 2004  
* All rights reserved.
* 
* Program : Control MII & MDC/MDIO connected 8305SB
* Abstract : 
* Author : Edward Jin-Ru Chen (jzchen@realtek.com.tw)               
* $Id: rtl8305sb.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
*/

/*
	Implementation note:
	1. Using GPIO Port A Pin 6 to emulate MDIO and GPIO Port A Pin 7 to emulate MDC
	2. 8305SB Port 4 connect to 8650B Port 5 (MII)
*/

/*	@doc RTL8305SB_API

	@module rtl8305sb.c - RTL8305SB 5-port switch controller driver API documentation	|
	This document explains the API interface of the driver module. 
	API included in this document is special APIs for RTL8305SB excluding common APIs for 
	both RTL8305SB and RTL8305SC.

	@normal Edward Jin-Ru Chen (jzchen@realtek.com.tw) <date>

	Copyright <cp>2004 Realtek<tm> Semiconductor Cooperation, All Rights Reserved.

 	@head3 List of Symbols |
 	Here is a list of all functions and variables in this module.

 	@index | RTL8305SB_API
*/

#include "rtl8305s.h"
#include "rtl8305sb.h"
#include "assert.h"

#define RTL8305SB_ASIC_DRIVER

#define RTL8305SB_TABLE_DRIVER

