/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_dumpPkt.h,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract:
*
* $Log: pg_dumpPkt.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:11  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:43  danwu
* init
*
* Revision 1.2  2003/12/30 10:34:43  waynelee
* add pptp, ipx support and provide more flexible packet format
*
* Revision 1.1  2002/08/28 03:43:33  orlando
* packet generation module initial check-in.
*
*-------------------------------------------------------------------------
*/

#ifndef _PG_DUMPPKT_H_
#define _PG_DUMPPKT_H_

#include "pg_l2pkt.h"
#include "pg_l3pkt.h"
#include "pg_l4pkt.h"

void dumpEther(etherHdr_t * ether);
void dumpVlan(vlanHdr_t * vlan);
void dumpLlc(llcHdr_t * llc);
void dumpPppoe(pppoeHdr_t * pppoe);
void dumpIpx(ipxHdr_t * ipx);

void dumpArp(arpHdr_t * arp);
void dumpIp(ipHdr_t * ip, uint32 l3Flag, uint16 l3Cksum);

void dumpPptp(greHdr_t * pptp);

void dumpIcmp(icmpHdr_t * icmp, uint32 l4Flag, uint16 l4Cksum);
void dumpIgmp(igmpHdr_t * igmp, uint32 l4Flag, uint16 l4Cksum);
void dumpTcp(tcpHdr_t * tcp, uint32 l4Flag, uint16 l4Cksum);
void dumpUdp(udpHdr_t * udp, uint32 l4Flag, uint16 l4Cksum);

#endif /* _PG_DUMPPKT_H_ */
