/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_flagDef.h,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract:
*
* $Log: pg_flagDef.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:11  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:43  danwu
* init
*
* Revision 1.2  2003/12/30 10:34:42  waynelee
* add pptp, ipx support and provide more flexible packet format
*
* Revision 1.1  2002/08/28 03:43:38  orlando
* packet generation module initial check-in.
*
*-------------------------------------------------------------------------
*/

#ifndef _PG_FLAGDEF_H_
#define _PG_FLAGDEF_H_

//Ethernet is always exist
#define L2_VLAN			0x00000001
#define L2_SNAP			0x00000002
#define L2_PPPoE		0x00000004
#define L2_MASK			0x00000007

#define L3_IPX			0x00000010
#define L3_ARP			0x00000020
#define L3_IP			0x00000040
#define L3_MASK			0x00000070

#define L4_ICMP			0x00000100
#define L4_IGMP			0x00000200
#define L4_UDP			0x00000400
#define L4_TCP			0x00000800
#define	L4_PPTP			0x00001000		
#define L4_MASK			0x00001f00

#define L2_CRC_ERR		0x80000000
#define L3_CKSUM_ERR	0x40000000
#define L4_CKSUM_ERR	0x20000000
#define L4_NO_CKSUM		0x10000000
#define CTL_MASK		0xf0000000

#define PKT_PARSE_L3_CKSUM_OK	0x00000001
#define PKT_PARSE_L3_CKSUM_ERR	0x00000002

#define PKT_PARSE_L4_CKSUM_OK	0x00000001
#define PKT_PARSE_L4_CKSUM_ERR	0x00000002
#define PKT_PARSE_UDP_NO_CKSUM	0x00000004
#define PKT_PARSE_UDP_LEN_ERR	0x00000008

#endif /* _PG_FLAGDEF_H_ */
