#ifndef __G7231_H__
#define __G7231_H__

void g7231_setHighPassFilter(Flag Hp);
void Init_Coder( void);
void Init_Decod( void );
void Init_Dec_Cng(void);
void g7231_setCoderRate53(void);
void g7231_setCoderRate63(void);
int  Read_lbc(Word16 *Dpnt, int Len, Word16 *Ifp);
int  Coder( Word16 *DataBuff, char *Vout, Word32 FrCnt );
int Line_Rd(char *Line, char *Fp);
Flag Decod(Word16 *DataBuff, char *Vinp, Word16 Crc);

/* ITU-T test sequence */
// default pattern
extern short womenb[];		// input
extern char r63vbits[]; 	// ref. output
// pass
extern short INEQC53_TIN[];
extern char INEQC53_RCO[];
// pass
extern short TAMEC63H_TIN[];
extern char TAMEC63H_RCO[];
// pass
extern short CODEC63_TIN[];
extern char CODEC63_RCO[];
// fail on frame 20
extern short OVERC53H_TIN[];
extern char OVERC53H_RCO[];
// fail on frame 2
extern short OVERC63_TIN[];
extern char OVERC63_RCO[];
// fail on frame43
extern short PATHC63H_TIN[];
extern char PATHC63H_RCO[];
// fail on frame0
extern short PATHC53_TIN[];
extern char PATHC53_RCO[];
// fail on frame 3
extern short DTX53MIX_TIN[];//
extern char DTX53_RCO[];//
// pass
extern short CODEC63_TIN[];
extern char CODEC63_RCO[];
// fail on frame 3
extern short DTX63_TIN[];
extern char DTX63_RCO[];
//
extern char INEQD53_TCO[];
extern short INEQD53_ROU[];
// serious errors
extern char OVERD53_TCO[];
extern short OVERD53_ROU[];

#endif

