#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

/*
Note.
1.
 Warning message: (missing case in sourcereg, format_num=116)
 <sol> no "mfa" following "lw" instruction can keep from this warning

*/

#define PitchMin	18
#define PitchMax	(PitchMin+127)
#define SubFrLen	60
#define SubFrLen2	(60+4)
#define Frame		240
#define ClPitchOrd	5
#define Pstep		1
#define PwRange		3
#define PwConst     0x00002800
#define	MlqSteps	2
#define Sgrid		2
#define NumOfGainLev	24

#define NbFilt085_min      51
#define NbFilt170_min      93
#define NbFilt085          85
#define NbFilt170          170

#define NB_POS	8
#define MSIZE	64
#define i0i0	(0)
#define i1i1	(NB_POS)*2
#define i2i2	(NB_POS*2)*2
#define i3i3	(NB_POS*3)*2
#define i0i1	(NB_POS*4)*2
#define i0i2	(NB_POS*4+MSIZE)*2
#define i0i3	(NB_POS*4+MSIZE*2)*2
#define i1i2	(NB_POS*4+MSIZE*3)*2
#define i1i3	(NB_POS*4+MSIZE*4)*2
#define i2i3	(NB_POS*4+MSIZE*5)*2

#define STEP	8
#define threshold 16384
#define max_time	120
	

/***************************************************
Word16   Estim_Pitch( Word16 *Dpnt, Word16 Start )
	a0->Dpnt
	a1->Start
local:	
	ptr0,Mxp->s0
	ptr1,Mcr->s1
	Acc1,Mnr->s2	
	s3 ->ra
	s4->mmd
	s5->i
	s6->Indx
	32(sp)->Len[]
	CrossEn[]->Temp3[], defined in exc_lbc.c
	En[]->Temp2[], define in exc_lbc.c
	src[] ->src[],define in exc_lbc.c
	tar[] ->tar[],define in exc_lbc.c
*/	
	.text
	.set	noat
	.set	noreorder
	.globl	Estim_Pitchs
	.ent	Estim_Pitchs
Estim_Pitchs:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 52(sp)
	sw		s4, 36(sp)
	sw		s5, 40(sp)
	sw		s6, 44(sp)
	sw		s7, 48(sp)
	sw		at, 60(sp)	;move	s3, ra
	mfru	s4, mmd		;li		t0, 0x6	//fractional and 32 bit
	mtru	t0, mmd
	/////////////////	
	sub		t4, a1, (PitchMax-2)
	sll		t5, a1, 1	;	addu	s0, a0, t5	
	sll		t4, t4, 1//s0=ptr0=Dpnt[Start]
	addu	s1, a0, t4	//s1=ptr1=Dpnt[Pr]			// 14 clks
	// make data alignment to 8
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t2, 2*SubFrLen/2-1
	mtru	t2, lpc0
	.extern src
	.extern tar
	la		s5, src
	la		s6, tar
	sub		t4, s0, 2		//force t0 align to 4,t4=ptr0[-1]
	move	t7, s1
	//t0:[s1 s2] t1:[s3 s4]
	//t2:[t0 t1]
	lwp		t0, (t4)+4
	lwp		t1, (t4)+4
	lwp		t2, (t7)+4
	mux2.lh	t5, t0, t1
	.align	3										//15 clks
1:
	swp		t5, (s5)+4;move	t0, t1	
	swp		t2, (s6)+4	
	lwp		t1, (t4)+4	
	lwp		t2, (t7)+4;mux2.lh	t5, t0, t1
2:													//4*60=240
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t6, PitchMax-1
	mtru	t6, lpc0
	.align	3									
1:
	swp		t2, (s6)+4
	lwp		t3, (t7)+4
	nop
	move	t2, t3
2:													//7+4*145= 587
	.extern src
	.extern tar
	la		s0, src	//s0=ptr0=src[0], align 8
	la		s1, tar	//s1=ptr1=tar[0], align 8
	/* compute energy from Start-144 to Start-144+120 */
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	ltp		t4, (s1)+8
	li		t2, 2*SubFrLen/8-1	
	mtru	t2, lpc0
	multa2	m0, zero,zero		
	.align	3
1:
	madda2.s m0, t4, t4	;ltp	t6, (s1)+8
	madda2.s m0, t5, t5	;nop
	madda2.s m0, t6, t6	;ltp	t4, (s1)+8
	madda2.s m0, t7, t7	;nop
2:													// 12+4*120/8=72
	addma.s m0l, m0l, m0h;subu	s1, s1, 2*2*SubFrLen+8
	/* Energy update */
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t2, (PitchMax-2-PitchMin)
	mtru	t2, lpc0
	.extern Temp2
	la		t9, Temp2//t9=En[], 32bit array
	li		t0, PitchMax-2
	sll		t0, t0, 2	
	add		t9, t9, t0//t9=En[PitchMax-2]
	.align	3
1:	
	lh		t0, 0(s1)	
	lh		t1, (2*2*SubFrLen)(s1)	
	nop
	mfa		v1, m0l	
	msuba2.s m0l, t0, t0
	madda2.s m0l, t1, t1
	addu	s1, s1, 2
	swp		v1, (t9)-4	
2:													//13+6*126=769
	
	.extern tar
	la		s1, tar
	/*compute cross-correlation */
	li		t0, PitchMax-2-PitchMin+1+2;li t1, 2*SubFrLen
	sh		t0, 32(sp)	; move a0, s0//Len[0]	
	sh		t1, 34(sp)	; move a1, s1
	.extern Temp3
	la		a2, Temp3	//a2=CrossEn[0]
	li		t0, PitchMax-2
	sll		t0, t0, 2
	addu	a2, a2, t0	; addu	a3, sp, 32
	jal		crosscorrs
	nop												//12+(9+(128/4)(5+(120/4)*8+12))=12+8233=8245
	
/*
	
	sub		t9, a1, (PitchMin-1);	mfru s4, mmd//t9=Pr
	sll		t9, t9, 1	;	li		t5, 0x6
	mta2	zero, m1	;	addu	s1, a0, t9	//s0=ptr0
	mtru	t5, mmd		;	li		t6, 2*SubFrLen/4-1
	la		t4, 1f	
	la		t5, 2f-4
	mtru	t4, lps0	
	mtru	t5, lpe0	
	mtru	t6, lpc0
	lwp		t0, (s1)+4
	lwp		t1, (s1)+4
	.align	3
1:
	madda2.s m1, t0, t0	;	lwp	t0, (s1)+4
	madda2.s m1, t1, t1	;	lwp	t1, (s1)+4
2:
	addma.s	m1l, m1l, m1h;	sub	t9, t9, 2	//Pr=Pr-1
	mfa		s2, m1l		;	addu s1, a0, t9	//s2=Acc1
	addu	s0, a0, a1		//s1->&Dpnt[Pr]
	addu	s0, s0, a1		//s0->&Dpnt[Start]	
	subu	s0, s0, 2		// offset to even addr	
	subu	s1, s1, 2		// offset to even addr
	// Main Olp search loop 
	.extern Temp2
	.extern Temp3
	la		t8, Temp3	//t8->CrsooEn[]
	la		t9, Temp2	//t9->En[]
	addu	t8, t8, PitchMin*2;	addu	t9, t9, PitchMin*2
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t7, (PitchMax-2-PitchMin+1)/2		
	li		s5, 2*SubFrLen/4-1
	.align	3
4:	// for (i=PitchMin; i<=PitchMax-2; i+=2) {
	 	// compute the cross 
	mtru	s5, lpc0	;	multa2	m0, zero, zero
	lwp		t0, (s0)+4	//t0:[T3 T4]
	lwp		t1, (s0)+4	//t1:[T5 T6] t2:[T4 T5]
	lwp		t4, (s1)+4	//t4:[V3 V4]	
	lwp		t5, (s1)+4	//t5:[V5 V6]
	multa2	m2, zero, zero; mux2.lh	t2,t0,t1
	madda2.s m0l, t0, t4	;	nop
1:
	madda2.s m2, t2, t4	;	lwp	t0, (s0)+4
	madda2.s m0, t1, t5	;	lwp	t4, (s1)+4
	mux2.lh	t2, t1, t0	;	lwp	t1, (s0)+4
	madda2.s m2, t2, t5	;	lwp	t5, (s1)+4
	madda2.s m0, t0, t4	;	mux2.lh	t2,t0,t1
2: 
	msuba2.s m0l, t0, t4	// sub last sample in ptr0
	addma.s m2l, m2l, m2h
	
	addma.s	m0l, m0l, m0h ;	mfa		v1, m2l	
	mfa		v0, m0l		 ;	sw		v1, 4(t8)
	sw		v0, 0(t8)	;	subu	s0, s0, (2*SubFrLen+4)*2//s0->ptr0
	subu	s1, s1, (2*SubFrLen+4)*2	;addu	t8, t8, 8	//s1->ptr1
	 	// Energy update 
	lw		t0, 0(s1)	//t0=[p-1 p0]	
	lw		t1, (2*SubFrLen*2)(s1)
	multa2	m0, t0, t0
	msuba2.s m0, t1, t1
	mfa		v0, m0h	
	mfa		v1, m0l	
	addr.s	v1, v1, s2	//v1=Acc1
	addr.s	v0, v0, v1	//v0=Acc3	 
	swp		v1, (t9)+4
	swp		v0, (t9)+4
	
	subu	s1, s1, 4
	move	s2, v0		// Acc1=Acc3		

	sub		t7, t7, 1
	bgtz	t7, 4b
	nop
	// }	
*/
	
	/* search best pitch lag */
	li		s6, PitchMin	//s6->Indx
	li		s0, 30			//s0->Mxp
	li		s1, 0x00004000	//s1->Mcr
	li		s2, 0x00007fff	//s2->Mnr
	li		s5, PitchMin	//s5->i
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t6, (PitchMax-3-PitchMin+1)-1
	mtru	t6, lpc0
	la		at, Temp3	//at->CrossEn[0]
	la		s7, Temp2	//s7->En[0]
	add		at, at, PitchMin*4//at=CrossEn[PitchMin]
	add		s7, s7, PitchMin*4//s7=En[PitchMin]
1:	// for(i=PitchMin;i<=PitchMax-3;i++){
	lwp		t0, (at)+4	//t0=Acc0=CrossEn[i]
	lwp		t1, (s7)+4	//t1=Acc1=En[i]
	// 1st if
	blez	t0, 2f-4
	move	a0, t0
	/* compute Exp and mant of cross */
	jal		norm_l
	nop
	sll		t0, t0, v0	;	sll	t8, v0, 1//t8=Exp
	li		t4, 0x00008000
	addr.s	t0, t0, t4
	sra		t0, t0, 16
	multa2	m0l, t0, t0
	mfa		t9, m0l	//t9=Acc0
	jal		norm_l	//can't used t9 and t8
	move	a0, t9
	sll		t9, t9, v0
	add		t8, t8, v0//t8=Exp
	sra		t9, t9, 16//t9=Ccr
	/* do the same with energy */
	jal		norm_l
	move	a0, t1
	sll		t1, t1, v0	;sub t8, t8, v0	//t8=Exp
	li		t4, 0x00008000
	addr.s	t1, t1, t4
	sra		t1, t1, 16	//t1=Enr
	
	sub		t4, t9, t1
	bltz	t4, 3f
	nop
	sub		t8, t8, 1
	sra		t9, t9, 1
3:	// 2nd if
	sub		t4, t8, s0
	bgtz	t4, 2f-4
	add		t5, t4, 1 
	
	bgez	t5, 3f	//if (Exp+1) < Mxp
	nop
	move	s6, s5
	move	s0, t8
	move	s1, t9
	move	s2, t1	
	j		2f-4	// continue;
	nop
3:	
	sra		t4, s1, 1//t4=Mcr>>1
	cmvnez	t4, s1, t5	//t4=Tmp
	
	/* compare with equal exponents */
	multa2	m0l, t9, s2
	msuba2.s m0l, t1, t4
	// 3rd if
	mfa		v0, m0l
	nop
	blez	v0, 2f-4
	li		t5, PitchMin
	
	sub		t6, s5, s6
	sub		t6, t6, t5
	bgez	t6, 3f
	nop
	move	s6, s5
	move	s0, t8
	move	s1, t9	
	j		2f-4
	move	s2, t1
3:	
	multa2	m0l, t9, s2
	mfa		v0, m0l, 2
	sub		v0, zero, v0
	mfa		v1, m0l
	addr.s	v0, v0, v1	//L_mac(Acc0, Ccr, Mnr)
	multa2	m1l, t1, t4
	mfa		v1, m1l
	subr.s	v0, v0, v1	//L_msu(Acc0, Enr, Tmp)
	blez	v0, 2f-4
	nop
	move	s6, s5
	move	s0, t8
	move	s1, t9
	move	s2, t1	

	add		s5, s5, 1	//i++	
2:	// }
	move	v0, s6	

	////////////////	
	mtru	s4, mmd
	move	ra, s3
	lw		s7, 48(sp)
	lw		s6, 44(sp)
	lw		s5, 40(sp)
	lw		s4, 36(sp)
	lw		s3, 52(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	lw		at, 60(sp)
	jr		ra
	addu	sp, sp, 64

	.end	Estim_Pitchs
	
/*************************************************
void Comp_Pw( Word16 *Dpnt, Word16 Start, Word16 Olp, PWDEF *Pw )
	a0->Dpnt
	a1->Start
	a2->Olp
	a3->Pw
local:
	mmd -> s1
	Mcr->s4
	Mnr->s5
	ptr0->s6
	ptr1->s7
	Lcr[0:14]->sp(40:4:96)
	Scr[0:14]->sp(100:2:128)
Instruction:
	1049 clks	
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Comp_Pws
	.ent	Comp_Pws
Comp_Pws:
	subu	sp, sp, 168
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;	move	s0, a0
	sw		s4, 36(sp)	;	move	s2, a2
	sw		s5, 140(sp)	;	move	s3, a3
	sw		s6, 144(sp)	
	sw		s7, 148(sp)	
	sw		ra, 152(sp)
	///////////////////
	sll		a1, a1, 1	;	add		t4, a2, PwRange
	addu	s6, a0, a1	;	sll		t4, t4, 1	// s6=ptr0=&Dpnt[Start]
	subu	s7, s6, t4	;	mfru	s1, mmd		// s7=ptr1=&Dpnt[Start-(Olp-PwRange)]	
	li		t4, 0x6		
	mtru	t4, mmd
	/* compute and save target energy */
	la		t0, 1f
	la		t1, 2f-4	
	mtru	t0, lps0	;	move	t5, s6 		//t5->ptr0[0]
	mtru	t1, lpe0	;	subu	t4, s7, 2 	//t4->ptr1[-1]
	li		t2, SubFrLen/2-1
	mtru	t2, lpc0
	lhp		t0, (t4)+2	;	multa2	m0l, zero, zero
	lhp		t2, (t5)+2	;	multa2	m1l, zero, zero
	lhp		t1, (t4)+2	
	lhp		t3, (t5)+2					
1:	// for(i=0;i<SubFrLEn;i++) {	
	madda2.s m1l, t0, t0;	lhp		t0, (t4)+2
	madda2.s m1l, t1, t1;	lhp		t1, (t4)+2
	madda2.s m0l, t2, t2;	lhp		t2, (t5)+2
	madda2.s m0l, t3, t3;	lhp		t3, (t5)+2
2:	// }												// 27+30*4=147
	mfa		v0, m0l
	mfa		v1, m1l		
	sw		v0, 40(sp)	// store Lcr[0]
	/* compute all crosses and energys */
	li		t9, 2*PwRange/2
	mta2	v1, m1		// m1l=m1h=Acc1
	la		t4, 1f
	mta2	zero, m3	//m3=0
	la		t5, 2f-4
	mtru	t4,lps0
	addu	t7, sp, 96	//t7->Lcr[14]
	mtru	t5, lpe0								
4:	// for (i=0;i<2*PwRange; i+=2) {
	li		t8, SubFrLen/2-1
	mtru	t8, lpc0	
	lhp		t0, (s6)+2	; multa2 m0, zero,zero// ptr0[2]
	lhp		t1, (s6)+2	; multa2 m2, zero,zero// ptr0[3]
	lhp		t2, (s7)+2	// ptr1[2]
	lhp		t3, (s7)+2	// ptr1[3]
	.align	3
1:	// for (j=0; j<SubFrLen; j++) {
	madda2.s m0l, t0, t2;	lhp	t2, (s7)+2//m0=p0[0]p1[0]
	madda2.s m2l, t0, t3;	lhp	t0, (s6)+2//m1=p0[0]p1[1]
	madda2.s m0l, t1, t3;	lhp	t3, (s7)+2//m0=p0[1]p1[1]
	move	t4, t1		;	lhp	t1, (s6)+2
	madda2.s m2l, t4, t2				  //m1=p0[1]p1[2]
2:	// }	
	subu	s6, s6, (SubFrLen+2)*2
	mfa		v0, m0l	;	subu	s7, s7, (SubFrLen+2)*2
	mfa		v1, m2l	
	lh		t0, ((SubFrLen-1)*2)(s7)	
	lh		t1, (-2)(s7);
	lh		t2, ((SubFrLen)*2)(s7)	
	madda2.s m1l, t0, t0;	lh	t3, 0(s7)
	msuba2.s m1l, t1, t1;	sw	v0, 0(t7)	// Lcr[14]=Acc0
	multa2	m3l, t2, t2	;	sw	v1, -8(t7)	// Lcr[12]=Acc2
	msuba2.s m3l, t3, t3;	mfa	v0, m1l
	addma.s	m3l, m3l, m1l;	sw	v0, -4(t7)	// Lcr[13]=Acc1
	mfa		v1, m3l	;		addu	s7, s7, 4
	/* save both */			
	sw		v1, -12(t7)	;	subu	t7, t7, 16//Lcr[11] = Acc3
	mta2	v1, m1		;	sub		t9, t9, 1
	bgtz	t9, 4b
	nop
	//}												// 13+3*(6+30*5+16)=
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t6, SubFrLen/2-1
	mtru	t6, lpc0
	
	lhp		t0, (s6)+2	;	multa2	m0l,zero,zero
	lhp		t1, (s6)+2
	lhp		t2, (s7)+2
	lhp		t3, (s7)+2	;	nop
	.align	3
1:
	madda2.s m0l, t0, t2;	lhp	t0, (s6)+2
	madda2.s m0l, t1, t3;	lhp	t2, (s7)+2
	lhp		t1, (s6)+2
	lhp		t3, (s7)+2
2:														// 130
	lh		t0, -6(s7)
	lh		t1, -((SubFrLen+3)*2)(s7)
	madda2.s m1l, t0, t0; mfa	v0, m0l
	msuba2.s m1l, t1, t1; sw	v0, 0(t7)	// Lcr[2]=Acc0
	mfa		v1, m1l	
	nop
	sw		v1, -4(t7)	// Lcr[1]=Acc1
	
	/* Normalize to maximum */
	addu 	t0, sp, 40//t0->Lcr[0]			
	la		t4, 1f	
	lwp		t1, (t0)+4	
	la		t5, 2f-4
	mtru	t4, lps0	;	li	t6, 15-1
	mtru	t5, lpe0	;	li	a0, 0	//a0=Acc1
	mtru	t6, lpc0	
1:	
	absr.s	t2, t1		
	lwp		t1, (t0)+4
	max		a0, t2, a0
2:												// 13+15*2=43
	subu	t0, t0, (15+1)*4//t0->Lcr[0]
	jal		norm_l
	nop
	
	la		t4, 1f
	la		t5, 2f-4
	lwp		t1, (t0)+4
	li		t2, 0x00008000
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t6, 15-1
	mtru	t6, lpc0	
	addu	t3, sp, 100//t3->Scr[0]	
1:
	sll		t4, t1, v0	;	lwp		t1, (t0)+4
	addr.s	t4, t4, t2
	sra		t4, t4, 16
	shp		t4, (t3)+2
2:													//34+4*15=94
	/* Find the best pair */
	li		t0, -1	;	sh	zero, 2(s3)
	li		s4, 1	;	sh	t0, 0(s3)	//s4=Mcr
	li		s5, 0x00007fff				//s5=Mnr
	addu	t3, sp, 102		//t3->Scr[1]
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t6, 2*PwRange
	mtru	t6, lpc0	
	li		t1, 0		//t1=i
1:
	lh		t5, 2(t3)	// t5=Ccr
	lh		t4, 0(t3)	// t4=Enr
	addu	t3, t3, 4
	blez	t5, 2f-4
	nop
	multa2	m0l, t5, t5
	mfa		v0, m0l
	addr.s	v0, v0, t2
	sra		v0, v0, 16	//v0=Exp
	/* compute the cross */
	multa2	m0l, v0, s5
	msuba2.s m0l, t4, s4
	mfa		v1, m0l
	blez	v1, 2f-4
	nop
	move	s4, v0	
	sh		t1, 0(s3)	//Pw->Indx = i
	move	s5, t4
	add		t1, t1, 1	//i++	
2:
	lh		t1, 0(s3)
	nop
	bgez	t1, 3f
	nop
	sh		s2, 0(s3)	//Pw->Indx=Olp
	nop
	j		Comp_Pws_exit
	nop
3:	
	/* Check the db limit */
	lh		t0, 100(sp)	// Scr[0]
	lh		t1, 0(s3)	//t1=Pw->Indx
	multa2	m0l, t0, s5	;	sll		t2, t1, 1
	addu	t2, t2, 2	;	mfa		v0, m0l, 2 //v0=L_shr(Acc0,2)
	sll		t2, t2, 1	;	mfa		v1, m0l, 3 //v1=L_shr(Acc0,3)
	addu	t2, sp, t2	;	addr.s	v0, v0, v1
	addu	t2, t2, 100
	lh		t2, 0(t2)	// t2->Scr[2*Pw->Indx+2]
	nop
	multa2	m0l, t2, t2
	mfa		v1, m0l
	subr.s	v0, v0, v1
	
	bgez	v0, 3f
	li		t4, PwConst
	sub		t3, t2, s5	//t2=Exp
	// if(Exp>= Mnr)
	bltz	t3, 4f
	nop
	sh		t4, 2(s3)
	nop
	j		3f	
	nop
	// else
4:	
	move	a0, t2	
	jal		div_s
	move	a1, s5
	li		t4, PwConst
	multa2	m0l, v0, t4
	li		t5, 0x00008000
	mfa		v0, m0l	
	addr.s	v0, v0, t5
	sra		v0, v0, 16
	sh		v0, 2(s3)	
3:
	add		t1, t1, s2
	sub		t1, t1, PwRange
	sh		t1, 0(s3)
	///////////////////
Comp_Pws_exit:	
	mtru	s1, mmd
	lw		ra, 152(sp)
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		s4, 36(sp)
	lw		s5, 140(sp)
	lw		s6, 144(sp)
	lw		s7, 148(sp)	
	jr		ra
	addu	sp, sp, 168							//100
	
	.end	Comp_Pws

/****************************************************
void  Find_Best( BESTDEF *Best, Word16 *Tv, Word16 *ImpResp, Word16 Np, Word16 Olp )
	s0->Best
	s1->Tv
	s2->ImpResp,WrkBlk
	s3->Np
	t0->Olp		//GHS pass Olp via t0
				//GNU pass Olp via 16(sp)
local:	
	MaxAmp->44(sp)
	t8->48(sp)
	t9->52(sp)
	MaxAmpId->56(sp)
	s4->best
	best.MaxErr->best+0
	best.GridId->best+4
	best.MampId->best+6
	best.UseTrn->best+8
	best.Ploc[6]->best+12~best+23					   
	best.Pamp[6]->best+24~best+35
	ploc[0]->best+36
	acc[0]->best+40
	ploc[1]->best+44
	acc[1]->best+48
	
	Imr->Imr		//define in exc_lbcs.asm
	OccPos->OccPos
	ImrCorr->ImrCorr
	ErrBlk->ErrBlk
	WrkBlk->WrkBlk
*/	
	.text
	.set	noat
	.set	noreorder
	.globl	Find_Bests
	.ent	Find_Bests
Find_Bests:
	subu	sp, sp, 128
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;move	s0, a0
	sw		ra, 36(sp)	;move	s1, a1
	sw		s4, 40(sp)	;move	s2, a2
	mfru	t9, mmd		;move	s3, a3
	sw		t9, 60(sp)	;li		t1, 0x6	
	sw		s5, 64(sp)	
	sw		s6, 68(sp)
	sw		s7, 72(sp)
	sw		at, 76(sp)
	mtru	t1, mmd
	//////////////////////
	/* Update impulse response */	
	lw		t0, (16+128)(sp)		// for GNU, load Olp from stack
	la		s4, best			// s4->best
	sub		t4, t0, SubFrLen-2	//Olp-(SubFrLen-2)	
	la		s5, Imr				// s5->Imr
	move	a0, s5
	move	a1, s2	
	bgez	t4, 1f
	nop
	// if (Olp<SubFrLen-2)
	li		t4, 1
	sh		t4, 8(s4)	//best.UseTrn=1
	jal		Gen_Trn
	move	a2, t0	
	j		2f
	nop
1:	// else	
	sh		zero,8(s4)	//best.UseTrn=0
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t2, SubFrLen/4-1
	mtru	t2, lpc0
	move	t4, s2		//t4->ImpResp	
	move	a0, s5		//a0->Imr
1:	
	lwp		t0, (t4)+4
	lwp		t1, (t4)+4
	nop
	stp		t0, (a0)+8
	nop	
2:	
	/* Scale Imr to avoid overflow */
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t2, SubFrLen/2-1	
	mtru	t2, lpc0
	move	a0, s5				//a0->Imr
	lwp		t0, (a0)+4
	la		s6, OccPos			//s6->OccPos	
	move	a1, s6
	li		t2, 1
	.align	3
1:	
	lwp		t1, (a0)+4;	srav2	t0, t0, t2
	swp		t0, (a1)+4
	move	t0, t1
2:	
	/* compute Imr AutoCorr function */
	// paddig 4 zero to OccPos
	la		s7, ErrBlk			//s7->ErrBlk
	swp		zero, (a1)+4;move	a0, s6
	swp		zero, (a1)+4;move	a2, s7
	move	a1, s6		;li		a3, SubFrLen
	jal		crossconvs
	nop
	lw		a0, 0(s7)
	jal		norm_l			//v0=Exp
	nop
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		t2, SubFrLen/2-1
	mtru	t2, lpc0
	la		at, ImrCorr			//at->ImrCorr	
	move	a0, s7		//a0->ErrBlk
	lt		t0, 0(a0)
	move	a1, at		//a1->ImrCorr	
	.align	3
1:
	lt		t2, 8(a0);	sll		t0, t0, v0
	sll		t1, t1, v0;	li		t6, 0x00008000
	//add		t4, t0, t6;	add		t5, t1, t6
	addr.s	t4, t0, t6;	addr.s	t5, t1, t6
	sra		t5, t5, 16;	stp		t0, (a0)+8		//ErrBlk[]=ErrBlk[]<<Exp
	mux2.hl	t4, t4, t5; move	t0, t2
	swp		t4, (a1)+4;	move	t1, t3			//ImrCorr[]=round(ErrBlk[])
2:	
	/* Cross correlation with the signal */
	sub		v0, v0, 4;move	a0, s1	//v0=Exp	
	move	a1, s5	;move	a2, s7
	jal		crossconvs
	li		a3, SubFrLen
	move	a0, s7		//a0->ErrBlk
	bltz	v0, 3f
	li		t2, SubFrLen/2-1
	//if(Exp >=0)
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	.align	3
1:		
	lt		t0, 0(a0)
	nop
	sll		t0, t0, v0
	sll		t1, t1, v0
	stp		t0, (a0)+8
	nop
2:	
	j		4f
	nop
3:	//else	
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	sub		v0, zero, v0	//v0=-Exp
	.align	3
1:		
	lt		t0, 0(a0)
	nop
	sra		t0, t0, v0
	sra		t1, t1, v0
	stp		t0, (a0)+8
	nop
2:		
4:
	/* Find maximum amplitude */
	li		t0, 0	; li	t1, 0	//acc0,acc1
	li		t6, 0	; li	t7, 0	//ploc[0],ploc[1]
	la		t2, 1f
	la		t3, 2f-4
	mtru	t2, lps0
	mtru	t3, lpe0	
	move	a0, s7		//a0->ErrBlk
	ltp		t2, (a0)+8
	li		t4, SubFrLen/2-1
	mtru	t4, lpc0
	li		t9, 0		//t9=i
1:
	absr.s	v0, t2	;absr.s	v1, t3	//t2=Acc0,t3=Acc2
	subr.s	t4, v0, t0;subr.s t5, v1, t1
	ltp		t2, (a0)+8
	bltz	t4, 3f
	nop
	move	t0, v0
	move	t6, t9	
3:	bltz	t5, 2f-4
	addu	t8, t9, 1	//i+1
	move	t1, v1
	move	t7, t8
	
	addu	t9, t9, 2
2:
	sh		t6, 36(s4)		//ploc[0]
	sw		t0, 40(s4)		//acc[0]
	sh		t7, 44(s4)		//ploc[1]
	sw		t1, 48(s4)		//acc[1]
	
	/*Reorder Imr vector */
	la		t0, 1f
	la		t1, 2f-4
	la		t2, SubFrLen/4-1
	mtru	t0, lps0;move	a0, s5
	mtru	t1, lpe0;addu	a1, s5, 2*(SubFrLen-1)
	mtru	t2, lpc0;subu	a1, a1, 2//a1->Imr[58]
1:	
	lw		t0, 0(a1)	
	lw		t1, 0(a0)
	mux2.lh	t2, t0, t0
	swp		t2, (a0)+4
	mux2.lh	t1, t1, t1	
	swp		t1, (a1)-4
2:
	addu	a0, s5, 2*SubFrLen
	swp		zero, (a0)+4
	swp		zero, (a0)+4	

	/* search for the best sequence */
	// for(k=0; k<Sgrid; k++) {
	li		t9, 0			// t9=k
							// at=ImrCorr
	la		s2, WrkBlk		// s2=WrkBlk
							// s4=best
							// s5=Imr
							// s6=OccPos
							// s7=ErrBlk
loop_k:								
	sll		t4, t9, 3
	addu	t4, t4, s4	
	addu	t4, t4, 36		//t4->ploc[0] or ploc[1]
	lh		t0, 0(t4)		//ploc[]
	lw		t1, 4(t4)		//t1=acc[]=Acc2
	sh		t0, 12(s4)		//best.Ploc[0]=ploc[k]
	sh		t9, 4(s4)		//best.GridId=k
	/* Quantize the maximum amplitude */
	li		t8, NumOfGainLev-MlqSteps//t8=MaxAmpId
	li		t0, 0x40000000	//t0=Acc1
	move	t7, t8			//t7=i
	// for 1
	la		t2, 1f	
	la		t3, 2f-4
	mtru	t2, lps0
	mtru	t3, lpe0	
	la		t2, FcbkGainTable	
	lh		t4, 0(at)		//t4=ImrCorr[0]	
	addu	t2, t2, t8
	addu	t2, t2, t8
	lhp		t3, (t2)-2		//t3=FcbkGainTable[i]
	sub		t5, t8, MlqSteps
	mtru	t5, lpc0
1:
	multa2	m0l, t3, t4	;mta2	t1, m1
	subma.s m0l, m0l, m1l;lhp	t3, (t2)-2
	mfa		v0, m0l
	absr.s	v0, v0
	sub		t5, v0, t0
	bgez	t5, 2f-4
	nop
	move	t0, v0		//t0 = Acc1
	move	t8, t7
			
	sub		t7, t7, 1
2:	// end for 1
	sub		t4, t8, 1	//t4=MaxAmpId--	
	sw		t4, 56(sp)	//push to stack
	// for 2	
	li		t8, 1		//t8=i
loop_i:
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	sll		t5, t9, 2	//t5=k*4
	addu	a0, s2, t5	//a0->WrkBlk[j]
	addu	a1, s7, t5	//a1->ErrBlk[j]
	sll		t6, t9, 1
	addu	a2, s6, t6	//a2->OccPos[j]
	lwp		t0, (a1)+8
	lw		t4, 56(sp)	//t4=MaxAmpId
	.align	3
1:	
	lwp		t1, (a1)+8
	swp		t0, (a0)+8
	shp		zero, (a2)+4;move	t0, t1	
2:		
	
	sub		t4, t4, MlqSteps
	add		t4, t4, t8		//t4=MaxAmpId-MlqSteps+i
	sh		t4, 6(s4)		//best.Mampld
	sll		t5, t4, 1
	la		t6, FcbkGainTable
	addu	t6, t6, t5
	lh		t5, 0(t6)		//t5=MaxAmp
	
	lh		t4, 12(s4)
	sh		t5, 44(sp)		//push MaxAmp to 44(sp)
	sll		t4, t4, 2
	addu	t4, t4, s2		//t4->WrkBlk[best.Ploc[0]]
	lw		t4, 0(t4)
	sub		t6, zero, t5	//t6=-MaxAmp
	slt		t0, t4, zero
	cmvnez	t5, t6, t0		//if lt zero, t5 = -MaxAmp
	sh		t5, 24(s4)		//best.Pamp[0]=+-MaxAmp
		
	lh		t4, 12(s4)
	li		t5, 1
	sll		t4, t4, 1
	addu	t4, t4, s6	
	sh		t5, 0(t4)		//OccPos[best.Ploc[0]] = 1
	//for 3
	li		t7, 1			//t7=j
	addu	a3, s4, 12		//a3->best.Ploc[0]
	addu	a2, s4, 24		//a2->best.Pamp[0]
loop_j:	
	lhp		t0, (a3)+2		//t0=best.Ploc[j-1]
	li		v1, 0xc0000000;	//v1=Acc1
	sub		t6, t9, t0		//t6=ind=k-best.Ploc[j-1]
	
	lhp		t4, (a2)+2		//t4=best.Pamp[j-1]
	// for 4
	move	t5, t9			//t5=l
	sll		t3, t5, 1
	addu	a0, s6, t3		//a0->OccPos[l]
	addu	a1, s2, t3
	addu	a1, a1, t3		//a1->WrkBlk[l]
loop_l:
	lhp		t0, (a0)+4
	lwp		t1, (a1)+8		//t1=WrkBlk[l]
	bnez	t0, 4f
	nop
		
	absr.s	t2, t6
	sll		t2, t2, 1
	addu	t2, t2, at		//t2->ImrCorr[abs_s(ind)]
	lh		t2, 0(t2)
	mta2	t1, m0
	msuba2.s m0l, t4, t2
	mfa		v0, m0l
    nop
	sw		v0, -8(a1)
	absr.s	t0, v0
	subr.s	t1, t0, v1		//prevent overflow
	blez	t1, 4f
	nop
	move	v1, t0
	move	t3, t5			//t3=best.Ploc[j]
	// end for 4 (l)
4:	
	addu	t6, t6, Sgrid
	addu	t5, t5, Sgrid
	sub		t0, t5, SubFrLen
	bltz	t0, loop_l
	nop
	
	sh		t3, 0(a3)		//best.Ploc[j]=l
	
	sll		t0, t3, 2		//t0->WrkBlk[best.Ploc[j]]
	addu	t0, t0, s2
	lw		t0, 0(t0)
	lh		t1, 44(sp)	//t1=MaxAmp
	slt		t0, t0, zero	//if(t0 < 0, t0 = 1)
	sub		t2, zero, t1//t2=-MaxAmp
	cmvnez	t1, t2, t0
	sh		t1, 0(a2)	//best.Pamp[j]=+-MaxAmp

	sll		t3, t3, 1
	addu	t3, t3, s6
	li		t0, 1
	sh		t0, 0(t3)	//OccPos[best.Ploc[j]] = 1
	// end for 3 (j)
	addu	t7, t7, 1
	sub		t0, t7, s3
	bltz	t0, loop_j
	nop	
	/* Compute error vector */
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	
	mtru	t1, lpe0	
	li		t2, SubFrLen/6-1
	mtru	t2, lpc0
	move	a0, s6		//a0->OccPos	
1:
	swp		zero,(a0)+4
	swp		zero,(a0)+4
	swp		zero,(a0)+4
2:			
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0;addu	a0, s4, 12	//a0->best.Ploc[0]
	mtru	t1, lpe0;addu	a1, s4, 24	//a1->best.Pamp[0]
	sub		t2, s3, 1;move	a2, s6		//a2->OccPos
	mtru	t2, lpc0 
1:
	lhp		t1, (a0)+2
	lhp		t0, (a1)+2
	sll		t1, t1, 1
	addu	t1, t1, a2
	sh		t0, 0(t1)
2:	
	// for 5
	sw		t8, 48(sp)	//store t8, t9
	sw		t9, 52(sp)
	move	a0, s5		;move	a1, s6
	addu	a2, sp, 0	;li		a3, SubFrLen
	jal		crossconv2s
	nop
	lw		t8, 48(sp)
	lw		t9, 52(sp)	
	
	/* Evaluate error */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/4-1
	mtru	t0, lps0	; move	a0, s1//a0->Tv
	mtru	t1, lpe0	; move	a1, s6//a1->OccPos
	mtru	t2, lpc0	; multa2 m0,zero,zero
	ltp		t0, (a0)+8	; multa2 m1,zero,zero
	lwp		t4, (a1)+4	; nop
	.align	3
1:
	//t0:[T0 T1]t1:[T2 T3]
	//t4:[O0 O1]t5:[O2 O3]
	madda2.s m0, t0, t4	;lwp	t5, (a1)+4
	madda2.s m1, t4, t4	;lwp	t0, (a0)+4
	madda2.s m0, t1, t5	;lwp	t4, (a1)+4	
	madda2.s m1, t5, t5	;lwp	t1, (a0)+4	
2:	
	addma.s m0l,m0l,m0h
	addma.s m1l,m1l,m1h
	mfa		v0, m0l
	mfa		v1, m1l
	sra		v1, v1, 1
	subr.s	v0, v0, v1	//v0=Acc1=L_sub(Acc1,Acc2)
	/* Memory copy */
	lw		t0, 0(s0)	//t0=Best.MaxErr
	nop	
	subr.s	t0, v0, t0
	blez	t0, 3f
	la		t1, 1f
	la		t2, 2f-4
	li		t3, 32/8-1
	mtru	t1, lps0	;addu	a0, s0, 4
	mtru	t2, lpe0	;addu	a1, s4, 4
	mtru	t3, lpc0	
1:
	lwp		t0, (a1)+4
	lwp		t1, (a1)+4
	swp		t0, (a0)+4
	swp		t1, (a0)+4
2:
	sw		v0, 0(s0)	//Best.MaxErr=Acc1
	
3:	// end for 2 (lop_i)
	addu	t8, t8, 1
	sub		t0, t8, 2*MlqSteps+1
	bltz	t0, loop_i
	nop
	// end k
	add		t9, t9, 1
	sub		t0, t9, Sgrid
	bltz	t0, loop_k
	nop	
	
	//////////////////////
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		ra, 36(sp)
	lw		s4, 40(sp)
	lw		t9, 60(sp)	
	lw		s5, 64(sp)
	lw		s6, 68(sp)
	lw		s7, 72(sp)	
	lw		at, 76(sp)
	mtru	t9, mmd
	jr		ra
	addu	sp, sp, 128
	.end	Find_Bests	

/* 
void convol(Word16 *xbuf,	order: x0 x1 x2 ... xN-1 (len = N)
			Word16 *imp,	order: iN-1 iN-2 ... i2 i1 i0 z z z z (pad 4 zeros)(len=N+4)
			Word16 *convEn,	
			int Len) 
 NOTE. 1) xbuf and imp must align on 8 boundary
 	   2) order of imp is inversion of h[]
 	   3) has to pad 4 zeros to imp tail
 	   4) Len should be a multiple of 4
 	   5) produce 4 convEn each inner loop 
 	   6) assume 32bit sature and fractinal mode
*/
	.text
	.set	noat
	.set	noreorder
	.globl	convols
	.ent	convols
convols:
	subu	sp, sp, 40
	sw		s0, 20(sp)
	sw		s1, 24(sp)	;sub	t0, a3, 4	//Len-4
	sw		s2, 28(sp)	;sll	t0, t0, 1	//2*(Len-4)
	sw		s3, 32(sp)	;move	s0, a0		//s0->xbuf
	addu	s1, a1, t0	//s1->imp[Len-4]
	////////////////
	li		s2, 0		// inner loop cnter=s2+1
	sra		s3, a3, 2	//s3=Len/4=outer loop cnter		
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0	
	.align	3
3:	// outer loop cnter	
	move	a0, s0		//a0->xbuf[0]
	move	a1, s1		//a1->imp[Len-4]
	mtru	s2, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a0)+8	;multa2	m1,zero,zero
	ltp		t4, (a1)+8	;multa2	m2,zero,zero
	lt		t6, 0(a1)	;multa2	m3,zero,zero
	move	t0, t2		;nop
1:
	// x t0:[0 1]t1:[2 3]t2:[4 5]t3:[6 7]
	// i t4:[z z]t5:[z z]t6:[z z]t7:[z z] t8:[z z]
	madda2.s m3, t0, t4	;move	t1, t3	//t9:[0 z]
	madda2.s m3, t1, t5	;ltp	t2, (a0)+8
	madda2.s m1, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m1, t1, t6	;mux2.lh t9, t5, t6
	madda2.s m2, t0, t8	;ltp	t4, (a1)+8
	madda2.s m2, t1, t9	;mux2.lh t8, t6, t7
	madda2.s m0, t0, t9	;lt		t6, 0(a1)
	madda2.s m0, t1, t8	;move	t0, t2
2:
	addma.s m3l,m3l,m3h	;addma.s m2l,m2l,m2h
	addma.s m1l,m1l,m1h	;addma.s m0l,m0l,m0h
	mfa		t3, m3l		;addu	s2, s2, 1	//inc inner loop cnter
	mfa		t2, m2l		;subu	s1, s1, 8	//offset s1 pointer to next 4 samples
	mfa		t1, m1l
	mfa		t0, m0l
	sw		t3, 12(a2)	//store conv[i+3:i]
	sw		t2, 8(a2)	
	sw		t1, 4(a2)
	sw		t0, 0(a2)
	// end outer loop
	sub		s3, s3, 1	//dec outer loop cnter
	bgtz	s3, 3b
	addu	a2, a2, 4*4	//inc convEn pointer
	
	////////////////
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	jr		ra
	addu	sp, sp, 40

	.end	convols

/*****************************************************
void  Find_Acbk( Word16 *Tv, Word16 *ImpResp, Word16 *PrevExc, LINEDEF *Line, Word16 Sfc )
	s0->Tv		
	s1->ImpResp,Imrv (align 4)
	s2->PrevExc
	a3->Line
	t0->Sfc			// for GHS, pass Sfc via t0
					// for GNU, pass Sfc via 16(sp)
local:
	RezBuf2->s3
	FltBuf->s4
	CorBuf->s5
	CorVct,k->s6
	lPnt->s7
	28(sp)->Line
	32(sp)->Sfc
	36(sp)->Olp
	40(sp)->Lid
	44(sp)->Gid
	48(sp)->Hb
	52(sp)->Bound[0]
	56(sp)->Bound[1]
	60(sp)->mmd	
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	Find_Acbks
	.ent	Find_Acbks
Find_Acbks:
	lw		t0, 16(sp)	//for GNU, load Sfc from stack
	nop
	mfru	t4, mmd
	subu	sp, sp, 128	
	sw		s0, 20(sp)
	sw		s1, 64(sp)
	sw		s2, 68(sp)
	sw		s3, 72(sp)	;move	s0, a0//s0->Tv
	sw		s4, 76(sp)	;move	s1, a1//s1->ImpResp
	sw		s5, 80(sp)	;move	s2, a2//s2->PrevExc
	sw		s6, 84(sp)
	sw		a3, 28(sp)	//28(sp)->Line
	sw		t0, 32(sp)	//32(sp)->Sfc
	sw		t4, 60(sp)	//60(sp)->mmd
	sw		at, 88(sp)
	sw		ra, 92(sp)
	sw		s7, 96(sp)
	/////////////////////
	/* Init constants */
	lw		t0, 32(sp)	//t0=Sfc
	lw		a3, 28(sp)	//a3=Line
	sra		t4, t0, 1	;addu	a3, a3, 8	//Line.Olp
	sll		t4, t4, 1	;li		t5, Pstep
	addu	a3, a3, t4	;sw		t5, 40(sp)	//Lid=Pstep
	lh		v0, 0(a3)	;and	t4, t0, 0x1	//v0=Olp
	add		t5, t4, 3	;sw		zero,44(sp)	//Gid=0
	sw		t5, 48(sp)		//Hb	
	/* For even frames only */
	bnez	t4, 1f
	add		t5, v0, 1	//t5=Olp+1
	sub		t3, v0, PitchMin
	cmveqz	v0, t5, t3
	li		t6, PitchMax-5
	min		v0, v0, t6
1:	
	sw		v0, 36(sp)	//36(sp)=Olp
	/* inverse order of ImpResp */
	la		t0, 1f
	la		t1, 2f-4
	la		t2, SubFrLen/4-1	
	mtru	t0, lps0
	mtru	t1, lpe0;addu	a1, s1, 2*(SubFrLen-1)
	mtru	t2, lpc0;subu	a1, a1, 2//a1->ImpResp[58]	
	la		s1, Imrv	//s1->Imrv
	move	a0, s1		//a0->Imrv[0]
1:	
	lwp		t0, (a1)-4	//t0=58 59
	lwp		t1, (a1)-4	//t1=56 57
	mux2.lh	t0, t0, t0	//t0=59 58
	mux2.lh	t1, t1, t1	//t1=57 56
	swp		t0, (a0)+4
	swp		t1, (a0)+4
2:	
	swp		zero, (a0)+4
	swp		zero, (a0)+4			
	
	// for 1
	la		s3, RezBuf2	//s3->RezBuf2
	la		s5, CorBuf	//s5->CorBuf(Word32)
	move	s7, s5		//s7->lPnt(Word32)
	li		s6, 0		//s6->k=0	
loop_k1:
	/* Get residual from the excitation buffer */
	lw		t4, 36(sp)	;move	a0, s3	
	sub		t3,zero,Pstep;move	a1, s2	
	add		t3, t3, s6	
	jal		Get_Rezs
    //jal     Get_Rez
	add		a2, t4, t3
	/* Filter the last one using the impulse response */
	addu	a0, s3, ClPitchOrd-1	;move	a1, s1
	li		t4, 0x6					;addu	a0,a0,ClPitchOrd-1
	mtru	t4, mmd		//fractional and 32 sature
	la		a2, ConvEn	
	jal		convols
	li		a3, SubFrLen
	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	la		a0, ConvEn	//a0->ConvEn	
	la		s4, FltBuf	//s4->FltBuf
	ltp		t0, (a0)+8	;li		t4, 0x00008000
	mtru	t2, lpc0	;addu	a1, s4, (ClPitchOrd-1)*2*SubFrLen	
							//a1->FltBuf[][0]
	.align	3
1:
	addr.s	t2, t0, t4	;addr.s	 t3, t1, t4
	ltp		t0, (a0)+8	;mux2.hh t3, t2, t3
	swp		t3, (a1)+4	;nop
2:	
	
	/* Update all the others */
	li		t8, ClPitchOrd-2	
	addu	a2, s3, 2*(ClPitchOrd-2)
	addu	a1, s4, (ClPitchOrd-2)*2*SubFrLen	
	//a0=FltBuf[i+1][0]	//a1=FltBuf[i][0]
	//a2=RezBuf2[i]		//a3=Imrv[58]	
	//t8=i=ClPitchOrd-2
	.align	3
3:	
	addu	a0, a1, 2*SubFrLen	
	addu	a3, s1, 2*(SubFrLen-2)	
	li		t0, 0x2000	;lhp	t1, (a2)-2//t1=RezBuf2[i]
	li		t2, 0x00008000;lhp	t3, (a3)-4//t3=Imrv[58]
	multa2	m0l, t0, t1	;lwp	t4, (a0)+4//t4=FltBuf[i+1][0]
	multa2	m1l, t1, t3	;li		t6, 0xffff0000
	mfa		v0, m0l		;and	t5, t4, t6
	mfa		v1, m1l		;addr.s	v0, v0, t2	
	addr.s	v1, v1, t5	;sra	v0, v0, 16
	addr.s	v1, v1, t2	;li		t6, (SubFrLen-2)/2-1
	mux2.lh	v0, v0, v1	;mux2.ll t1, t1, t1	
	swp		v0, (a1)+4
	la		t0, 1f
	la		t5, 2f-4	
	mtru	t0, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	//a3=Imrv[56] t4=F[i+1][0:1] t1=RezBuf2[i i]	
	//t5=F[i+1][2:3] t6=I[56 57]
	.align	3
1:
	//v0=Acc0=FltBuf[i+1][1]
	sll		v0, t4, 16	;lwp	t6, (a3)-4	
	lwp		t5, (a0)+4	;li		t2, 0x00008000	
	multa2	m0, t6, t1	;li		v1, 0xffff0000
	mfa		t0, m0l		;and	v1, t5, v1
	mfa		t7, m0h		;addr.s	t0, t0, v0
	addr.s	t7, t7, v1	;move	t4, t5
	addr.s	t0, t0, t2	;addr.s	t7, t7, t2
	mux2.hh	t0, t0, t7
	swp		t0, (a1)+4
2:	
	sub		t8, t8, 1	
	bgez	t8, 3b
	sub		a1, a1, 2*2*SubFrLen	

	/* Compute the cross with the signal */	
	/* Compute the energies */		
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/4-1
	mtru	t0, lps0	;move	a1, s4	//a1->FltBuf[0][0]
	mtru	t1, lpe0	;li		t9, 5	//t9=outer loop cnter	
3:
	mtru	t2, lpc0	;move	a0, s0	//a0->Tv
	multa2	m0, zero, zero
	multa2	m1, zero, zero
1:	
	// t0:[0 1]t1:[2 3]t6:[4 5]t7:[6 7]
	// t4:[0 1]t5:[2 3]	
	ltp		t0, (a0)+8
	ltp		t4, (a1)+8
	nop
	madda2.s m0, t0, t4	
	madda2.s m0, t1, t5
	madda2.s m1, t4, t4
	madda2.s m1, t5, t5
2:	
	addma.s	m0l,m0l,m0h	;sub	t9, t9, 1	
	addma.s m1l,m1l,m1h	;mfa	v0, m0l
	mfa		v1, m1l
	swp		v0, (s7)+4
	sw		v1, 16(s7)
	bgtz	t9, 3b
	nop
	
	addu	s7, s7, 5*4	//lPnt += 5

	/* Compute the between crosses */	
	addu	a0, s4, 2*SubFrLen	//a0->FltBuf[1][0]	
	move	a2, a0
	li		t9, ClPitchOrd-1	//t9=i
	li		t8, 1				//t8=i
	la		t0, 1f
	la		t1, 2f-4
	li		t6, SubFrLen/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
5:	//for(i=1; i<ClPitchOrd; i++) {
	move	t7, t8	;move	a1, s4//a1->FltBuf[0][0]
4:		//for(j=0; j<i; j++) {
	mtru	t6, lpc0	;multa2	m0,zero,zero
	move	a2, a0
1:			//for(l=0; l<SubFrLen; l++) {
	ltp		t0, (a2)+8
	ltp		t2, (a1)+8
	nop
	madda2.s m0, t0, t2
	madda2.s m0, t1, t3	
2:			//} l
	addma.s m0l,m0l,m0h
	addma.s m0l,m0l,m0l
	mfa		v0, m0l
	swp		v0, (s7)+4	// *lPnt++=L_shl(Acc1, 1)	
		//} j
	sub		t7, t7, 1
	bgtz	t7, 4b
	nop
	
	add		t8, t8, 1
	//} i
	sub		t9, t9, 1
	bgtz	t9, 5b
	addu	a0, a0, 2*SubFrLen
	
	// end for 1
	lw		t0, 48(sp)	;add	s6, s6, 1
	sub		t3, s6, t0
	bltz	t3, loop_k1
	nop
	
	/* Find Max and normalize */	
	lw		t0, 48(sp)	;li		a0, 0//Acc1=0 //t0=Hb	
	li		t1, 20		;move	a1, s5//a1->CorBuf[0]
	multa2	m0l, t0, t1		
	ltp		t0, (a1)+8	
	la		t4, 1f	
	mfa		t9, m0l, 2	//t9=Hb*20/2
	la		t5, 2f-4	
	mtru	t4, lps0
	mtru	t5, lpe0
	sub		t9, t9, 1
	mtru	t9, lpc0
	.align	3
1:
	absr.s	t2, t0		;absr.s	t3, t1
	max		t2, t2, t3	;ltp	t0, (a1)+8
	max		a0, a0, t2	;nop
2:	
	jal		norm_l
	nop
	
	/* Convert to shorts */
	la		t0, 1f
	la		t1, 2f-4
	move	a1, s5
	ltp		t4, (a1)+8
	mtru	t0, lps0
	la		s6, CorVct	//s6->CorVct
	mtru	t1, lpe0
	move	a2, s6		//a2->CorVct
	mtru	t9, lpc0	
	li		t6, 0x00008000
	.align	3
1:
	sllv	t0, t4, v0	;sllv	t1, t5, v0
	addr.s	t0, t0, t6	;addr.s	t1, t1, t6
	mux2.hh	t0, t0, t1	;ltp	t4, (a1)+8
	swp		t0, (a2)+4	;nop
2:
	/*Test potential error */
	li		a0, 0x2		//integer mpy
	mtru	a0, mmd
	lw		t8, 36(sp)	//t8=Olp
	lw		t9, 48(sp)	//t9=Hb
	sub		a0, t8, Pstep
	add		a1, a0, t9	
	jal		Test_Err	//v0=off_filt
	sub		a1, a1, 1
	
	li		a0, 0x6		//fractional mpy
	mtru	a0, mmd
	
	sll		t0, v0, 2	;sll	t1, v0, 3
	add		t0, t0, NbFilt085_min
	add		t1, t1, NbFilt170_min
	li		t2, NbFilt085
	li		t3, NbFilt170
	min		t0, t0, t2	;min	t1, t1, t3
	sw		t0, 52(sp)	//Bound[0]
	sw		t1, 56(sp)	//Bound[1]
	
	/* Init the search loop */
	lw		t8, 36(sp)	//t8=Olp	
	li		v1, 0		//v1=Acc1=0
	lw		t9, 48(sp)	//t9=Hb
	li		a0, 0		//a0=k
	li		t5, 0		//t5=Gid (load original value)
	li		t6, Pstep	//t6=Lid=Pstep (load original value)	
3:	// for(k=0; k<Hb; k++) {
		/* Select Quantization tables */	
	.extern pCoderMem
	lw		t1, pCoderMem	//t1=pCoderMem->WrkRate
	//lw		t1, WrkRate
	li		t0, 0			//l=0
	lw		t2, 32(sp)		//t2=Sfc
	lw		t1, 0(t1)		//t1=Wrkrate
	li		t4, 1
	sub		t1, t1, zero	//0->Rate63	
	bnez	t1, 4f
	cmvnez	t0, t4, t1
	
	and		t2, t2, 0x1
	bnez	t2, 5f
	nop
	add		t2, t8, a0
	sub		t2, t2, Pstep
	sub		t2, t2, SubFrLen-2
	sge		t2, t2, zero	
	j		4f	
	cmvnez	t0, t4, t2
5:
	sub		t2, t8, SubFrLen-2
	sge		t2, t2, zero
	cmvnez	t0, t4, t2		//t0=l
4:

	sll		t1, t0, 2
	la		t4, AcbkGainTablePtr
	addu	t4, t4, t1
	lw		a1, 0(t4)	//a1=sPnt=AcbkGainTablePtr[l]
	addu	t3, sp, 52
	addu	t3, t3, t1	
	lw		a3, 0(t3)	//a3=Bound[l]
	la		t2, 1f
	la		t3, 2f-4
	li		t7, 20/4-1	
	mtru	t2, lps0
	mtru	t3, lpe0
	li		t4, 20
	multa2	m0l, a0, t4	//k*20
	mfa		t3, m0l
	addu	a2, s6, t3	//a2=CorVct[k*20]
	//li		t5, 0		//t5=Gid (load original value)
	//li		t6, Pstep	//t6=Lid=Pstep (load original value)	
	li		at, 0		//at=i
6:	// for(i=0; i<Bound[l]; i++) {
	mtru	t7, lpc0	;multa2	m0,zero,zero	
1:
	ltp		t0, (a2)+8
	//ltp		t2, (a1)+8	
	lwp		t2, (a1)+4
	lwp		t3, (a1)+4
	madda2.s m0, t0, t2
	madda2.s m0, t1, t3
2:
	addma.s	m0l,m0l,m0h
	subu	a2, a2, 20*2
	mfa		v0, m0l, 1
	
	sgt		t4, v0, v1	
	cmvnez	v1, v0, t4
	cmvnez	t5, at, t4		//t5=Gid
	cmvnez	t6, a0, t4		//t6=Lid
	
	//} i
	sub		a3, a3, 1
	bgtz	a3, 6b
	add		at, at, 1	//i++
	
	//sw		t5, 44(sp)	//t5=Gid=i
	//sw		t6, 40(sp)	//Lid=k	
	
	// } k
	sub		t9, t9, 1
	bgtz	t9, 3b
	add		a0, a0, 1
	
	/* Modify Olp for even sub frame */
	lw		s6, 32(sp)		//s6=Sfc
	lw		s7, 28(sp)		//s7->Line
	and		t0, s6, 0x1
	bnez	t0, 3f
	sub		t7, t8, Pstep		
	add		t8, t7, t6		//t8=Olp		
	li		t6, Pstep		//t6=Lid
	//sw		t6, 40(sp)	
	//sw		t8, 36(sp)
3:	/* Save Gains and Olp */
	addu	t4, s7, 12		//s7->Line.Sfs
	sll		t0, s6, 4		//Sfc*16
	addu	t4, t4, t0		//s7->Line.Sfs[Sfc]
	mux2.ll	t1, t6, t5		//t1=Lid Gid
	sw		t1, 0(t4)	
	sra		t2, s6, 1
	sll		t2, t2, 1
	addu	t0, s7, 8		//t0->Line.Olp[0]
	addu	t0, t0, t2
	sh		t8, 0(t0)	
	/* Decode the Acbk contribution and suntract it */
	li		t4, 0x2
	mtru	t4, mmd
	move	a0, s3	;move	a1, s2
	move	a2, t8	;move	a3, t6		
	//move	t0, t5			//for GHS, pass Gid via t0
	sw		t5, 16(sp)		//for GNU, padd Gid via 16(sp)
	jal		Decod_Acbks
	//jal		Decod_Acbk
	nop
	li		t4, 0x6
	mtru	t4, mmd
	/* convolution */
	move	a0, s3	;move	a1, s1
	la		s2, ConvEn		//s2=ConvEn
	move	a2, s2
	jal		convols
	li		a3, SubFrLen
	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	.align	3
1:
	lw		t0, 0(s0)
	lw		t1, 4(s0)
	ltp		t2, (s2)+8
	ltp		t4, (s2)+8	;li		at, 0x00008000
	mux2.hl	t6, t0, zero;mux2.lh t7, t0, zero
	mux2.hl	t8, t1, zero;mux2.lh t9, t1, zero
	sra		t6, t6, 1	;sra	t7, t7, 1
	sra		t8, t8, 1	;sra	t9, t9, 1
	subr.s	t6, t6, t2	;subr.s	t7, t7, t3
	subr.s	t8, t8, t4	;subr.s	t9, t9, t5
	addr.s	t6, t6, t6	;addr.s	t7, t7, t7
	addr.s	t8, t8, t8	;addr.s	t9, t9, t9
	addr.s	t6, t6, at	;addr.s	t7, t7, at
	addr.s	t8, t8, at	;addr.s	t9, t9, at
	mux2.hh	t6, t6, t7	;mux2.hh t7, t8, t9
	swp		t6, (s0)+4
	swp		t7, (s0)+4
2:	

	/////////////////////
	lw		t0, 60(sp)	//mmd
	lw		s0, 20(sp)
	lw		s1, 64(sp)
	lw		s2, 68(sp)
	lw		s3, 72(sp)
	lw		s4, 76(sp)
	lw		s5, 80(sp)
	lw		s6, 84(sp)
	lw		at, 88(sp)
	lw		ra, 92(sp)
	lw		s7, 96(sp)
	mtru	t0, mmd	
	jr		ra
	addu	sp, sp, 128
	
	.end	Find_Acbks
	
/*
void  Get_Rez(Word16 *Tv, Word16 *PrevExc, Word16 Lag )
	a0->Tv	(align 8)
	a1->PrevExc
	a2->Lag
*/	
	.text
	.set	noat
	.set	noreorder
	.globl	Get_Rezs
	.ent	Get_Rezs
Get_Rezs:
	li		t4, PitchMax
	sub		t9, t4, a2	//t9=P_L
	sll		t9, t9, 1	
	addu	t8, a1, t9	//t8=PrevExc[P_L]
	lh		t4, -4(t8)
	lh		t5, -2(t8)
	nop
	mux2.ll	t4, t4, t5
	swp		t4, (a0)+4	//store Tv[0:1]
	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (SubFrLen+2)/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	sll		a2, a2, 1	//a2=(Lag)*2
	addu	t9, t8, a2	//t9=PrevExc[P_L+Lag-1]
	move	a1, t8
1:
	lhp		t4, (a1)+2
	seq		t0, t9, a1
	cmvnez	a1, t8, t0 
	lhp		t5, (a1)+2
	seq		t0, t9, a1
	cmvnez	a1, t8, t0 
	mux2.ll	t5, t4, t5
	swp		t5, (a0)+4
2:
	jr		ra
	nop
	.end	Get_Rezs
	
/******************************************************
void  Decod_Acbks( Word16 *Tv, Word16 *PrevExc, Word16 Olp, Word16 Lid, Word16 Gid )
	s0 -> Tv	
	s1 -> PrevExc
	s2 -> Olp
	s3 -> Lid
	s4=16(sp) -> Gid (for GNU complier)
 local:
 	20(sp) -> mmd
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Decod_Acbks
	.ent	Decod_Acbks
Decod_Acbks:	
	sub		sp, sp, 64
	mfru	t9, mmd
	sw		s0, 24(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)
	sw		s3, 36(sp)
	sw		s4, 40(sp)	
	sw		ra, 44(sp)
	sw		t9, 20(sp)//mmd
	///////////////////////////////////
	addiu	s0, a0, 0		;	lui		t4, %hi(RezBuf)		
	addiu	s1, a1, 0		;	addiu	a0, t4, %lo(RezBuf)
	addiu	s2, a2, 0		;	sub		a2, a2, Pstep
	addiu	s3, a3, 0		;	add		a2, a2, a3		
	//jal		Get_Rez			// (~ 250 clks)
	jal		Get_Rezs
	lw		s4, 64+16(sp)		// s4 = Gid		920715
	
	/* Select Quantization table */	 // (24 clks)
	la		t6, AcbkGainTablePtr
	.extern pCoderMem
	lw		t4, pCoderMem	//t4=pCoderMem->WrkRate
	/*lw		t4, WrkRate		;*/	li		t5, (SubFrLen-2)	
	lw		t4, 0(t4)		//t4=WrkRate
	nop
	bnez	t4, 1f
	nop	
	sub		t4, s2, t5		// ?(Olp >= 58)
	bltz	t4, 2f
	nop	
1:	
	addiu	t6, t6, 4
2:	
	lw		t1, 0(t6)		// t1 = Spnt
	li		t4, 20
	multa2	m0l, s4, t4		// Gid*20
	mfa		t4, m0l
	add		t1, t1, t4		
	add		t1, t1, t4		// t1 = Spnt += Gid*20
	la		t0, RezBuf		// t0 = ptrR = &RezBuf[0]	
	// for (i=0; i<SubFrLen; i+=2) {
	li		t6, 0x6
	mtru	t6, mmd					// fractional and 32 bit sature	
	la		t4, 1f
	//lt		t2, (t0)			// t2:pR[0 1] t3:pR[2 3] t4:pR[4 5] t5:pR[5 z]
	lw		t2, 0(t0)				// note. lt must used in data address are 8 bytes alignment	
	la		t5, 2f-4
	lw		t3, 4(t0)	
	li		t6, SubFrLen/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	multa2	m0, zero, zero			// Acc0 	
	//lt		t6, (t1)			// t6:Sp[0 1] t7:Sp[2 3] t8:Sp[4 z]
	lw		t6, 0(t1)	
	lw		t7, 4(t1)
	multa2	m1, zero, zero			// Acc1
	lw		t4, 8(t0)	
	lw		t8, 8(t1)	
	li		t5, 0
	.align 	3		
1:	// loop start			(16*30=480)
	madda2.s m0, t2, t6				// pR[0 1] * Sp[0 1]	
	mux2.lh	t5, t2, t3				
	madda2.s m1, t5, t6				// pR[1 2] * Sp[0 1]
	//nop
	lw		t2, 4(t0)
	madda2.s m0, t3, t7				// pR[2 3] * Sp[2 3]
	mux2.lh	t5, t3, t4
	madda2.s m1, t5, t7				// pR[3 4] * Sp[2 3]
	mux2.lh	t5, t4, zero
	madda2.s m0h, t4, t8			// pR[4] * Sp[4]
	//nop
	lw		t3, 8(t0)
	madda2.s m1h, t5, t8			// pR[5] * Sp[4]
	lw		t4, 12(t0)
	addiu	t0, t0, 4				// ptrR += 2
	addma.s	m0l, m0l, m0h
	////lt		t2, (t0)	
	//lw		t2, 0(t0)
	//lw		t3, 4(t0)
	addma.s m1l, m1l, m1h
	////lt		t6, (t1)
	//lw		t6, 0(t1)
	//lw		t7, 4(t1)
	addma.s m0l, m0l, m0l			// Acc0 = L_shl(Acc0,1)
	//lw		t4, 8(t0)
	addma.s m1l, m1l, m1l			// Acc1 = L_shl(Acc1,1)
	//lw		t8, 8(t1)		
	li		a0, 0x00008000
	mfa		v0, m0l
	mfa		v1, m1l
	addr.s	v0, v0, a0
	addr.s  v1, v1, a0
	mta2	zero, m0
	mta2	zero, m1
	sra		v0, v0, 16
	sra		v1, v1, 16
	shp		v0, (s0)+2
	shp		v1, (s0)+2	
2:	// loop end
	// }
	///////////////////////////////////
	lw		t9, 20(sp)	//mmd
	lw		ra, 44(sp)
	lw		s0, 24(sp)
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	lw		s3, 36(sp)
	lw		s4, 40(sp)		
	mtru	t9, mmd		
	jr		ra
	addiu	sp, sp, 64
	
	.end Decod_Acbks
	
/********************************************************
static Word32 CalEn(Word16 *pB, Word16 *pB2, Word16 Len)
	a0 -> pB
	a1 -> pB2
	a2 -> Len
 local:
 	t0, t1, t2, t3, t4, t5
*/			//(10+60*4+3)=253
	.text
	.set	noat
	.set	noreorder
	.globl	CalEns
	.ent	CalEns
CalEns:	
	sub		sp, sp, 40
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	mfru	s0, lps0
	mfru	s1, lpe0
	mfru	s2, lpc0
	lui		t4, %hi(s154)	
	addiu	t4, t4, %lo(s154)	;	lui		t5, %hi(e159-4)
	addiu	t5, t5, %lo(e159-4);	mtru	t4, lps0
	sra		a2, a2, 1		;	lhp		t0, (a0)+2
	sub		a2, a2, 1		;	lhp		t1, (a1)+2
	lhp		t2, (a0)+2		
	lhp		t3, (a1)+2
	mtru	t5, lpe0	
	mtru	a2, lpc0	
	multa2	m0, zero, zero
	.align	3		
s154:
	madda2.s m0l, t0, t1	;	lhp		t0, (a0)+2
	madda2.s m0l, t2, t3	;	lhp		t1, (a1)+2
	lhp		t2, (a0)+2		
	lhp		t3, (a1)+2
e159:	
	addma.s	m0l, m0l, m0l
	mfa		v0, m0l
	mtru	s0, lps0
	mtru	s1, lpe0
	mtru	s2, lpc0	
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	jr		ra
	addiu	sp, sp, 40
	.end CalEns

/**************************************************
Word16 Comp_Info( Word16 *Buff, Word16 *Buff1, Word16 Olp, Word16 *Gain, Word16 *ShGain)
	a0 -> Buff
	a1 -> Buff1
	a2 -> Olp
	a3 -> Gain
	16(sp) -> ShGain (for GNU complier, pass ShGain via stack)
 local:
Instruction: 2645 clks
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Comp_Infos
	.ent	Comp_Infos
Comp_Infos:
	sub		sp, sp, 128
	sw		s0, 20(sp)		// s0=Buff
	sw		s1, 24(sp)		// s1=Buff1
	move	s0, a0
	sw		s2, 28(sp)		// s2=Olp
	move	s1, a1
	sw		s3, 32(sp)		// s3=Gain
	move	s2, a2
	sw		s4, 36(sp)		// s4=ShGain
	move	s3, a3
	sw		s5, 40(sp)		
	sw		s6, 44(sp)		
	sw		ra, 48(sp)
	//ori		s4, t0, 0	// for GHS, s4 -> ShGain
	lw		s4, (16+128)(sp)		// for GNU, s4 -> ShGain
	/////////////////////////////////
	/* Normalize the excitation */
	jal		Vec_Norms	//(~345 clk)
	add		a2, zero, (PitchMax+Frame)	
	sh		v0, 0(s4)		// *ShGain = Vect_Norms(...)
	/*ori		s4, v0, 0		;*/	li		t4, PitchMax-3
	min		s2, s2, t4		// min(Olp, PitchMax-3)
	move	s5, s2			// Indx = Olp
							// t6 = pB, t7 = pB2, t8 = (Olp-3), t9 = i, s6=Acc1, s5 = Indx
	li		t4, PitchMax+Frame-2*SubFrLen	;	sub		t8, s2, 3	
	sub		t5, t4, t8		;	sll		t4, t4, 1
	add 	t6, s1, t4		;	sll		t5, t5, 1
	add 	t7, s1, t5		;	li		s6, 0	//s6=Acc1
	la		t3, 1f
	la		t4, 2f-4
	li		t5, 7-1
	mtru	t3, lps0
	mtru	t4, lpe0
	mtru	t5, lpc0
	li		t9, 0		//	 i =0
1:	// for(i=0; i<7; i++) {	// (~ 7*(245+6)=1757)
	move	a0, t6		;	move	a1, t7
	jal		CalEns
	ori		a2, zero, (2*SubFrLen)
	sub		t7, t7, 2	;	sub		v1, v0, s6
	bltz	v1, 2f-4
	nop
	move	s6, v0		;	add		s5, t8, t9
	addiu	t9, t9, 1
2:	// }
	li		t4, 0x00008000	// t6 = pB, t7=Ccr, t8=Enr, t9 = Tenr
	add		t5, s6, t4
	sra		t7, t5, 16		// Ccr = round(Acc1)
	blez	t7, 3f
	ori		v0, zero, 0
	/* Compute target energy */ // (~ 245+7=252)
	ori		a0, t6, 0
	ori		a1, t6, 0		;	li		a2, 2*SubFrLen
	jal		CalEns			
	nop
	li		t4, 0x00008000
	add		t9, v0, t4
	sra		t9, t9, 16
	sh		t9, 0(s3)
	/* Compute best energy */	// (~245+16=261)
	sll		t4, s5, 1
	sub		t6, t6, t4
	ori		a0, t6, 0		;	ori		a1, t6, 0
	jal		CalEns
	ori		a2, zero,2*SubFrLen
	li		t4, 0x00008000
	add		t8, v0, t4
	sra		t8, t8, 16
	multa2	m0l, t8, t9		// m0l = Enr*Tenr
	multa2	m1l, t7, t7		
	addma.s	m1l, m1l, m1l	// m1l = Ccr*Ccr*2
	mfa		v0, m0l, 2		// L_shr(Acc0,2)
	mfa		v1, m1l			
	subr.s	v0, v0, v1
	bgez	v0, 3f
	ori		v0, zero, 0
	
	ori		v0, s5, 0

	/////////////////////////////////
3:	
	lw		ra, 48(sp)
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		s4, 36(sp)
	lw		s5, 40(sp)
	lw		s6, 44(sp)
	jr		ra
	addiu	sp, sp, 128
	.end Comp_Infos


/******************************************************
Word32 CalEn2(Word32 Acc0, Word16 *pB, Word16 Len)
	Note. pB must align 4
		  Len must even
	a0 -> Acc0
	a1 -> pB
	a2 -> Len
*/
	.text
	.set	noat
	.set	noreorder
	.globl	CalEn2s
	.ent	CalEn2s
CalEn2s:	
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	
	mtru	t1, lpe0
	sra		t0, a2, 1	// Len/2
	sub		t0, t0, 1	// Len/2-1
	mtru	t0, lpc0
	////////////////////////
	lwp		t1, (a1)+4	
	multa2	m0, zero, zero
	.align	3
1:
	madda2.s m0, t1, t1	;	lwp		t1, (a1)+4	
	nop
2:	
	addma.s m0l,m0l,m0h
	addma.s	m0l, m0l, m0l
	mfa		v0, m0l	
	////////////////////////
	jr		ra
	addr.s	v0, v0, a0

	.end CalEn2s

/****************************************************
void Comp_Lpf( Word16 *Buff, Word16 Olp, Word16 Sfc, PFDEF *Pf )
	a0 -> Buff
	a1 -> Olp
	a2 -> Sfc
	a3 -> Pf	
 local:
 	Lcr[0:4] -> sp[20,24,28,32,36]			Lcr[1]=SenB,Lcr[3]=SenF
 	Scr[0:4] -> sp[40,44,48,52,56] 	
 	s0 -> sp[60]
 	s4 -> pB
 	t8 -> Bindx 
 	t9 -> Findx
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Comp_Lpfs
	.ent	Comp_Lpfs
Comp_Lpfs:
	//andi	at, sp, 0x0000000f
	//add		at, at, 0x70
	//subu	sp, sp, at	
	subu	sp, sp, 128
	sw		s0, 60(sp)
	sw		s1, 64(sp)
	sw		s2, 68(sp)		;	ori		s0, a0, 0
	sw		s3, 72(sp)		;	ori		s1, a1, 0
	sw		s4, 76(sp)		;	ori		s2, a2, 0
	sw		s5, 80(sp)		;	ori		s3, a3, 0
	sw		s6, 84(sp)		;	ori		t4, zero, 0x7fff
	sw		ra, 96(sp)		//;	ori		s6, at, 0
	////////////////////////////
	/* Initialize */	
	sh		zero, 0(a3)		// Indx=0
	sh		zero, 2(a3)		// Gain=0
	sh		t4, 4(a3)		// ScGn=0x7fff
	/* Find both indices */	
	addiu	a3, sp, 24	
	//jal		Find_Bs
	jal		Find_Bs2 
	nop
	ori		s4, v0, 0		
	ori		a0, s0, 0		;	ori		a1, s1, 0
	ori		a2, s2, 0		;	addiu	a3, sp, 32
	jal		Find_Fs
	nop
	ori		t9, v0, 0		// t9 = Findx
	ori		t8, s4, 0		// t8 = Bindx	
	/* Combine the results */	
	bnez	t8, 1f
	nop
	bnez	t9, 1f
	nop
	j		5f
	nop	
1:	
	/* Compute target energy */
	li		t0, SubFrLen	;	ori		t1, zero, PitchMax
	multa2	m0l, s2, t0		// SubFrLen*Sfc
	mfa		v0, m0l
	add		t1, v0, t1		// SubFrLen*Sfc+PitchMax
	sll		t1, t1, 1
	addu	s4, s0, t1		// s4 = &pB[PitchMax+Sfc*SubFrLen]
	lh		t0, (s4)		// load pB[0]
	addiu	a1, s4, 2		// a1 ->pB[1]
	multa2	m0l, t0, t0
	addma.s m0l,m0l,m0l
	mfa		a0, m0l
	ori		a2, zero, SubFrLen-2
	jal		CalEn2s			// v0=Acc0
	nop
	lh		t7, ((SubFrLen-1)*2)(s4)
	nop
	multa2	m1l, t7, t7
	addma.s	m1l,m1l,m1l
	mfa		v1, m1l
	addr.s	v0, v0, v1		// Acc0 = L_mac(Acc0, pB[SubFrLen-1], pB[SubFrLen-1]);	
	sw		v0, 20(sp)		// Lcr[0] = Acc0
	nop
	// if ( Bindx != (Word16) 0 ) {		// t7 = icase	
	beqz	t8, 2f	
	nop
	sll		t0, t8, 1
	add		s5, s4, t0		// s5 -> pB[Bindx]
	and		t4, t8, 1	
	bnez	t4, 1f
	nop
		// Bindx = even, pB not align 4
	lh		t0, (s5)
	nop
	multa2 	m0l, t0, t0
	addma.s m0l, m0l, m0l
	mfa		a0, m0l	
	addu	a1, s5, 2
	ori		a2, zero, SubFrLen-2
	jal		CalEn2s
	nop
	lh		t0, (SubFrLen-1)*2(s5)
	nop
	multa2	m1l, t0, t0
	addma.s m1l, m1l, m1l
	mfa		v1, m1l
	addr.s	v0, v0, v1 	
	j		3f
	nop
1:		// Bindx = odd, pB align 4
	ori		a0, zero, 0
	ori		a1, s5, 0
	ori		a2, zero, SubFrLen
	jal		CalEn2s
	nop
3:
	sw		v0, 28(sp)		// Lcr[2]=Acc1
	ori		t7, zero, 1		// icase = 1
	j		4f	
	nop
2:	// else
	ori		t7, zero, 0		// icase = 0
	sw		zero, 24(sp)		// Lcr[1]=0
	sw		zero, 28(sp)		// Lcr[2]=0
	// }
	
4:	//if ( Findx != (Word16) 0 ) {   
	sll		t7, t7, 1		// icase = icase << 1     
	beqz	t9, 6f	
	nop
	sll		t0, t9, 1
	add		s5, s4, t0		// s5 -> pB[Findx]
	and		t4, t9, 1
	bnez	t4, 1f
	nop
		// Findx = even, pB not align 4
	lh		t0, (s5)		
	addu	a1, s5, 2
	multa2	m0l, t0, t0
	addma.s m0l,m0l,m0l
	mfa		a0, m0l
	ori		a2, zero, SubFrLen-2
	jal		CalEn2s
	nop
	lh		t0, ((SubFrLen-1)*2)(s5)
	nop
	multa2	m1l, t0, t0
	addma.s m1l,m1l,m1l
	mfa		v1, m1l
	addr.s	v0, v0, v1	
	j		2f
	nop
1:		// Findx = odd, pB align 4	
	ori		a0, zero, 0
	ori		a1, s5, 0	
	ori		s2, SubFrLen	
	jal		CalEn2s
	nop
2:	
	sw		v0, 36(sp)		// Lcr[4]=Acc1	
	add		t7, t7, 1		// icase=icase<<1+1
	j		7f
	nop
6:	// else	
	sw		zero, 32(sp)	// Lcr[3]=0
	sw		zero, 36(sp)	// Lcr[4]=0
	// }
7:	
	/* Normalize and convert to shorts */
	lw		a0, 20(sp)
	lw		t1, 24(sp)
	lw		t2, 28(sp)	;	max		a0, a0, t1
	lw		t1, 32(sp)	;	max		a0, a0, t2
	lw		t2, 36(sp)	;	max		a0, a0, t1
	jal		norm_l		;	max		a0, a0, t2	
	//lt		t0, 20(sp)
	//lt		t2, 28(sp)
	lw		t0, 20(sp)
	lw		t1, 24(sp)
	lw		t2, 28(sp)
	lw		t3, 32(sp)
	lw		t4, 36(sp)	;	sll		t0, t0, v0
	sra		t0, t0, 16	;	sll		t1, t1, v0
	sw		t0, 40(sp)	;	sra		t1, t1, 16
	sw		t1, 44(sp)	;	sll		t2, t2, v0
	sra		t2, t2, 16	;	sll		t3, t3, v0
	sw		t2, 48(sp)	; 	sra		t3, t3, 16
	sw		t3, 52(sp)	;	sll		t4, t4, v0
	sra		t4, t4, 16
	sw		t4, 56(sp)
	/* Select the best pair */		
	sub		t1, t7, 3
	beqz	t1, icase3
	nop
	sub		t1, t7, 2
	beqz	t1, icase2
	nop	
icase1:		
	lw		a1, 40(sp)
	lw		a2, 52(sp)
	lw		a3, 56(sp)		
	j		6f
	ori		a0, t9, 0
icase2:	
	lw		a1, 40(sp)
	lw		a2, 44(sp)
	lw		a3, 48(sp)	
	j		6f
	ori		a0, t8, 0
icase3:	

	lw		t1, 44(sp)
	lw		a1, 40(sp)		// a1=Scr[0]	
	multa2	m0l, t1, t1		// Scr[1]*Scr[1]		(missing case in sourcereg, format_num=116)
	lw		t4, 56(sp)
	nop
	mfa		v0, m0l
	sra		v0, v0, 15
	lw		t3, 52(sp)
	multa2	m0l, v0, t4		// Exp*Scr[4]			(missing case in sourcereg, format_num=116)
	multa2	m1l, t3, t3		// Scr[3]*Scr[3]		(missing case in sourcereg, format_num=116)
	lw		t2, 48(sp)
	nop
	mfa		v0, m1l
	sra		v0, v0, 15
	multa2	m1l, v0, t2		// Exp*Scr[2]
	mfa		v0, m0l
	mfa		v1, m1l
	sub		v0, v0, v1
	blez	v0, 1f
	nop	
		// Acc0 > Acc1
	ori		a0, t8, 0
	ori		a2, t1, 0	
	j		6f
	ori		a3, t2, 0	
1:		// Acc0 <= Acc1
	ori		a0, t9, 0
	ori		a2, t3, 0	
	ori		a3, t4, 0
6:
	sh		a0, 0(s3)	//Pf->Indx=a0;
	nop
	move 	a0, a1
	move	a1, a2
	move	a2, a3		
	jal		Get_Ind
	move	a3, s3

	//move	at, s6

	////////////////////////////
5:	
	lw		ra, 96(sp)
	lw		s0, 60(sp)
	lw		s1, 64(sp)
	lw		s2, 68(sp)
	lw		s3, 72(sp)
	lw		s4, 76(sp)
	lw		s5, 80(sp)
	lw		s6, 84(sp)
	jr		ra
	//addiu	sp, sp, 100
	//addu	sp, sp, at
	addu	sp, sp, 128
	.end	Comp_Lpfs

/*	
void crosscorr(Word16 *ptr0, Word16 *ptr1, Word32 *xcorr, Word16 *Len)
	a0->ptr0
	a1->ptr1
	a2->xcorr
	a3->Len[]
clk : 9+(Num_Out/4)(5+(SubFrLen/4)*8+12)
	ex. Num_Out=8 -> 283 clks	
NOTES.
	1. assume ptr0 and ptr1 align 8	
	2. Num_Out is even and div by 4
	3. processing length is SubFrLen(60 samples)		
	4. assume fractional mode	
	used at, t0~t9
*/
	.text
	.set	noat
	.set	noreorder
	.globl	crosscorrs
	.ent	crosscorrs
crosscorrs:
	subu	sp, sp, 64	;lh	 t4, 0(a3)//t4=Num_Out
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		at, 28(sp)	;sra 	s0, t4, 2 //loop counter
	//addu	a2, a2, t3	//a2->xcorr[Num_Out-1]	
	la		t0, 3f
	lh		t9, 2(a3)	//t9=correlation length
	la		t1, 4f-4
	sll		s1, t9, 1	
	addu	s1, s1, 8	//s1=corr-Len*2+8
	sra		t9, t9, 2
	sub		t9, t9, 1	
	mtru	t0, lps0
	mtru	t1, lpe0
	.align	3
1:	// outer loop start	
	// t0:[s0 s1]t1:[s2 s3]t2:[s4 s5]t3:[s6 s7]
	// t4:[t0 t1]t5:[t2 t3]t6:[t4 t5]t7:[t6 t7]
	// t8:[t5 t6] at:[t3 t4]
	mtru	t9, lpc0	;multa2 m0,zero,zero
	ltp		t2, (a0)+8	;multa2 m1,zero,zero
	ltp		t4, (a1)+8	;multa2 m2,zero,zero
	lt		t6, 0(a1)	;move	t0, t2
	nop					;multa2	m3,zero,zero
	// process 4 output 
3:	
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (a0)+8
	madda2.s m2, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m2, t1, t6	;mux2.lh at, t5, t6
	madda2.s m1, t0, t8	;ltp	t4, (a1)+8
	madda2.s m1, t1, at	;mux2.lh t8, t6, t7
	madda2.s m3, t0, at	;lt		t6, 0(a1)
	madda2.s m3, t1, t8	;move	t0, t2	
4:
	addma.s	m0l,m0l,m0h	;addma.s m1l,m1l,m1h
	addma.s	m2l,m2l,m2h	;addma.s m3l,m3l,m3h
	mfa		t0, m0l		;subu	a0, a0, s1
	mfa		t1, m1l		;subu	a1, a1, s1
	mfa		t2, m2l		;addiu	a1, a1, 8 // offset 4 samples
	mfa		t3, m3l		;sub	s0, s0, 1//dec loop counter
	swp		t0, (a2)-4
	swp		t1, (a2)-4
	swp		t2, (a2)-4
	swp		t3, (a2)-4	
	bgtz	s0, 1b
	nop
2:	// outer loop end
	lw		at, 28(sp)
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	jr		ra
	addu	sp, sp, 64

	.end	crosscorrs
		
/******************************************************
Word16   Find_Bs2( Word16 *Buff, Word16 Olp, Word16 Sfc, Word32 *Sen )
	s0 -> Buff
	s1 -> Olp
	s2 -> Sfc, Indx
	s3 -> Sen
 local: 	
 	32(sp) -> mmd
 	36(sp)->ra
 	40(sp)~68(sp):xcorr[]
 	72(sp):Len[0]
 	76(sp):Len[1]
 	share Temp2[] with others
 	Temp2[0]->src
 	Temp2[72]->tar
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Find_Bs2
	.ent	Find_Bs2
Find_Bs2:
	subu	sp, sp, 120		
	mfru	t0, mmd	
	sw		s0, 20(sp)	;li		t4, 0x6	
	sw		s1, 24(sp)	;nop
	sw		s2, 28(sp)	;move s0, a0
	sw		s3, 80(sp)	;move s1, a1
	sw		t0, 32(sp)	;move s2, a2
	sw		ra, 36(sp)	;move s3, a3	
	/////////////	
	li		t0, PitchMax;li	t2, SubFrLen
	sub		t1, t0, 3	;multa2	m0l, s2, t2//s1=Olp
	min		s1, s1, t1	;mtru	t4, mmd
	add		t2, s1, 4	;mfa		v0, m0l//v0=Sfc*SubFrLen
										//t2=Olp+4
	add		t4, t0, v0	;add	t1, t0, v0//t1=PitchMax+Sfc*SubFrLen
	sll		t4, t4, 1	;sub	t2, t1, t2//t2=PitchMax+Sfc*SubFrLen-(Olp+4), t2 maybe < 0
	addu	a0, s0, t4	;andi	t3, t2, 0x1//a0->ptr0
						//t3: 1->ptr1 is odd
	.extern Temp2
	la		t8, Temp2	//t8=src=Temp2[0]
	addu	t9, t8, 72*2//t9=tar=Temp2[72]
	sll		t2, t2, 1		
	beqz	t3, 3f
	addu	a1, s0, t2	//a1->ptr1
	
	// ptr1 is odd, from data to 8 alignment
	// t0:[s1 s2]t1:[s3 s4]
	// t2:[t-1 t0]t3:[t1 t2]
	// t4:[s0 s1]
	la		t5, 1f
	la		t6, 2f-4
	li		t7, (SubFrLen+8)/2-1
	mtru	t5, lps0
	mtru	t6, lpe0
	mtru	t7, lpc0	;subu	a0, a0, 2//offset a0 to 4 align	
	lwp		t0, (a0)+4	;subu	a1, a1, 2//offset a1 to 4 alignment
	lwp		t1, (a0)+4
	lwp		t2, (a1)+4	
	.align	3
1:
	lwp		t3, (a1)+4	;mux2.lh t4, t0, t1
	swp		t4, (t8)+4	;move	 t0, t1
	mux2.lh	t5, t2, t3	;lwp	 t1, (a0)+4
	swp		t5, (t9)+4	;move	 t2, t3
2:
	j		2f
	nop
3:	// ptr1 is even, form data for 8 alignment
	// t0:[s-1 s0]t1:[s1 s2]
	// t2:[t0 t1]	
	la		t5, 1f
	la		t6, 2f-4
	li		t7, (SubFrLen+8)/2-1
	mtru	t5, lps0
	mtru	t6, lpe0	
	mtru	t7, lpc0
	subu	a0, a0, 2//offset a0 to 4 align	
	lwp		t0, (a0)+4
	lwp		t1, (a0)+4	
	.align	3
1:	
	lwp		t2, (a1)+4;mux2.lh	t4, t0, t1
	swp		t4, (t8)+4;move		t0, t1	
	swp		t2, (t9)+4;nop
	nop				  ;lwp		t1, (a0)+4
	nop;nop
2:	
	// call crosscorr()
	li		t4, 8	;li		t5, SubFrLen
	sh		t4, 72(sp)
	sh		t5, 74(sp)	
	la		a0, Temp2
	addu	a1, a0, 72*2;addu	a2, sp, 68//a2=xcorr[7]		
	jal		crosscorrs
	addu	a3, sp, 72	//72(sp)->Len
	
	// find best indx
	la		t4, 1f
	la		t5, 2f-4	
	mtru	t4, lps0	;li		t6, 6
	mtru	t5, lpe0	;li		v1, 0//Acc1=0
	mtru	t6, lpc0	;li		t2, 0//i=0
	sub		t3, s1, 3	;li		v0, 0 //v0=Indx//t3=Olp-3
	addu	a1, sp, 40
1:	
	lwp		t0, (a1)+4	
	add		t4, t3, t2	//t4=Olp-3+i	
	sub		t1, t0, v1
	blez	t1, 2f-4
	nop
	// if(xcorr[i] > Acc1)
	move	v1, t0	
	sub		v0, zero, t4	
	addi	t2, t2, 1	//i++	
2:	
	sw		v1, 0(s3)
		
	/////////////
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 80(sp)	
	lw		t0, 32(sp)
	lw		ra, 36(sp)
	mtru	t0, mmd
	jr		ra
	addu	sp, sp, 120	

	.end	Find_Bs2
	
	

/******************************************************
Word16   Find_B( Word16 *Buff, Word16 Olp, Word16 Sfc, Word32 *Sen )
	a0 -> Buff
	a1 -> Olp
	a2 -> Sfc
 local:
 	t8 = Indx
 	t9 -> mmd
Instruct: 14+7*(4+4*30+14)+3=983)
*/


	.text
	.set	noat
	.set	noreorder
	.globl	Find_Bs
	.ent	Find_Bs
	.align	3
Find_Bs:
	//
	//	
	li		t8, 0				;	nop
	li		t5, SubFrLen		;	ori		t4, zero, PitchMax-3
	multa2	m0l, a2, t5			;	min		a1, a1, t4			
	ori		v1, zero, 0			;	sub		a1, a1, 3		// v1 =Acc1= 0, a1 = Olp - 3
	addiu	t0, a0, PitchMax*2	;	subu	t1, a0, a1
	subu	t1, t1, a1			;	nop
	mfa		t2, m0l				;	addiu	t1, t1, PitchMax*2
	sll		t2, t2, 1			;	mfru	t9, mmd
	addu	t0, t0, t2			;	addu	t1, t1, t2		// t0 = ptr0, t1 = ptr1
	li		t2, 0				;	ori		t4, zero, 0x6	// t2 = loop counter
	mtru	t4, mmd				//	fraction and 32 bit sature
	lui		t4, %hi(lp1s)				
	lui		t5, %hi(lp1e-4)		;	addiu	t4, t4, %lo(lp1s)
	addiu	t5, t5, %lo(lp1e-4)	;	mtru	t4, lps0
	mtru	t5, lpe0			;	addiu	t7, zero, (SubFrLen/2)-1	// t7 = (SubFrLen/2)-1
loop1:
	//////////////////////////
	lhp		t3, (t0)+2			;	multa2	m0l, zero, zero		// m0l = Acc0 = 0			
	lhp		t4, (t1)+2			;	mtru	t7, lpc0		
	lhp		t5, (t0)+2
	lhp		t6, (t1)+2
lp1s:		
	madda2.s m0l, t3, t4		;	lhp		t3, (t0)+2
	madda2.s m0l, t5, t6		;	lhp		t4, (t1)+2
	lhp		t5, (t0)+2	
	lhp		t6, (t1)+2
lp1e:	
	mfa		v0, m0l				//;	addi	t0, t0, -((SubFrLen+2)*2)	
	subu	t0, t0, ((SubFrLen+2)*2)
	subu	t1, t1, ((SubFrLen+3)*2)
	sub		t3, v0, v1
	blez	t3, 1f
	nop
	ori		v1, v0, 0			;	add		t3, a1, t2
	sub		t8, zero, t3		// t8 = Indx
	/////////////////////////
1:	
	addiu	t2, t2, 1
	addiu	t3, t2, -7
	bltz	t3, loop1
	nop
loop1e:
	sw		v1, 0(a3)			// *Sen = Acc1
	mtru	t9, mmd	
	jr		ra	
	move	v0, t8
	
	.end Find_Bs


/********************************************************
Word16   Find_F( Word16 *Buff, Word16 Olp, Word16 Sfc, Word32 *Sen )
	a0 -> Buff
	a1 -> Olp
	a2 -> Sfc
	a3 -> Sen
 local: 	 	
 	t0 -> ptr0
 	t1 -> ptr1
 	t2 -> Olp-3
 	t3 -> thr
 	t7 -> indx
*/
	.text
	.set	noreorder
	.globl	Find_Fs
	.ent	Find_Fs
	.align	3
Find_Fs:	
	subu	sp, sp, 32		;	li		t7, 0			// t7=Indx=0;
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	li		t4, PitchMax-3	;	li		t5, SubFrLen
	min		a1, a1, t4		;	multa2	m0l, a2, t5		//Sfc*SubFrLen	
	mfa		t0, m0l
	addu	t3, t0, t5		// t3=thr=Sfc*SubFrlEn
	sll		t0, t0, 1		;	li		t4, PitchMax*2
	addu	t0, t0, t4		;	sub		t2, a1, 3		// t2 = Olp-3
	addu	t0, a0, t0		// t0 -> &Buff[PitchMax+Sfc*SubFrLen]	
	addu	t1, t0, t2
	addu	t1, t1, t2		// t1 -> &Buff[PitchMax+Sfc*SubFrLen+(Olp-3)]
	add		t3, t3, t2		// t3 = thr=Sfc*SubFrLen+(Olp-3)		
	
	li		v1, 0			// v1=Acc1=0
	li		t8, 0			// t8=i=0
	la		t4, 3f
	la		t5, 4f-4	
	mtru	t4, lps0
	mtru	t5, lpe0	
1:	// outer loop start	
	add		t4, t3, t8		;	multa2	m0l, zero, zero	// t3=thr+i, v0=m0l		
	sub		t4, t4, Frame	;	nop
	bgtz	t4, 5f
	nop
	// if (thr+i <= Frame) {
	li		t4, SubFrLen/2-1;	lhp		t5, (t0)+2
	mtru	t4, lpc0	
	lhp		t6, (t1)+2
	lhp		s0, (t0)+2
	lhp		s1, (t1)+2	
3:	// inner loop start	
	madda2.s m0l, t5, t6	;	lhp		t5, (t0)+2
	madda2.s m0l, s0, s1	;	lhp		t6, (t1)+2
	lhp		s0, (t0)+2	
	lhp		s1, (t1)+2
4:	// inner loop end
	addma.s m0l, m0l, m0l	;	subu	t0, t0, (SubFrLen+2)*2		// ptr0 -= SubFrLen
	mfa		v0, m0l			;	subu	t1, t1, (SubFrLen+1)*2		// ptr1 -= SubFrLen-1	
	// if (Acc0 > Acc1) {	
	sub		t4, v0, v1		;	nop
	blez	t4, 5f
	nop
	move 	v1, v0			;	add		t7, t2, t8		// Indx = (Olp-3)+i
	// }	
	// }
5:	
	addu	t8, t8, 1
	sub		t4, t8, 7
	bnez	t4, 1b
	nop
2:	// outer loop end
	sw		v1, (a3)
	move	v0, t7
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	
	jr		ra
	addu	sp, sp, 32

	.end Find_Fs


/***************************************************************
void  Filt_Lpf( Word16 *Tv, Word16 *Buff, PFDEF *Pf, Word16 Sfc )
	a0 -> Tv
	a1 -> Buff
	a2 -> Pf
	a3 -> Sfc	
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Filt_Lpfs
	.ent	Filt_Lpfs
Filt_Lpfs:        
    li		t4, SubFrLen
    multa2	m0l, a3, t4
    addma.s	m0l, m0l, m0l    
    li		t5, PitchMax
    sll		t5, t5, 1
    mfa		t4, m0l
    addu	a0, a0, t4	//a0=Tv[Sfc*SubFrLen]
    addu	t0, a1, t5	//Buff[PitchMax]    
    addu	t0, t0, t4	//t0=Buff[PitchMax+Sfc*SubFrLen]    
    lh		t1, 0(a2)	//t1=Pf.Indx
    lh		t2, 2(a2)	//t2=Pf.Gain
    lh		t3, 4(a2)	//t3=Pf.ScGn    
    sll		t4, t1, 1
    addu	t4, t0, t4 	//t4=Buff[PitchMax+Sfc*SubFrLen+Pf.Indx]
	la		t5, 1f
	la		t6, 2f-4
	li		t7, SubFrLen-1
	mtru	t5, lps0
	mtru	t6, lpe0
	mtru	t7, lpc0
	lhp		t5, (t0)+2	
	lhp		t7, (t4)+2	
	ori		t9, zero, 0x00008000
	.align	3
1:    
	multa2	m0l, t5, t3		;	lhp		t5, (t0)+2
	addma.s	m0l, m0l, m0l	;	multa2	m1l, t7, t2		
	lhp		t7, (t4)+2		;	addma.s	m1l, m1l, m1l
	addma.s	m0l, m0l, m1l
	mfa		v0, m0l
	addr.s	v0, v0, t9
	sra		v0, v0, 16
	shp		v0, (a0)+2
2:
	jr		ra
	nop
	.end Filt_Lpfs


/*
void crossconv(Word16 *Tv, Word16 *Imr, Word32 *CrossEn, int Len)
	a0->Tv
	a1->Imr
	a2->CrossEn
	a3->Len
Usage.
	1.assume fractional mode and 32 bit sature
	2.process 4 output each outer loop
	3.Tv[] has to pad 4 "zero" in the tail
clks: 14+Len/4*(5+14)+8*(Len/4+..+1)+6
*/
	.text
	.set	noat
	.set	noreorder
	.globl	crossconvs
	.ent	crossconvs
crossconvs:
	subu	sp, sp, 40	
	sw		s0, 20(sp)	//Tv offset stride
	sw		s1, 28(sp)	//Imr[0]
	sw		at, 24(sp)
	sw		s3, 32(sp);	li	s0, 8	//offset pointer
	move	at, a3	;	move	s1, a1
	/////////////////////	
	sll		at, at, 1
	add		at, at, 8	//at=Len*2+8
	la		t0, 1f		
	la		t1, 2f-4
	mtru	t0, lps0;sra a3, a3, 2	//outer loop cnter (a3=Len/4)
	mtru	t1, lpe0;sub s3, a3, 1	//inner loop cnter (s3=Len/4-1)			
	.align	8			
3:	
	// set inner loop times
	mtru	s3, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a1)+8	;multa2	m1,zero,zero
	ltp		t4, (a0)+8	;multa2	m2,zero,zero
	lt		t6, 0(a0)	;multa2 m3,zero,zero
	move	t0,t2		;nop
1:	// inner loop start
	// Imr ->t0:[4 5]t1:[2 3]t2:[4 5]t3:[6 7]
	// Tv->	 t4:[4 5]t5:[6 7]t6:[8 9]t7:[10 11] 
	//		 t8:[5 6]t9:[3 4]
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (a1)+8
	madda2.s m2, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m2, t1, t6	;mux2.lh t9, t5, t6
	madda2.s m1, t0, t8	;ltp	t4, (a0)+8
	madda2.s m1, t1, t9	;mux2.lh t8, t6, t7
	madda2.s m3, t0, t9	;lt		t6, 0(a0)
	madda2.s m3, t1, t8	;move	t0, t2	
2:	// inner loop end
	addma.s m0l, m0l, m0h;addma.s m1l, m1l, m1h
	addma.s m2l, m2l, m2h;addma.s m3l, m3l, m3h
	mfa		t0, m0l
	mfa		t1, m1l
	mfa		t2, m2l
	mfa		t3, m3l
	// store 4 CrossEn[]
	// adjust Tv[] and Imr[] pointer	
	// dec inner loop cnter
	swp		t0, (a2)+4;subu	a0, a0, at	//Tv=Tv-(Len*2+8)
	swp		t1, (a2)+4;move	a1, s1
	swp		t2, (a2)+4;addu	a0, a0, s0	//Tv=Tv+offset(offset 4 samples)	
	swp		t3, (a2)+4;sub	s3, s3, 1
	addu	s0, s0, 8
	//dec outer loop cnter
	sub		a3, a3, 1
	bgtz	a3, 3b
	nop	
4:	
	////////////////////	
	lw		s0, 20(sp)
	lw		s1, 28(sp)
	lw		s3, 32(sp)	
	lw		at, 24(sp)
	jr		ra
	addu	sp, sp, 40
	.end	crossconvs

/*
void crossconv2(Word16 *Tv, Word16 *Imr, Word32 *CrossEn, int Len)
	a0->Tv
	a1->Imr
	a2->dummy (not used)
	a3->Len
Usage.
	1.assume fractional mode and 32 bit sature
	2.process 4 output each outer loop
	3.Tv[] has to pad 4 "zero" in the tail
clks: 14+Len/4*(5+14)+8*(Len/4+..+1)+6
*/
	.text
	.set	noat
	.set	noreorder
	.globl	crossconv2s
	.ent	crossconv2s
crossconv2s:
	subu	sp, sp, 40	
	sw		s0, 20(sp)	//Tv offset stride
	sw		s1, 28(sp)	//Imr[0]
	sw		at, 24(sp)
	sw		s3, 32(sp);	li	s0, 8	//offset pointer
	move	at, a3	;	move	s1, a1
	sub		t0, a3, 4//Len-4
	sll		t0, t0, 1
	addu	a2, s1, t0	//a2->Imr[Len-4]
	/////////////////////	
	sll		at, at, 1
	add		at, at, 8	//at=Len*2+8
	la		t0, 1f		
	la		t1, 2f-4
	mtru	t0, lps0;sra a3, a3, 2	//outer loop cnter (a3=Len/4)
	mtru	t1, lpe0;sub s3, a3, 1	//inner loop cnter (s3=Len/4-1)				
	.align	8			
3:	
	// set inner loop times
	mtru	s3, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a1)+8	;multa2	m1,zero,zero
	ltp		t4, (a0)+8	;multa2	m2,zero,zero
	lt		t6, 0(a0)	;multa2 m3,zero,zero
	move	t0,t2		;nop
1:	// inner loop start
	// Imr ->t0:[4 5]t1:[2 3]t2:[4 5]t3:[6 7]
	// Tv->	 t4:[4 5]t5:[6 7]t6:[8 9]t7:[10 11] 
	//		 t8:[5 6]t9:[3 4]
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (a1)+8
	madda2.s m2, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m2, t1, t6	;mux2.lh t9, t5, t6
	madda2.s m1, t0, t8	;ltp	t4, (a0)+8
	madda2.s m1, t1, t9	;mux2.lh t8, t6, t7
	madda2.s m3, t0, t9	;lt		t6, 0(a0)
	madda2.s m3, t1, t8	;move	t0, t2	
2:	// inner loop end
	addma.s m0l, m0l, m0h;addma.s m1l, m1l, m1h
	addma.s m2l, m2l, m2h;addma.s m3l, m3l, m3h
	mfa		t0, m0l
	mfa		t1, m1l
	mfa		t2, m2l
	mfa		t3, m3l
	// shift tan store to Imr[]
	sll		t0, t0, 2;	sll		t1, t1, 2
	sll		t2, t2, 2;	sll		t3, t3, 2
	sra		t2, t2, 16;	sra		t0, t0, 16
	mux2.hl	t4, t3, t2;	mux2.hl	t5, t1, t0
	stp		t4, (a2)-8	//update Imr[]
		
	// adjust Tv[] and Imr[] pointer	
	// dec inner loop cnter
	move	a1, s1;		subu	a0, a0, at	//Tv=Tv-(Len*2+8)
	sub		s3, s3, 1;	addu	a0, a0, s0	//Tv=Tv+offset(offset 4 samples)		
	addu	s0, s0, 8
	//dec outer loop cnter
	sub		a3, a3, 1
	bgtz	a3, 3b
	nop	
4:	
	////////////////////	
	lw		s0, 20(sp)
	lw		s1, 28(sp)
	lw		s3, 32(sp)	
	lw		at, 24(sp)
	jr		ra
	addu	sp, sp, 40
	.end	crossconv2s

/*
void Cor_h(Word16 *H, Word16 *rr)
	a0->H		align 8
	a1->rr		align 4
local:
	g7231_TmpVct[]->h[]
*/
	.text
	.set	noat
	.set	noreorder
	.globl	g7231_Cor_hs
	.ent	g7231_Cor_hs
g7231_Cor_hs:
	subu	sp, sp, 128
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;move	s0, a0//s0->H
	sw		s4, 36(sp)	;move	s1, a1//s1->rr
	sw		s5, 40(sp)	;li		t4, 0x6
	sw		s6, 44(sp)
	sw		s7, 48(sp)
	mfru	t5, mmd
	mtru	t4, mmd
	sw		t5, 52(sp)
	//////////////////
	/*Scaling for maximum precision */
	la		t0, 1f
	ltp		t4, (a0)+8
	la		t1, 2f-4	
	li		t2, SubFrLen/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	;multa2	m0,zero,zero
	mtru	t2, lpc0	
	.align	3
1:
	madda2.s m0, t4, t4	;ltp	t6, (a0)+8
	madda2.s m0, t5, t5	;nop	
	move	t4, t6		;move	t5, t7
2:
	addma.s m0l,m0l,m0h	;li		t4, 32000
	mfa		v0,m0l	//v0=cor
	
	.extern g7231_TmpVct
	la		s2, g7231_TmpVct	//s2->h[0]
	sw		zero, 0(s2)	;sra	v1, v0, 16
	sw		zero, 4(s2)	;sgt	v1, v1, t4	//v1=extract_h(cor)>32000?1:0
	move	a0, s0	//a0->H[0]
	beqz	v1, 3f
	addu	a1, s2, 8	//a1->h[4]
	// if(extract_h(cor) > 32000)
	la		t0, 1f
	ltp		t4, (a0)+8
	la		t1, 2f-4
	li		t2, SubFrLen/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	;li		t0, 1
	.align	3
1:
	srav2	t6, t4, t0	;srav2	t7, t5, t0	
	ltp		t4, (a0)+8
	stp		t6, (a1)+8
2:
	j		4f
	nop	
3:	// else
	la		t0, 1f
	ltp		t4, (a0)+8
	la		t1, 2f-4
	li		t2, SubFrLen/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	;cls	v0, v0	//v0=k
	mtru	t2, lpc0	;sra	v0, v0, 1
1:	
	sllv2	t6, t4, v0	;sllv2	t7, t5, v0
	ltp		t4, (a0)+8
	stp		t6, (a1)+8	
2:
4:
	/*Compute rri0i0[], rri1i1[], rri2i2[] and rri3i3[] */
	addu	a0, s1, (i0i0+(NB_POS-1)*2)//a0->p0
	addu	a1, s1, (i1i1+(NB_POS-1)*2)//a1->p1
	addu	a2, s1, (i2i2+(NB_POS-1)*2)//a2->p2
	addu	a3, s1, (i3i3+(NB_POS-1)*2)//a3->p3
	
	move	t9, s2	;multa2	m0,zero,zero//t9=ptr_h1
	la		t0, 1f
	ltp		t4, (t9)+8	//t4=[h0 h1] t5=[h2 h3]
	la		t1, 2f-4
	li		t2, NB_POS-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align	3
1:
	madda2.s m0, t4, t4	;ltp	t6, (t9)+8
	addma.s m1l,m0l,m0h	;nop
	mfa		v0, m1l		;madda2.s m0, t5, t5
	sra		v0, v0, 16	;addma.s m1h, m0l,m0h
	shp		v0, (a3)-2	;mfa	v1, m1h
	madda2.s m0, t6, t6	;sra	v1, v1, 16
	addma.s m1l, m0l,m0h;shp	v1, (a2)-2
	mfa		v0, m1l		;madda2.s m0, t7, t7
	sra		v0, v0, 16	;addma.s m1h, m0l,m0h
	shp		v0, (a1)-2	;mfa	v1, m1h
	ltp		t4, (t9)+8	;sra	v1, v1, 16
	nop					;shp	v1, (a0)-2
2:
	/* compute elements of: rri0i1[], rri0i3[], rri1i2[] and rri2i3[] */
	li		t9, MSIZE-1	//t9=l_fin_sup
	li		t8, MSIZE-2 //t8=l_fin_inf
	move	s3, s2		//s3=ptr_hd
	addu	s4, s2, 2*2	//s4=ptr_hf
	li		s5, 0		//s5=k
	.align	3
3:	//for(k=0;k<NB_POS;k++) {	
	addu	a0, s1, i0i3	;sll	t4, t8, 1
	addu	a0, a0, t4		;addu	a1, s1, i0i1//a0->p0
	addu	a2, s1, i1i2	;sll	t4, t9, 1
	addu	a1, a1, t4		;addu	a2, a2, t4//a1->p1 a2->p2
	addu	a3, s1, i2i3	;multa2	m0,zero,zero
	addu	a3, a3, t4		;move	s6, s3//a3->p3 s6=ptr_h1
	move	s7, s4			;li		t2, NB_POS-2//s7=ptr_h2
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, t2, s5		;mtru	t0, lps0
	lwp		t4, (s6)+4		//t4=h1[0] h1[1] 
	lwp		t5, (s7)+4		//t5=h2[0] h2[1]
	bltz	t2, 2f		//if(t2<0) skip inner loop
	mtru	t1, lpe0
	mtru	t2, lpc0
1:	//for(i=k+1; i<NB_POS;i++)
	madda2.s m0, t4, t5		;lwp	t6, (s6)+4
	addma.s	m1l,m0l,m0h		;lwp	t7, (s7)+4
	mfa		v0, m1l			;nop
	sra		v0, v0, 16		;lwp	t4, (s6)+4
	shp		v0, (a3)-((NB_POS+1)*2);madda2.s m0, t6, t7
	lwp		t5, (s7)+4		;addma.s m1h, m0l,m0h
	nop						;mfa	v1, m1h
	lwp		t6, (s6)+4		;sra	v1, v1, 16
	madda2.s m0, t4, t5		;shp	v1, (a2)-((NB_POS+1)*2)
	addma.s m1l, m0l,m0h	;lwp	t7, (s7)+4
	mfa		v0, m1l			;nop
	sra		v0, v0, 16		;madda2.s m0, t6, t7
	shp		v0, (a1)-((NB_POS+1)*2);addma.s m1h, m0l,m0h
	lwp		t4, (s6)+4		;mfa	v1, m1h
	lwp		t5, (s7)+4		;sra	v1, v1, 16
	shp		v1, (a0)-((NB_POS+1)*2);nop	
2:	//end of i
	madda2.s m0, t4, t5		;lwp	t6, (s6)+4
	addma.s m1l, m0l,m0h	;lwp	t7, (s7)+4
	mfa		v0, m1l			;nop
	sra		v0, v0, 16		;madda2.s m0, t6, t7
	sh		v0, 0(a3)		;addma.s m1h, m0l,m0h
	lwp		t4, (s6)+4		;mfa	v1, m1h
	lwp		t5, (s7)+4		;sra	v1, v1, 16
	nop						;sh		v1, 0(a2)
	madda2.s m0, t4, t5		;sub	t9, t9, NB_POS//l_fin_sup -=NB_POS
	addma.s m1l,m0l,m0h		;sub	t8, t8, 1//l_fin_inf--
	mfa		v0, m1l			;addu	s4, s4, STEP*2//ptr_hf+=STEP
	sra		v0, v0, 16
	sh		v0, 0(a1)	
	// end of k
	sub		t4, s5, NB_POS-1
	bnez	t4, 3b
	addi	s5, s5, 1	//k++
	
	/* compute elements of: rri0i2[], rri1i3[] */
	move	s3, s2		;addu	s4, s2, 4*2//s3->ptr_hd
	li		t9, MSIZE-1	//s4->ptr_hf t9=l_fin_sup
	li		t8, MSIZE-2	//t8=l_fin_inf
	li		s5, 0		//s5=k
	.align	3
3:	//for(k=0; k<NB_POS; k++)
	addu	a0, s1, i0i2;sll	t4, t8, 1
	addu	a1, s1, i1i3;addu	a0, a0, t4//a0->p0
	addu	a2, s1, i0i2;addu	a1, a1, t4//a1->p1
	addu	a3, s1, i1i3;sll	t4, t9, 1//a2->p2
	addu	a2, a2, t4	;addu	a3, a3, t4//s3->p3
	multa2	m0,zero,zero;move	s6, s3	//s6=ptr_h1
	move	s7, s4		;li		t2, NB_POS-2//s7=ptr_h2
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, t2, s5
	mtru	t0, lps0
	ltp		t4, (s6)+8//t4=h1[0] h1[1] t5=h1[2] h1[3]
	ltp		t6, (s7)+8//t6=h2[0] h2[1] t7=h2[2] h2[3]
	bltz	t2, 2f		//if(t2 < 0) skip inner loop	
	mtru	t1, lpe0
	mtru	t2, lpc0
1:	//for(i=k+1; i<NB_POS;i++)
	madda2.s m0, t4, t6	;ltp	t0, (s6)+8
	addma.s m1l,m0l,m0h	;ltp	t2, (s7)+8
	mfa		v0, m1l		;madda2.s m0, t5, t7
	sra		v0, v0, 16	;addma.s m1h, m0l,m0h
	shp		v0, (a3)-((NB_POS+1)*2);mfa	v1, m1h
	madda2.s m0, t0, t2	;sra	v1, v1, 16
	addma.s m1l,m0l,m0h	;shp	v1, (a2)-((NB_POS+1)*2)
	mfa		v0, m1l		;madda2.s m0, t1, t3
	sra		v0, v0, 16	;addma.s m1h, m0l, m0h
	shp		v0, (a1)-((NB_POS+1)*2);mfa	v1, m1h
	ltp		t4, (s6)+8	;sra	v1, v1, 16
	ltp		t6, (s7)+8	
	shp		v1, (a0)-((NB_POS+1)*2)
2:	// end of i
	madda2.s m0, t4, t6	;sub	t9, t9, NB_POS
	addma.s m1l, m0l,m0h;sub	t8, t8, 1
	mfa		v0, m1l		;madda2.s m0, t5, t7
	sra		v0, v0, 16	;addma.s m1h, m0l,m0h
	sh		v0, 0(a3)	;addu	s4, s4, STEP*2
	mfa		v1, m1h
	sra		v1, v1, 16	
	sh		v1, 0(a2)	
	// end of k
	sub		t4, s5, NB_POS-1
	bnez	t4, 3b
	add		s5, s5, 1	//k++
	
	/* compute elements of: rri0i1[], rri0i3, rri1i2, rri2i3 */
	move	s3, s2		;addu	s4, s2, 6*2//s3->ptr_hd s4->ptr_hf
	li		t9, MSIZE-1	;li		t8, MSIZE-2//t9=l_fin_sup
											//t8=l_fin_inf
	li		s5, 0		//s5=k
	.align	3
3:	//for(k=0;k<NB_POS;k++)
	addu	a0, s1, i0i1;sll	t4, t8, 1
	addu	a1, s1, i1i2;addu	a0, a0, t4//a0->p0
	addu	a2, s1, i2i3;addu	a1, a1, t4//a1->p1
	addu	a3, s1, i0i3;addu	a2, a2, t4//a2->p2
	sll		t4, t9, 1 	;move	s6, s3	//s6=ptr_h1
	addu	a3, a3, t4	;move	s7, s4	//a3->p3 //s7=ptr_h2		
	multa2	m0,zero,zero;li		t2, NB_POS-2
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, t2, s5	
	mtru	t0, lps0
	ltp		t4, (s6)+8//t4=h1[0] h1[1] t5=h1[2] h1[3]
	lwp		t6, (s7)+4
	lwp		t7, (s7)+4
	bltz	t2, 2f		//if(t2<0) skip inner loop
	mtru	t1, lpe0
	mtru	t2, lpc0	;nop
1:
	madda2.s m0, t4, t6	;ltp	t0, (s6)+8
	addma.s m1l, m0l,m0h;lwp	t2, (s7)+4
	mfa		v0, m1l		;madda2.s m0, t5, t7
	sra		v0, v0, 16	;lwp	t3, (s7)+4
	shp		v0, (a3)-((NB_POS+1)*2);addma.s m1h,m0l,m0h
	madda2.s m0, t0, t2	;mfa	v1, m1h
	addma.s m1l, m0l,m0h;sra	v1, v1, 16
	mfa		v0, m1l		;madda2.s m0, t1, t3
	sra		v0, v0, 16	;shp	v1, (a2)-((NB_POS+1)*2)
	shp		v0, (a1)-((NB_POS+1)*2);addma.s m1h, m0l,m0h
	mfa		v1, m1h		;nop
	sra		v1, v1, 16	;ltp	t4, (s6)+8
	shp		v1, (a0)-((NB_POS+1)*2)
	lwp		t6, (s7)+4
	lwp		t7, (s7)+4
2:
	madda2.s m0, t4, t6	;sub	t9, t9, NB_POS
	addma.s m1l, m0l,m0h;sub	t8, t8, 1
	mfa		v0, m1l		;addu	s4, s4, (STEP*2)
	sra		v0, v0, 16
	sh		v0, 0(a3)
	//end of k
	sub		t4, s5, NB_POS-1
	bnez	t4, 3b
	addi	s5, s5, 1	//k++

	//////////////////
	lw		t4, 52(sp)	//mmd	
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		s4, 36(sp)
	lw		s5, 40(sp)
	lw		s6, 44(sp)
	lw		s7, 48(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128

	.end	g7231_Cor_hs

/*
void Cor_h_X(Word16 h[], Word16 X[], Word16 D[])
	a0->h[]		align 8
	a1->X[]		align 8
	a2->D[] 	align 4
local:
	y32[]->g7231_TmpVct[]	
	40(sp)->mmd
*/
	.text
	.set	noat
	.set	noreorder
	.globl	g7231_Cor_h_Xs
	.ent	g7231_Cor_h_Xs
g7231_Cor_h_Xs:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;move	s0, a0//s0=h[]
	sw		ra, 36(sp)	;li		t5, 0x6
	mfru	t4, mmd		;move	s1, a1//s1=X[]
	mtru	t5, mmd		;move	s2, a2//s2=D[]
	sw		t4, 40(sp)	
	/* first keep the result on 32 bits and find absolute maximum */
	.extern	g7231_TmpVct
	la		s3, g7231_TmpVct	//s3->y32[]
	move	a0, s1		
	move	a1, s0		;move	a2, s3
	jal		crossconvs
	li		a3, SubFrLen
	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/2-1
	mtru	t0, lps0
	mtru	t1, lpe0	;move	a0, s3
	ltp		t4, (a0)+8	;li		t9, 0	//t9=max
	mtru	t2, lpc0
	.align	3
1:
	absr.s	t0, t4		;absr.s	t1, t5
	max		t9, t9, t0	;ltp	t4, (a0)+8
	max		t9, t9, t1	;li		t6, 16
2:	
	/* Find the number of right shift to do on y32[]
	   so that maximum is on 13 bits */
	cls		t4, t9		;li		t7, 18
	cmveqz	t4, zero, t9	//t4=j
	min		t4, t4, t6
	sub		t4, t7, t4	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/2-1
	mtru	t0, lps0	
	mtru	t1, lpe0
	ltp		t0, (s3)+8
	mtru	t2, lpc0
	.align	3
1:
	sra		t0, t0, t4	;sra	t1, t1, t4		
	mux2.ll	t5, t0, t1	;ltp	t2, (s3)+8
	swp		t5, (s2)+4	;nop
	move	t0, t2		;move	t1, t3
2:		
	lw		ra, 36(sp)	
	lw		t4, 40(sp)//mmd
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)	
	lw		s3, 32(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64

	.end	g7231_Cor_h_Xs

/*
Word16 D4i64_LBC(Word16 Dn[], Word16 rr[], Word16 h[],
 	Word16 cod[], Word16 y[], Word16 *code_shift, Word16 *sign)
	a0->Dn[]					align 4 =s0
	a1->rr[]					align 4 =s1
	a2->h[]						align 8 sp()
	a3->cod[]					align 4 sp()
	t0->y[]			//for GHS	align 4 sp()
	t1->*code_shift	//for GHS			sp()
	t2->*sign		//for GHS			sp()
local:
	h[]->32(sp)
	cod[]->36(sp)
	y[]->40(sp)
	*code_shift->44(sp)
	*sign->48(sp)
	mmd->84(sp)
	p_sign[]->g7231_TmpVct
	s2=p_sign[], [ip0 ip1]
	s3=thres
	s4=[ip2 ip3]
	s5=[psc alpha]
	s6=[time shif]
*/
	.text
	.set	noat
	.set	noreorder
	.globl	D4i64_LBCs
	.ent	D4i64_LBCs
D4i64_LBCs:
	lw		t0, 16(sp)	//load y[] to t0
	lw		t1, 20(sp)	//load *code_shift to t1
	lw		t2, 24(sp)	//load *sign to t2
	nop
	subu	sp, sp, 128
	sw		s0, 52(sp)
	sw		s1, 56(sp)
	sw		s2, 60(sp)
	sw		s3, 64(sp)	;move	s0, a0//s0=Dn[]
	sw		s4, 68(sp)	;move	s1, a1//s1=rr[]
	sw		s5, 72(sp)
	sw		s6, 76(sp)
	sw		s7, 80(sp)
	sw		a2, 32(sp)	//h[]
	sw		a3, 36(sp)	//cod[]
	sw		t0, 40(sp)	//y[]
	sw		t1, 44(sp)	//code_shift
	sw		t2, 48(sp)	//sign
	//////////////////
	.extern	g7231_TmpVct
	la		s2, g7231_TmpVct	//s2->p_sign[]
	sw		zero, 120(s0)	//store [0 0] to Dn[60 61]
	sw		zero, 124(s0)	//store [0 0] to Dn[62 63]
	/* Chose the sign of the impulse */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/2-1
	mtru	t0, lps0
	mtru	t1, lpe0	;move	a0, s0//a0->Dn[0]
	lwp		t0, (a0)+4	;move	a1, s2//a1->p_sign[0]
	mtru	t2, lpc0
	.align	3
1:
	sra		t4, t0, 16	;sll	t5, t0, 16//t4=Dn[i]
	sra		t5, t5, 16	;lwp	t1, (a0)+4//t5=Dn[i+1]
	add		t4, t4, t5	;li		t3, 0x00010001
	bgez	t4, 3f
	li		t2, 1
	li		t2, -1		;subr2.s t0, zero, t0
	sw		t0, -8(a0)	;nop
3:	
	shp		t2, (a1)+2	;move	t0, t1
2:
	sw		t3, 0(a1)	;move	a0, s0	//a0->Dn[0]
	addu	a1, s0, 4	;addu	a2, s0, 8//a1->Dn[2]
										//a2->Dn[4]
	/* compute the search threshold after three pulses */
	/* odd positions & find mean of Dn[i0 i1 i2] */	
	.align	3	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/STEP;li	t6, 0x00020000
	mtru	t0, lps0	;multa2	m0, zero, zero//m0h=L_32
	mtru	t1, lpe0	;li		t7, 0x80000000//t7=max0
	lwp		t0, (a0)+(STEP*2);li t8, 0x80000000//t8=max1
	mtru	t2, lpc0	;li		t9, 0x80000000//t9=max2	
1:
	max2	t7, t0, t7		 ;lwp	t1, (a1)+(STEP*2)
	lwp		t2, (a2)+(STEP*2);madda2.s  m0h, t0, t6
	lwp		t0, (a0)+(STEP*2);madda2.s  m0h, t1, t6
	max2	t8, t1, t8		 ;madda2.s  m0h, t2, t6
	max2	t9, t2, t9		 ;nop //m0h=L_32	
2:
	addr2.s	t7, t7, t8	;mfa	v0, m0h
	addr2.s t7, t7, t9	;sra	v0, v0, 4
	sra		t9, t7, 16	;sll	v0, v0, 16//t9=max0
	sra		v0, v0, 16	;li		t4, threshold//v0=means
	sub		t0, t9, v0//t0=thres
	multa2	m0l, t0, t4
	mfa		v1, m0l
	sra		v1, v1, 15
	add		s3, v1, v0	//s3=thres	
	/* even positions & find mean of Dn[i0]+...*/
	.align	3	
	move	a0, s0		;addu	a1, s0, 4//a0->Dn[0]
	addu	a2, s0, 8	;nop//a1->Dn[2] a2=Dn[4]
	la		t0, 1f
	la		t1, 2f-4
	li		t2, SubFrLen/STEP;li	t6, 0x00000002
	mtru	t0, lps0	;multa2	m0, zero, zero//m0l=L_32
	mtru	t1, lpe0	;li		t7, 0x00008000//t7=max0
	lwp		t0, (a0)+(STEP*2);li t8, 0x00008000//t8=max1
	mtru	t2, lpc0	;li		t9, 0x00008000//t9=max2	
1:
	max2	t7, t0, t7		 ;lwp	t1, (a1)+(STEP*2)
	lwp		t2, (a2)+(STEP*2);madda2.s  m0l, t0, t6
	lwp		t0, (a0)+(STEP*2);madda2.s  m0l, t1, t6
	max2	t8, t1, t8		 ;madda2.s  m0l, t2, t6
	max2	t9, t2, t9		 ;nop //m0l=L_32	
2:
	addr2.s	t7, t7, t8	;mfa	v0, m0l
	addr2.s t7, t7, t9	;sra	v0, v0, 4
	sll		t7, t7, 16	;sll	v0, v0, 16
	sra		t9, t7, 16	;li		t4, threshold//t9=max0
	sra		v0, v0, 16	//v0=means
	sub		t0, t9, v0	//t0=max1
	multa2	m0l, t0, t4
	mfa		v1, m0l
	sra		v1, v1, 15
	add		t0, v1, v0	//t0=max1	
	
	/* Keep maximum threshold between odd and even position */
	max		s3, s3, t0	//s3=thres	
	/*
	 Modification of rrixiy[] to take signs into account
	 */
	//(1)
	la		t0, 1f
	la		t1, 2f-4			//t9=i0
	mtru	t0, lps0	;li		t9, SubFrLen/2/(STEP/2)
	mtru	t1, lpe0	;addu	a0, s1, i0i1//a0->ptr_ri0i1
	addu	a1, s2, 0	//a1->p_sign[i0]
	addu	a2, s2, 2	//a2->p_sign[i1]
	addu	s4, s1, i0i2//s4->ptr_ri0i2
	addu	s5, s1, i0i3//s5->ptr_ri0i3
3:	//for(i0=0; ...)
	li		t2, 8-1		;lhp	t0, (a1)+STEP//t0=p_sign[i0]
	mtru	t2, lpc0	//t2=(SubFrLen-2)/8
	.align	3	
1:	//for(i1=1; ...)
	lhp		t1, (a2)+2
	lhp		t2, (a2)+2
	lhp		t3, (a2)+4	;add	v0, t0, t1
	lhp		t4, (a0)+2	;add	v1, t0, t2
	lhp		t5, (s4)+2	;add	a3, t0, t3
	lhp		t6, (s5)+2	;sub	s6, zero, t4
	cmveqz	t4, s6, v0	;sub	s7, zero, t5//t4=*ptr_ri0i1
	cmveqz	t5, s7, v1	;sub	s6, zero, t6//t5=*ptr_ri0i2
	cmveqz	t6, s6, a3	;sh		t4, -2(a0)
	sh		t5, -2(s4)
	sh		t6, -2(s5)
2:	//end of i1
	
	//end of i0
	sub		t9, t9, 1
	bgez	t9, 3b
	subu	a2, a2, 8*8
	
	//(2)
	la		t0, 1f
	la		t1, 2f-4			//t9=i1
	mtru	t0, lps0	;li		t9, SubFrLen/2/(STEP/2)
	mtru	t1, lpe0	;addu	a0, s1, i1i2//a0->ptr_ri1i2
	addu	a1, s2, 2	//a1->p_sign[i1]
	addu	a2, s2, 4	//a2->p_sign[i2]
	addu	s4, s1, i1i3//s4->ptr_ri1i3	
3:	//for(i1=1; ...)
	li		t2, 8-1		;lhp	t0, (a1)+STEP//t0=p_sign[i1]
	mtru	t2, lpc0	//t2=(SubFrLen2-4)/8
	.align	3	
1:	//for(i2=2; ...)
	lhp		t1, (a2)+2
	lhp		t2, (a2)+6
	lhp		t4, (a0)+2	;add	v0, t0, t1
	lhp		t5, (s4)+2	;add	v1, t0, t2		
	nop					;sub	s6, zero, t4
	cmveqz	t4, s6, v0	;sub	s7, zero, t5//t4=*ptr_ri0i1
	cmveqz	t5, s7, v1	;sh		t4, -2(a0)//t5=*ptr_ri0i2	
	sh		t5, -2(s4)	;nop	
2:	//end of i2	
	//end of i1
	sub		t9, t9, 1
	bgez	t9, 3b
	subu	a2, a2, 8*8
	
	//(3)
	la		t0, 1f
	la		t1, 2f-4			//t9=i2
	mtru	t0, lps0	;li		t9, SubFrLen2/2/(STEP/2)-1
	mtru	t1, lpe0	;addu	a0, s1, i2i3//a0->ptr_ri2i3
	addu	a1, s2, 4	//a1->p_sign[i2]
	addu	a2, s2, 6	//a2->p_sign[i3]	
3:	//for(i2=2; ...)
	li		t2, 8-1		;lhp	t0, (a1)+STEP//t0=p_sign[i1]
	mtru	t2, lpc0	//t2=(SubFrLen2-6)/8
	.align	3	
1:	//for(i3=3; ...)
	lhp		t1, (a2)+8	
	lhp		t4, (a0)+2	
	add		v0, t0, t1						
	sub		s6, zero, t4
	cmveqz	t4, s6, v0	//t4=*ptr_ri2i3
	sh		t4, -2(a0)
2:	//end of i3	
	//end of i2
	sub		t9, t9, 1
	bgez	t9, 3b
	subu	a2, a2, 8*8
	
	/*
	 Search the optimum positions of the 4 pulses ...
	 reg:
	 	s0=Dn[]
	 	s1=rr[]
	 	s2=p_sign[0]=g7231_TmpVct[0]
	 	s3=thres
	 	[ip0 ip1]=s4
	 	[ip2 ip3]=s5
	 	[psc alpha]=s6
	 	[time shif]=s7
	 	t4=[psx psxa], x=0,1,2
	 	[i0 i1]=t9
	 	[i2 i3]=t8
	 	t7=ptr_i2i2 t6=ptr_i0i2 t5=ptr_i1i2
	 	a0=ptr_i3i3 a1=ptr_i0i3 a2=ptr_i1i3 a3=ptr_i2i3
	 	temp_reg:
	 		t0,t1,t2,t3
	 		v0,v1	 
	 var:	 	
	 	g7231_TmpVct[40]=[ps0 ps0a]
	 	g7231_TmpVct[42]=[ps1 ps1a]
	 	g7231_TmpVct[44]=[ps2 ps2a]
	 	g7231_TmpVct[46]=[ps0 ps0a]
	 	//g7231_TmpVct[48]=[x shift]
	 	g7231_TmpVct[50]=ptr_ri0i0
	 	g7231_TmpVct[52]=ptr_ri0i1
	 	g7231_TmpVct[54]=ptr_ri1i1
	 	g7231_TmpVct[56]=alp1
	 	Tmpvct[58]=alp2
	 	
	*/		
	.align	3
	mfru	t1, mmd		;li	t2, 0x6//frac mpy
	mtru	t2, mmd		;sw	t1, 84(sp)//store mmd
	.extern extra
	lh		t0, extra
	li		s4, 0x00000002//s4=[ip0 ip1]
	li		s5, 0x00040006//s5=[ip2 ip3]
	li		s6, 0x00007fff//s6=[psc alpha]	
	add		s7, t0, max_time
	sll		s7, s7, 16	  //s7=[time shif]
	/* Four loops to search innovation code. */
	//t6=ptr_ri0i2 a1=ptr_ri0i3
	addu	t0, s1, i0i0	;addu	t1, s1, i0i1
	addu	t6, s1, i0i2	;sw		t0, (50*2)(s2)//g7231_TmpVct[50]=ptr_ri0i0
	addu	a1, s1, i0i3	;sw		t1, (52*2)(s2)//g7231_TmpVct[52]=ptr_ri0i1
	
	/* first pulse loop  */
    .align 3
	li		t9, 0x00000000	;nop//t9=[i0 z]	
for_i0:
	//and		t9, t9, 0xffff0000;nop	//clear i1
	li		t1, 0xffff0000
	and		t9, t9, t1	//clear i1
	sra		t0, t9, 16	;addu	t1, s1, i1i1//t0=i0
	sll		t0, t0, 1	;sw		t1, (54*2)(s2)//store ptr_ri1i1
	addu	t0, t0, s0	;addu	a2, s1, i1i3//t0->Dn[i0]
	lw		t4, 0(t0)	;addu	t5, s1, i1i2//t4=[ps0 ps0a]			
	 /* second pulse loop */	
	ori		t9, t9, 0x00000002	//t9=[i0 i1]
	sw		t4, (40*2)(s2) 	//store [ps0 ps0a]
for_i1:	
	mux2.hl t0, zero, t9;lw		t1, (50*2)(s2)//t1=ptr_ri0i0 //t0=i1
	sll		t0, t0, 1	;lw		t4, (40*2)(s2)	//t4=[ps0 ps0a]
	addu	t0, t0, s0	;lhp	t2, (t1)+2//t2=*ptr_ri0i0
	lw		t0, 0(t0)	;nop//t0=[Dn[i1] Dn[i1+1]]
	lw		t3, (54*2)(s2)
	addr.s	t2, t2, t2	//t2=alp1=L_mult(*ptr_ri0i0,1)
	lw		v0, (52*2)(s2);addr2.s	t4, t4, t0	//t4=[ps1 ps1a]
	lhp		t0, (t3)+2	//t0=*ptr_ri1i1
	lhp		v1, (v0)+2	//v1=*ptr_ri0i1
	sw		t3, (54*2)(s2);addr.s	t2, t2, t0
	sw		v0, (52*2)(s2);addr.s	t2, t2, t0//t2=alp1=L_mac(alp1, *ptr_ri1i1,1)
	sll		v1, v1, 2	  ;addu	t7, s1, i2i2
	addr.s	t2, t2, v1	  ;sw	t4, (42*2)(s2)//t2=alp1
	sw		t2, (56*2)(s2);nop//store alp1
	  /* 3rd pulse loop */	//t4->store [ps1 ps1a]
	li		t8, 0x00040000;addu	a3, s1, i2i3//t8=[i2 z]	
for_i2:							
	sra		t0, t8, 16	;lw		t4, (42*2)(s2)//t4=[ps1 ps1a]
	sll		t0, t0, 1	;lhp	v0, (t7)+2//v0=*ptr_ri2i2
	addu	t0, t0, s0	;lhp	v1, (t6)+2//v1=*ptr_ri0i2
	lw		t0, 0(t0)	;sll	v0, v0, 1//t0=[Dn[i2] Dn[i2+1]]
	lhp		t1, (t5)+2	;sll	v1, v1, 2//t1=*ptr_ri1i2
	addr2.s	t4, t4, t0	;lw		t2, (56*2)(s2)//t4=[ps2 ps2a]
	nop					;nop
	addr.s	t2, t2, v0	;sll	t1, t1, 2
	addr.s	t2, t2, v1	;li		t3, 0	//t3=shift
	addr.s	t2, t2, t1	;sra	t0, t4, 16//t2=alp2 t0=ps2
	sll		t1, t4, 16	;sw		t2, (58*2)(s2)//store alp2
	sra		t1, t1, 16	;li		v1, 1//t1=ps2a
	sgt		v0, t1, t0	;mux2.ll t2, t4, t4//t2=[ps2a ps2a]
	cmvnez	t3, v1, v0	//t3=shift
	cmvnez	t4, t2, v0	//t4=[ps2 ps2a]
	sw		t4, (44*2)(s2)	//store [ps2 ps2a]	
	/* Test threshold */
	sra		t0, t4, 16	//t0=ps2
	sub		t2, t0, s3	;li		t1, 0xffff0000
	and		t8, t8, t1//clear i3
	// if(ps2 > thres) {
	blez	t2, 3f
	ori		t8, t8, 0x6	//t8=[i2 i3]
	// can use "t0,t1,t2, v0,v1 "
	addu	a0, s1, i3i3;nop	
		/* 4th pulse loop */
for_i3:	
	//t3=shift t4=[ps2 ps2a]
	mux2.hl	t0, zero, t8//t0=i3
	add		t0, t0, t3
	sll		t0, t0, 1
	addu	t0, t0, s0	//t0->Dn[i3+shift]
	lh		t0, 0(t0)	;sra	t1, t4, 16
	lw		v0, (58*2)(s2);nop//v0=alp2	
	addr2.s	t2, t0, t1//t2=[x ps3]
	lhp		v1, (a0)+2	//v1=*ptr_ri3i3
	lhp		t0, (a1)+2	//t0=*ptr_ri0i3
	lhp		t1, (a2)+2	//t1=*ptr_ri1i3
	sll		v1, v1, 1	;sll	t0, t0, 2
	addr.s	v0, v0, v1	;sll	t1, t1, 2
	addr.s	v0, v0, t0	;lhp	v1, (a3)+2//v1=*ptr_ri2i3
	addr.s	v0, v0, t1	;multa2	m0l, t2, t2
	sll		v1, v1, 2
	addr.s	v0, v0, v1	//v0=alp3
	sra		v1, v0, 5	;mfa	t0, m0l	
	sll		v1, v1, 16	;nop
	sra		v1, v1, 16	;sra t0, t0, 16//v1=alp t0=ps3c
	mux2.ll	v1, v1, t0	//v1=[alp ps3c]
	multa2	m0, v1, s6
	mfa		t0, m0h	//t0=L_mult(alp, psc)
	mfa		t1, m0l		//t1=L_mult(ps3c, alpha)
	sgt		v0, t1, t0	;mux2.lh v1, v1, v1//v1=[ps3c alp]
		//update s6[psc alpha] s4[ip0 ip1] s5[ip2 ip3] s7[time shif]
	cmvnez	s6, v1, v0	;cmvnez	s4, t9, v0//up [psc alpha] [ip0 ip1]
	cmvnez	s5, t8, v0	;li		t1, 0xffff0000
	and		t2, s7, t1	;nop
	or		t2, t2, t3	;li		t1, STEP//t2=[time shift]
	cmvnez	s7, t2, v0
	// end of for i3
	mux2.hl	t0, zero, t8	//t0=i3
	sub		t0, t0, SubFrLen2-STEP
	bltz	t0, for_i3
	addr2.s	t8, t8, t1
	
	// time--;
	li		t1, 0x00010000
	subr2.s	s7, s7, t1	//[time-- shif]
	sra		t0, s7, 16
	blez	t0, end_searchs
	nop
	subu	a1, a1, (NB_POS*2)//ptr_ri0i3-=NB_POS	
	j		4f
	subu	a2, a2, (NB_POS*2)//ptr_ri1i3 -= NB_POS	
	// }end of if > thres
3:	// else {
	addu	a3, a3, (NB_POS*2)//ptr_ri2i3+=NB_POS
4: 	// }
	// end of for i2
	sra		t0, t8, 16	;li	t1, 0x00080000	//t1=[STEP z]
	sub		t0, t0, SubFrLen2-STEP
	bltz	t0, for_i2
	addr2.s	t8, t8, t1
	
	subu	t6, t6, (NB_POS*2)//ptr_ri0i2-=NB_POS
	addu	a2, a2, (NB_POS*2)//ptr_ri1i3+=NB_POS
	// end of for i1
	mux2.hl	t0, zero, t9;li	t1, STEP
	sub		t0, t0, SubFrLen-STEP
	bltz	t0, for_i1
	addr2.s t9, t9, t1
	
	lw		t0, (50*2)(s2)
	addu	t6, t6, (NB_POS*2)//ptr_ri0i2+=NB_POS
	addu	a1, a1, (NB_POS*2)//ptr_ri0i3++NB_POS
	addu	t2, t0, 2		//ptr_ri0i0++
	sw		t2, (50*2)(s2)	
	
	// end of for i0
	sra		t0, t9, 16	;li	t1, 0x00080000//t0=i0
	sub		t0, t0, SubFrLen-STEP	//t1=[STEP z]
	bltz	t0, for_i0
	addr2.s	t9, t9, t1	//i0 += STEP	
	
end_searchs:	
	
	sra		t0, s7, 16
	.extern extra
	la		t2, extra
	//sh		t0, extra
	sh		t0, 0(t2)
	li		t1, 0x1
	/* Set the sign of impulse */
	srav2	s4, s4, t1	;srav2	s5, s5, t1
	sllv2	s4, s4, t1	;sllv2	s5, s5, t1
	sra		a0, s4, 16	;mux2.hl a1, zero, s4
	sra		a2, s5, 16	;mux2.hl a3, zero, s5
	addu	a0, a0, s2	;addu	a1, a1, s2//a0->p_sign[...]
	lh		t0, 0(a0)	;addu	a2, a2, s2//t0=i0
	lh		t1, 0(a1)	;addu	a3, a3, s2//t1=i1	
	lh		t2, 0(a2)		//t2=i2
	lh		t3, 0(a3)		//t3=i3
	/* Find the codeword corresponding to the selected ... */
	lw		a0, 36(sp)	//a0->cod[0]
	la		t4, 1f
	la		t5, 2f-4
	li		t6, SubFrLen/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0	;move	a1, a0//a1->cod[0]
	.align	3
1:
	swp		zero, (a0)+4;nop
	swp		zero, (a0)+4;nop
2:
	mux2.hl	t4, zero, s7	;li		t5, 0x00010001//t4=shif
	sgt		t4, t4, zero	;addr2.s t6, s4, t5
	cmvnez	s4, t6, t4		;addr2.s t7, s5, t5
	cmvnez	s5, t7, t4		;sra	t4, s4, 16//t4=ip0
	mux2.hl	t5, zero, s4	;sll	t4, t4, 1
	sll		t5, t5, 1		;addu	t4, t4, a1//t4->cod[ip0]
	addu	t5, t5, a1		;sh		t0, 0(t4)	//cod[ip0]=i0
	sh		t1, 0(t5)		;sra	t6, s5, 16//t6=ip2
	mux2.hl	t7, zero, s5	;sub	v0, t6, SubFrLen //t7=ip3
	//if(ip2<SubFrLen)
	bgez	v0, 3f	
	sll		t6, t6, 1
	addu	t6, t6, a1//t6->cod[ip2]
	sh		t2, 0(t6)	
3:	//if(ip3<SubFrLen)
	sub		v1, t7, SubFrLen
	bgez	v1, 4f
	sll		t7, t7, 1
	addu	t7, t7, a1//t7->cod[ip3]
	sh		t3, 0(t7)
4:
	/* find the filtered codeword */
	lw		a0, 40(sp)	//a0->y[0]
	la		t4, 1f
	la		t5, 2f-4
	li		t6, SubFrLen/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
1:
	swp		zero, (a0)+4;sgt	t7, t0, zero//t7=i0>0?1:0
	swp		zero, (a0)+4;sgt	t8, t1, zero//t8=i1>0?1:0
2:
	//if (i0>0)
	lw		a1, 32(sp)	;subu	a0, a0, 2*SubFrLen
	la		t4, 1f				//a1->h[0]
	move	s0, a0		;move	s1, a1//s0->y[0] s1->h[0]
	lhp		a3, (a1)+2	;sra	v0, s4, 16//a3=h[0]
	la		t5, 2f-4		
	addu	a0, a0, v0	
	addu	a0, a0, v0	//a0->y[ip0]
	lhp		a2, (a0)+2	;nop//a2=y[ip0]
	mtru	t4, lps0	;sra	t6, s4, 16	
	mtru	t5, lpe0	;li		v0, SubFrLen-1
	sub		t6, v0, t6	
	mtru	t6, lpc0	
1:
	add		v0, a2, a3	;sub	v1, a2, a3//v0=y+h
	lhp		a2, (a0)+2	;move	t4, v0//v1=y-h
	lhp		a3, (a1)+2	;cmveqz	t4, v1, t7	
	sh		t4, -4(a0)	;nop
2:	
	// if(i1>0)
	move	a1, s1		;mux2.hl a0, zero, s4
	la		t4, 1f
	li		t6, SubFrLen-1;mtru	t4, lps0//a1->h[0]
	la		t5, 2f-4
	sub		t6, t6, a0	;mtru	t5, lpe0
	sll		a0, a0, 1	;mtru	t6, lpc0
	addu	a0, a0, s0	//a0->y[ip1]	
	lhp		a2, (a0)+2	//a2->y[ip1]
	lhp		a3, (a1)+2	//a3->h[0]
1:
	add		v0, a2, a3	;sub	v1, a2, a3	
	lhp		a2, (a0)+2	;move	t4, v0
	lhp		a3, (a1)+2	;cmveqz	t4, v1, t8	
	sh		t4, -4(a0)	;nop
2:
	// if(ip2 < SubFrLen)
	sra		t5, s5, 16	;sgt	t7, t2, zero//t5=ip2
	sub		v0, t5, SubFrLen
	bgez	v0, 2f
	li		t6, SubFrLen-1
	la		t4, 1f
	la	 	t8, 2f-4
	sub		t6, t6, t5
	mtru	t4, lps0
	mtru	t8, lpe0	;move	a1, s1//a1->h[0]
	mtru	t6, lpc0	;addu	a0, s0, t5
	addu	a0, a0, t5	;lhp	a3, (a1)+2//a0->y[ip2]
	lhp		a2, (a0)+2	;nop
1:
	add		v0, a2, a3	;sub	v1, a2, a3
	lhp		a2, (a0)+2	;move	t4, v0
	lhp		a3, (a1)+2	;cmveqz	t4, v1, t7
	sh		t4, -4(a0)	;nop
2:		
	// if(ip3 < SubFrLen)	
	mux2.hl	t5, zero, s5;sgt	t7, t3, zero//t5=ip3
	sub		v0, t5, SubFrLen
	bgez	v0, 2f
	li		t6, SubFrLen-1
	la		t4, 1f
	la	 	t8, 2f-4
	sub		t6, t6, t5
	mtru	t4, lps0
	mtru	t8, lpe0	;move	a1, s1//a1->h[0]
	mtru	t6, lpc0	;addu	a0, s0, t5
	addu	a0, a0, t5	;lhp	a3, (a1)+2//a0->y[ip3]
	lhp		a2, (a0)+2	;nop
1:
	add		v0, a2, a3	;sub	v1, a2, a3
	lhp		a2, (a0)+2	;move	t4, v0
	lhp		a3, (a1)+2	;cmveqz	t4, v1, t7
	sh		t4, -4(a0)	;nop
2:
	/* find codebook index; 17 bit address */
	lw		a0, 44(sp)	//a0->code_shift
	mux2.hl	v0, zero, s7//v0=shif
	lw		a1, 48(sp)	//a1->sign
	sh		v0, 0(a0)	// *code_shift = shif
	
	li		v1, 0	//v1=*sign
	add		t4, v1, 1	;sgt	t5, t0, zero
	cmvnez	v1, t4, t5	//if(i0>0) *sign=*sign+1
	sgt		t6, t1, zero
	add		t4, v1, 2	;sgt	t7, t2, zero
	cmvnez	v1, t4, t6	;sgt	t8, t3, zero	
	add		t4, v1, 4	;sra	s0, s4, 16//s0=ip0
	cmvnez	v1, t4, t7	;mux2.hl s1, zero, s4//s1=ip1
	add		t4, v1, 8	;sra	s2, s5, 16//s2=ip2
	cmvnez	v1, t4, t8	;mux2.hl s3, zero, s5//s3=ip3
	sh		v1, 0(a1)	;sra	v0, s0, 3// v1=*sign v0=i
	and		s1, s1, 0xfff8;sra	s2, s2, 3
	add		v0, v0, s1	;sll	s2, s2, 6
	add		v0, v0, s2	;sra	s3, s3, 3
	sll		s3, s3, 9
	add		v0, v0, s3//v0=i
	
	//////////////////
	lw		t4, 84(sp)	//mmd
	lw		s0, 52(sp)
	lw		s1, 56(sp)
	lw		s2, 60(sp)
	lw		s3, 64(sp)
	lw		s4, 68(sp)
	lw		s5, 72(sp)
	lw		s6, 76(sp)
	lw		s7, 80(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128

	.end	D4i64_LBCs

