#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define SubFrLen	60

/*
 void Rem_Dc(Word16 *Dpnt)
 	a0->Dpnt (align 8)
 note. 
 	only High pass filter been implemented !! 	
*/
.if 0
	.text
	.set	noat
	.set	noreorder
	.globl	Rem_Dcs
	.ent	Rem_Dcs
Rem_Dcs:
	// fast version
	la		t0, 1f
	la		t1, 2f
	li		t2, Frame-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	//lw		t8, pCodStat// t8->CodStat.HpfZdl (Word16)
	.extern pCoderMem
	lw		t8, pCoderMem	
	lh		t4, 0(a0)	//t4=Dpnt[i]	
	addu	t8, t8, 784	//t8->pCoderMem->CodStat
	lh		t5, 0(t8)	//t5=CodStat.HpfZdl
	addu	t9, t8, 4	// t9->CodStat.HpfPdl (Word32)	
	lw		t6, 0(t9)	//t6=.CodStat.HpfPdl
1:	
	subr	v0, t4, t5	;sra	v1, t6, 7
	addr	v0, v0, 1	;subr	v1, t6, v1
	sra		v0, v0, 1	;move	t5, t4
	addr	t6, v0, v1	;lh		t4, 2(a0)
	shp		t6, (a0)+2	;nop
2:	

	.end	Rem_Dcs
	
.endif

/************************************************

Word16 Vec_Norm( *Vect,				// (i)
				 Word16 *Vect_Norm, // (o)
				 Word16 Len )		// (i)
input:
	a0->Vect
	a1->Vect_Norm
	a2->Len				 
*/				 
	.set	noreorder
	.set	noat
	.text
	.globl	Vec_Norms	
	.ent	Vec_Norms
Vec_Norms:
	sub		sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		ra, 36(sp)
	sw		s2, 28(sp);	move s0, a0
	sw		s3, 32(sp);	move s1, a1

	and		t6, a2, 0x1		// if Len = odd, then add 1 to Len and zero Vect[Len]
	beqz	t6, 1f
	nop	
	sll		t4, a2, 1	
	add		t5, t4, a0
	sh		zero, 0(t5)
	add		a2, a2, t6
1:	
	/* Find absolute maximum (9+Len/2*2+3 )*/
	la		t4, lp0_s		
	la		t5, lp0_e-4		
	sra		t6, a2, 1	;	mtru	t4, lps0
	lwp		t0, (a0)+4								// load 2 samples
	sub		t6, t6, 1	;	mtru	t5, lpe0		//t6=Len/2-1
	li		t3, 0		
	mtru	t6, lpc0	;	addiu	t5, zero, 4		// set t5=4
	.align 	3
lp0_s:
	absr2.s t1, t0		;	lwp		t2, (a0)+4		// load 2 samples	
	max2	t3, t1, t3	;	add		t5, t5, 4
	move	t0, t2		;	nop
lp0_e:		
	sra		t2, t3, 16	;	sll		t4, t3, 16		// t2 = high part, t3 = low part	
	sra		t4, t4, 16	;	subu	a0, a0, t5		// reset Vect starting addr
	max		t4, t2, t4								// t4 = maximum value	
	
	/* Get the shift count */	
	move	s2, t6	//s2=Len/2-1
	jal		norm_s					// v0 = Rez	
	move	a0, t4
		
	/* Normailze all the vector */	//(Len/2*3+13)
	la		t4, lp1_s
	la		t5, lp1_e-4
	mtru	t4, lps0
	mtru	t5, lpe0		
	lwp		t0, (s0)+4
	li		t3, 3	 
	mtru	s2, lpc0
	.align	3
lp1_s:	
	sllv2	t1, t0,	v0	;	nop
	srav2	t2, t1, t3	;	lwp		t0, (s0)+4
	swp		t2, (s1)+4	;	nop
lp1_e:	

	sub		v0, v0, 3				// return Rez
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		ra, 36(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)	
	jr		ra
	addiu	sp, sp, 64
	
	.end Vec_Norms


/**********************************************
Word32   Comp_En( Word16 *Dpnt )
	a0 -> Dpnt (align 4)
	(9+4*15+5 = 74)
*/

	.text
	.set 	noat
	.set	noreorder
	.globl	Comp_Ens
	.ent	Comp_Ens
	.align	3
Comp_Ens:
	mfru	t9, mmd			;	ori		t4, zero, 0x6
	mtru	t4, mmd			;	ori		t5, zero, SubFrLen/4-1
	lui		t6, %hi(lps)		;	multa2	m0, zero, zero
	addiu	t6, t6, %lo(lps);	multa2	m1, zero, zero
	lui		t7, %hi(lpe-4)	;	li		t8, 2
	addiu	t7, t7, %lo(lpe-4);	lwp		t0, (a0)+4
	mtru	t6, lps0		;	nop
	mtru	t7, lpe0		;	srav2	t0, t0, t8
	mtru	t5, lpc0
	lwp		t1, (a0)+4
	.align	3
lps:	// loop start		
	madda2.s m0, t0, t0		;	nop
	srav2	t1, t1, t8		;	lwp		t0, (a0)+4
	madda2.s m1, t1, t1		;	nop
	srav2	t0, t0, t8		;	lwp		t1, (a0)+4		
lpe:	// loop end	
	addma.s	m0l, m0l, m0h	;	addma.s m1l, m1l, m1h
	addma.s	m0l, m0l, m1l	;	mtru	t9, mmd
	mfa		v0, m0l
	jr		ra
	nop

	.end Comp_Ens
	
/********************************************
Word16   Sqrt_lbc( Word32 Num )
	a0 -> Num
*/	
	.text
	.set	noat
	.set	noreorder
	.globl	Sqrt_lbcs
	.ent	Sqrt_lbcs
Sqrt_lbcs:
	ori		t0, zero, 0				// t0=Rez
	ori		t1, zero, 0x00004000	// t1=Exp
	la		t4, 1f
	la		t5, 2f-4
	ori		t6, zero, 14-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	ori		t4, zero, 0x6
	mfru	t9, mmd
	mtru	t4, mmd	
1:
	add		t2, t0, t1
	multa2	m0l, t2, t2
	mfa		v0, m0l
	sub		t4, a0, v0
	bltz	t4, 3f
	nop	
	ori		t0, t2, 0			// Rez=Rez+Exp
3:
	sra		t1, t1, 1
2:
	mtru	t9, mmd
	jr		ra
	ori		v0, t0, 0
	.end Sqrt_lbcs

/******************************************
void  Scale( Word16 *Tv, Word32 Sen )
	a0 -> Tv (align 4)
	a1 -> Sen
 local:
	t8 -> SfGain
	t9 -> mmd
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Scales
	.ent	Scales
Scales:
	sub		sp, sp, 64
	sw		s0, 20(sp)		// Tv
	sw		s1, 24(sp)		// Acc0 = Sen
	sw		s2, 28(sp)		// Acc1 = Comp_En(Tv)
	sw		s3, 32(sp)		// Exp
	sw		ra, 36(sp)
	ori		s0, a0, 0		// s0 = Tv
	ori		s1, a1, 0		// s1 = Acc0 = Sen
	////////////////////////////
	jal		Comp_Ens			
	nop
	ori		s2, v0, 0		// s2 = Acc1 = Comp_En(Tv)
	
	/* Normalize both */
	beqz	s2, 1f
	nop
	beqz	s1, 1f
	nop
	jal		norm_l			// Exp = norm_l(Acc1)
	ori		a0, s2, 0
	sll		s2, s2, v0
	ori		s3, v0, 0		// s3 = Exp
	jal		norm_l
	ori		a0, s1, 0
	ori		t8, v0, 0		// t8 = SfGain
	sll		s1, s1, v0
	sra		s1, s1, 1
	sub		s3, s3, t8		// Exp = Exp - SfGain
	addiu	s3, s3, 1
	li		t4, 6
	sub		s3, t4, s3
	max		s3, s3, zero	// if (Exp < 0) ? 0 : Exp
	sra		a1, s2, 16		// SfGain = extract_h(Acc1)	
	jal		div_l			// SfGain = div_l(Acc0, SfGain)
	ori		a0, s1, 0
	sll		a0, v0, 16		// Acc0 = L_deposit_h(SfGain)
	jal		Sqrt_lbcs
	srav	a0, a0, s3		// Acc0 = L_shr( Acc0, Exp )
	j		2f
	ori		t8, v0, 0		
1:
	ori		t8, zero, 0x00001000	//	t8 = SfGain	
2:	
	/* Filter the data */	// a0 = Exp, a1 = Exp2, a2 = Gain, a3=pDecodMem->DecStat
	mfru	t9, mmd			// v0 = Acc0, v1 = Acc1, 
	ori		t5, 0x6			// fractional and 32 bits S
	mtru	t5, mmd
	//lw		a3, pDecStat	
	//nop
	.extern pDecodMem
	lw		a3, pDecodMem	//a3->pDecodMem->DecStat
	la		t4, 3f
	la		t5, 4f-4
	lh		a2, 10(a3)		// DecStat.Gain	
	li		t6, SubFrLen/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0		
	//mta2	zero, m0
	ori		t0, zero, 0x00000800
	ori		t1, zero, 0x00008000	
3:	// loop start (32*30=960)
	sll		v0, a2, 16		
	sub		t2, t8, a2
	//madda2.s m0l, t2, t0
	multa2	m0l, t2, t0
	mfa		t4, m0l			// t4 = (SfGain-Gain)*0x0800
	addr.s	v0, v0, t4		// Acc0 + t4
	addr.s	v0, v0, t1		// Acc0+t4+0x00008000
	sra		a2, v0, 16
	sra		t3, a2, 4		
	add		a0, a2, t3		// Exp = Gain+(Gain>>4);	
	sll		v1, a2, 16 		// Acc1 = L_deposit_h(Gain)
	sub		t2, t8, a2
	multa2	m0l, t2, t0
	mfa		t4, m0l	
	addr.s	v1, v1, t4		// Acc1+t4
	addr.s	v1, v1, t1		// Acc1+t4+0x00008000
	sra		a2, v1, 16
	sra		t3, a2, 4
	add		a1, a2, t3		// Exp2 = Gain+(Gain>>4)
	lw		t6, (s0)		// t6 = [Tv[i] Tv[i+1]]
	sll		a0, a0, 16
	or		t4, a0, a1		// t4 = [Exp Exp2]
	multa2 	m0, t6, t4
	addma.s m0h, m0h, m0h	// L_shl(Acc0, 4)
	addma.s m0l, m0l, m0l	// L_shl(Acc1, 4)
	addma.s m0h, m0h, m0h
	addma.s m0l, m0l, m0l
	addma.s m0h, m0h, m0h
	addma.s m0l, m0l, m0l
	addma.s m0h, m0h, m0h
	addma.s m0l, m0l, m0l
	mfa		v0, m0h
	mfa		v1, m0l
	addr.s	v0, v0, t1
	addr.s	v1, v1, t1
	sra		v0, v0, 16
	sra		v1, v1, 16
	shp		v0, (s0)+2
	shp		v1, (s0)+2
4:	// loop end
	sh		a2, 10(a3)		// Gain = pDecStat->Gain
	////////////////////////////
	mtru	t9, mmd
	lw		ra, 36(sp)
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	jr		ra
	addiu	sp, sp, 64
	.end Scales


		
