#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define BIT_0	0
#define BIT_1	1

/*
void int2bin(Word16 value, Word16 no_of_bits, Word16 *bitstream)
	a0->value
	a1->no_of_bits
	a2->*bitstream
*/

	.text
	//.section ".text.int2bins"
	.set	noreorder
	.globl	int2bins
	.ent	int2bins
int2bins:
	.align	3
	sll		t0, a1, 1
	addu	a2, a2, t0	//a2->pt_bitstream
	la		t4, 1f
	la		t5, 2f-4
	sub		t6, a1, 1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
1:	
	and		t4, a0, 1	;subu	a2, a2, 2
	sh		t4, 0(a2)	;nop
	sra		a0, a0, 1	;nop
2:
	jr		ra
	nop

	.set	reorder
	.end	int2bins

/*
Word16 bin2ints(Word16 no_of_bits, Word16 *bitstream)
	a0->no_of_bits
	a1->bitstream	//align 2
*/
	.text
	//.section ".text.bin2ints"
	.set	noreorder
	.globl	bin2ints
	.ent	bin2ints
bin2ints:
	.align	3
	li		v0, 0		;sub	t2, a0, 1//v0=value
	lhp		t4, (a1)+2	;li		t9, BIT_1//t4=bitstream[0],now, a1 align 4
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align	3
1:	
	sll		t0, v0, 1	;lhp	t5, (a1)+2
	seq		t2, t4, t9	;addi	t1, t0, 1
	cmvnez	t0, t1, t2	;move	t4, t5
	move	v0, t0		;nop
2:
	jr		ra
	nop
	.set	reorder
	.end	bin2ints

