#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define L_SUBFR		40
#define L_FRAME		80
#define FLAG_DEC	1
#define FRAC1       19043
#define K0          24576
#define G_MAX       5000


/*
void Calc_exc_rand(Word16 cur_gain, Word16 *exc, Word16 *seed, Flag flag_cod)
	a0->cur_gain
	a1->*exc		align 4
	a2->*seed
	a3->flag_cod
local:
	excg[]->g729_TmpVct[0]
	excs[]->g729_TmpVct[40]	
	pos[0]->g729_TmpVct[80]
	sign[0]->g729_TmpVct[81]	
	t0->g729_TmpVct[88 89] 32 bits
	frac->g729_TmpVct[90 91] 32 bits
	Gp->g729_TmpVct[92 93] 32 bits
	Gp2->g729_TmpVct[94 95] 32 bits
	L_k->g729_TmpVct[96 97]
*/
	.text
	//.section ".text.Calc_exc_rands"
	.set	noreorder
	.globl	Calc_exc_rands
	.ent	Calc_exc_rands
Calc_exc_rands:
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0//s0=cur_gain
	sw		s3, 40(sp)	;move	s1, a1//s1=exc[]
	sw		s4, 44(sp)	;move	s2, a2//s2=seed[]
	sw		s5, 48(sp)	;move	s3, a3//s3=flag_cod
	sw		s6, 52(sp)
	sw		s7, 56(sp)
	.extern g729_TmpVct
	la		s4, g729_TmpVct	//s4->g729_TmpVct[0]
	/////////////////
	bnez	a0, 3f
	li		t2, L_FRAME/8-1
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0
	mtru	t1, lpe0	
	mtru	t2, lpc0
1:
	swp		zero, (a1)+4
	swp		zero, (a1)+4
	swp		zero, (a1)+4
	swp		zero, (a1)+4
2:
	li		a0, 0	//a0=Gp
	li		t1, FLAG_DEC
	li		a1, L_SUBFR+1//a1=t0	
	sne		t0, a3, t1
	beqz	t0, 1f
	nop
	jal		update_exc_err
	nop
	li		a0, 0	
	jal		update_exc_err
	li		a1, L_SUBFR+1
1:
	j		9f
	nop
3:	/* Loop on subframes */
	li		s5, 0		//s5=i_subfr
8:	// for(i_subfr=0; i_subfr<L_FRAME; i_subfr+=L_SUBFR)
	
	/* generate random adaptive codebook & fixed codebook parameters */
	/*****************************************************************/
	jal		Randoms
	move	a0, s2		//v0=temp1
	and		t0, v0, 0x3
	sub		t8, t0, 1
	sub		t1, t8, 2	;sra	v0, v0, 2	//temp1=shr(temp1, 2)
	cmveqz	t8, zero, t1;and	t0, v0, 0x3f//t8=frac
	add		t0, t0, 40	;sra	v0, v0, 6 //t0=t0
	and		v1, v0, 0x7	;sw		t0, (2*88)(s4)//v1=temp2
	//pos[0]
	sll		t1, v1, 2	;sw		t8, (2*90)(s4)//store frac
	add		t1, v1, t1	//t1=pos[0]
	sra		v0, v0, 3	//v0=temp1
	and		t2, v0, 0x1	//t2=sign[0]
	sra		v0, v0, 1	;mux2.ll	t1, t1, t2
	and		v1, v0, 0x7	;sw		t1, (2*80)(s4)//v1=temp2
	sll		t0, v1, 2	//store pos[0] sign[0] to g729_TmpVct[80 81]
	add		v1, v1, t0
	add		t1, v1, 1	//t1=pos[1]
	sra		v0, v0, 3
	and		t2, v0, 0x1	//t2=sign[1]
	mux2.ll	t1, t1, t2
	sw		t1, (2*82)(s4)//store pos[1] sign[1] to g729_TmpVct[82 83]
	jal		Randoms
	move	a0, s2	//v0=temp1
	and		v1, v0, 0x7//v1=temp2
	sll		t0, v1, 2
	add		v1, v1, t0
	add		t1, v1, 2	//t1=pos[2]
	sra		v0, v0, 3
	and		t2, v0, 0x1	//t2=sign[2]
	sra		v0, v0, 1	;mux2.ll	t1, t1, t2
	and		v1, v0, 0xf	;sw		t1, (2*84)(s4)	
	and		t0, v1, 0x1	//store pos[2] sign[2] to g729_TmpVct
	add		t1, t0, 3	//t1=pos[3]
	sra		v1, v1, 1
	and		v1, v1, 0x7
	sll		t0, v1, 2
	add		v1, v1, t0
	add		t1, t1, v1	//t1=pos[3]
	sra		v0, v0, 4
	and		t2, v0, 0x1
	mux2.ll	t1, t1, t2
	sw		t1, (2*86)(s4)	//store pos[3] sign[3] to g729_TmpVct
	
	jal		Randoms
	move	a0, s2
	and		v0, v0, 0x00001fff	
	sll		v1, v0, 1	//v1=Gp2
	st		v0, (2*92)(s4) 	//store Gp Gp2
	/* Generate gaussian excitation */
	/********************************/
	//la		t0, 1f
	//la		t1, 2f-4
	//li		t2, L_SUBFR/2-1
	//mtru	t0, lps0
	/*mtru	t1, lpe0	;*/move		s7, s4	//s7->excg[0]
	/*mtru	t2, lpc0	;*/multa2	m1, zero, zero
	
	li		a3, L_SUBFR/2
1:
	jal		Gausss
	move	a0, s2
	move	s6, v0	
	jal		Gausss
	move	a0, s2	
	mux2.ll	t0, s6, v0	//v0=temp1
	madda2.s m1, t0, t0
	swp		t0, (s7)+4

	sub		a3, a3, 1
	bgtz	a3, 1b
	nop

	addma.s m1l,m1l,m1h	
	move	s6, v0		//s6=temp1
	mfa		a0, m1l
	jal		Inv_sqrt
	nop	
	//L_Extract
	sra		t0, v0, 16	;sra	t1, v0, 1//t0=hi
	sll		a3, t0, 14+1;li		t2, FRAC1
	subr.s	t1, t1, a3	;li		t3, 0x00004000//t1=lo	
	multa2	m0l, s0, t2
	mfa		v0, m0l
	addr.s	v0, v0, t3
	sra		v0, v0, 15
	addr2.s v0, v0, s0	
	sll		v0, v0, 16
	sra		v0, v0, 16	//v0=temp1
	/* <=> alpha x cur_gainR * 2^2 * sqrt(L_SUBFR) */
	multa2	m0l, t0, v0
	addma.s	m0l,m0l,m0l	//shift left 1
	multa2	m1l, t1, v0
	mfa		v0, m0l
	mfa		a3, m1l
	sra		a3, a3, 15
	sll		a3, a3, 1			
	addr.s	s6, v0, a3	//s6=L_acc
	//jal		norm_l
	//move	a0, s6		//v0=sh
	cls		v0, s6
	cmveqz	v0, zero, s6
	sll		s6, s6, v0
	sra		s6, s6, 16	//s6=temp1
	
	sub		v0, v0, 14			//v0=sh
	move	a0, s4				//a0->excg[0]
	lwp		t4, (a0)+4	;sge	t7, v0, zero//t7=sh>=0 ?
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/2-1
	mtru	t0, lps0	;sub	v1, zero, v0//v1=-sh
	mtru	t1, lpe0	;li		t9, 0x00004000
	mtru	t2, lpc0	;mux2.ll t8, s6, s6	//t8=[temp1 temp1]
	sub		s6, v0, 1	;li		s7, 1
	absr.s	s6, s6
	max		s6, s6, zero	//s6=max{0,(sh-1)}
	sll		s7, s7, s6	//s7=1<<(sh-1)
	.align	3
1:
	multa2	m0, t4, t8	;lwp	t5, (a0)+4
	mfa		t0, m0h		;move	t6, v1	//t6=-sh
	mfa		t1, m0l		;addr.s	t0, t0, t9//t0=temp2
	sra		t0, t0, 15	;addr.s	t1, t1, t9//t1=temp1
	sra		t1, t1, 15	;cmvnez	t6, v0, t7//if(sh>=0) t6=sh
	addr.s	t2, t0, s7	;addr.s	t3, t1, s7
	sra		t2, t2, t6	;sra	t3, t3, t6//t2=temp2 >> sh/-sh	
	cmvnez	t0, t2, t7	;cmvnez	t1, t3, t7
	sll		t2, t0, t6	;sll	t3, t1, t6
	cmveqz	t0, t2, t7	;cmveqz	t1, t3, t7
	mux2.ll	t0, t0, t1	;move	t4, t5
	sw		t0, -8(a0)	;nop
2:	
	/* generate random  adaptive excitation */
    /****************************************/
	move	a0, s1		;lw		a1, (2*88)(s4)//t0
	li		a3, L_SUBFR	;lw		a2, (2*90)(s4)//frac
	jal		Pred_lt_3s
	nop
	/* compute adaptive + gaussian exc -> cur_exc */
    /**********************************************/
	li		t9, 0		//t9=max
	move	a0, s1		//a0->cur_exc[]
	la		t0, 1f
	lwp		t4, (a0)+4	//t4=cur_exc[0 1]
	la		t1, 2f-4
	lw		t8, (2*94)(s4)	//t8=Gp2
	li		t2, L_SUBFR/2-1;nop
	mtru	t0, lps0	;move	a1, s4	//a1->excg[]
	mtru	t1, lpe0	;mux2.ll t8,t8,t8 //t8=[Gp2 Gp2]
	mtru	t2, lpc0	;li		t7, 0x00004000
	.align	3
1:	
	multa2	m0, t4, t8	;lwp	t5, (a0)+4
	mfa		v0, m0h		;li		t0, 0x00004000
	lwp		t3, (a1)+4	;addr.s	v0, v0, t0
	mfa		v1, m0l		;sra	v0, v0, 15
	addr.s	v1, v1, t0	;move	t4, t5
	sra		v1, v1, 15	
	mux2.ll	v0, v0, v1
	addr2.s	v0, v0, t3	;nop
	sw		v0, -8(a0)	;absr2.s v1, v0	//cur_exc[i]=temp1
	max2	t9, v1, t9	;nop
2:
	sra		t0, t9, 16	;mux2.lh t1, t9, t9
	sra		t1, t1, 16
	max		t9, t0, t1	//t9=max	
	/* rescale cur_exc -> excs */
	seq		t0, t9, zero//max==0?
	bnez	t0, 3f
	cmvnez	t8, zero, t0	//t8=sh
	//jal		norm_s
	//move	a0, t9
	cls		v0, t9
	sub		v0, v0, 16
	cmveqz	v0, zero, t9
	li		t4, 3
	sub		t8, t4, v0
	max		t8, t8, zero	//t8=sh
	move	s6, t8			//s6=sh
3:	//for (i=0; i<L_SUBFR; i++)
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/2-1;mtru	t0, lps0
	mtru	t1, lpe0	;move	a0, s1		//a0->cur_exc
	lwp		t4, (a0)+4	;sge	t7, t8, zero//t4=cur_exc[0 1]
	mtru	t2, lpc0	;addu	a1, s4, 2*40//a1->excs[]
	sub		t9, zero, t8//t9=-sh
	cmveqz	t8, t9, t7	//t8=sh/-sh, t8>0
1:
	srav2	t0, t4, t8	;lwp	t5, (a0)+4
	sllv2	t1, t4, t8	;move	t3, t0
	cmveqz	t3, t1, t7	;nop
	swp		t3, (a1)+4	;move	t4, t5
2:	
	/* Compute fixed code gain */
	/***************************/
	addu	a0, s4, 2*40;multa2	m0,zero,zero
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
1:
	lwp		t4, (a0)+4
	lwp		t5, (a0)+4
	madda2.s m0, t4, t4
	madda2.s m0, t5, t5
2:
	addma.s m0l,m0l,m0h
	addma.s m0l,m0l,m0l	//m0l=L_ener
	
	/* inter_exc = b >> sh */	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 4/2-1
	mtru	t0, lps0	
	mtru	t1, lpe0	;addu	a0, s4, 2*80//a0->pos[0]
	lwp		t4, (a0)+4	;addu	a1, s4, 2*40//a1->excs[] t4=[pos[0] sign[0]]
	mtru	t2, lpc0	;li		t9, 0//t9=inter_exc
	.align	3
1:
	sra		t0, t4, 16	;lwp	t5, (a0)+4//t0=j
	sll		t0, t0, 1	;and	v0, t4, 0x0000ffff
	addu	t0, t0, a1	;sra	t1, t5, 16
	lh		t0, 0(t0)	;sll	t1, t1, 1//t0=exc[j]
	nop					;addu	t1, t1, a1
	sub		t8, t9, t0	;lh		t1, 0(t1)//t8=inter_exc-excs[j]
	add		t7, t9, t0	;lwp	t4, (a0)+4//t7=inter_exc+excs[j]
	cmvnez	t8, t7, v0	;and	v1, t5, 0x0000ffff//t8=inter_exc
	sub		t3, t8, t1	;add	t6, t8, t1
	cmvnez	t3, t6, v1
	move	t9, t3		//t9=inter_exc
2:
	/* compute k = cur_gainR x cur_gainR x L_SUBFR */
	li		t0, L_SUBFR	;sll	t1, s6, 1
	multa2	m1l, s0, t0	;add	t1, t1, 1//t1=temp1
	mfa		v0, m1l, 5	;sgt	t3, t1, zero//v0=L_acc
	multa2	m2l, s0, v0	;sub	t2, zero, t1//t2=-temp1
	addma.s m2l,m2l,m2l	;cmveqz	t1, t2, t3//t1=temp1
	mfa		v1, m2l		//v1=L_k
	sra		t0, v1, t1
	sll		t2, v1, t1	;mfa	v0, m0l//v0=L_ener
	cmveqz	t0, t2, t3	//t0=L_acc
	
	/* compute delta = b^2 - 4c */
	subr.s	t0, t0, v0
	sra		t9, t9, 1	;mta2	t0, m0h
	multa2	m0l, t9, t9	;sw		v1, (96*2)(s4)//save L_k
	addma.s	m0l, m0l, m0l
	addma.s m0l, m0l, m0h
	mfa		t0, m0l	//t0=L_acc
	add		s6, s6, 1	//s6=sh
	
	bgez	t0, 3f
	move	a0, t0	
	// if (L_acc < 0) {		
	/* adaptive excitation = 0 */
	.align	3
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	;move	a0, s1	//a0->cur_exc
	mtru	t2, lpc0	;move	a1, s4	//a1->excg
1:	
	lwp		t0, (a1)+4
	lwp		t1, (a1)+4
	swp		t0, (a0)+4
	swp		t1, (a0)+4
2:
	lw		t0, (2*80)(s4)	//t0=[pos[0] sign[0]]
	lw		t1, (2*82)(s4)	//t1=[pos[1] sign[1]]
	lw		t2, (2*84)(s4)	;sra	t0, t0, 16//t2=[pos[2] sing[2]]
	lw		t3, (2*86)(s4)	;sra	t1, t1, 16//t3=[pos[3] sign[3]]
	sra		t2, t2, 16		;sll	t0, t0, 1
	sll		t1, t1, 1		;sra	t3, t3, 16
	sll		t2, t2, 1		;sll	t3, t3, 1
	addu	t0, t0, s4		;nop
	lh		t0, 0(t0)		;addu	t1, t1, s4
	lh		t1, 0(t1)		;addu	t2, t2, s4
	lh		t2, 0(t2)		;addu	t3, t3, s4
	lh		t3, 0(t3)		;absr.s	t0, t0
	absr.s	t1, t1			;absr.s	t2, t2
	absr.s	t3, t3			;or		t0, t0, t1
	or		t2, t2, t3		;nop
	or		t0, t0, t2		;li		t4, 1
	and		t0, t0, 0x00004000;li	t5, 2
	cmvnez	s6, t5, t0		;li		t9, 0 //s6=sh t9=inter_exc
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 4/2-1
	mtru	t0, lps0
	mtru	t1, lpe0		;move	a0, s4//a0->excg[0]
	mtru	t2, lpc0		;addu	a1, s4, 2*80//a1->pos[0]
	.align	3
1:
	lwp		t0, (a1)+4	//t0=[pos0 s0]
	lwp		t1, (a1)+4	//t1=[pos1 s1]
	sll		t2, t0, 1		;sll	v0, t0, 16
	sll		t3, t1, 1		;sra	t2, t2, 16//t2=pos0*2
	sra		t3, t3, 16		;addu	t2, s4, t2
	addu	t3, s4, t3		;lh		t2, 0(t2)
	lh		t3, 0(t3)		;sll	v1, t1, 16
	sra		v0, v0, 16		;sra	v1, v1, 16//v0=s0 v1=s1
	sra		t2, t2, s6		;sra	t3, t3, s6//t2=temp1 t3=temp1
	sub		t8, t9, t2		;add	t7, t9, t2
	cmvnez	t8, t7, v0	
	sub		t6, t8, t3
	add		t5, t8, t3
	cmvnez	t6, t5, v1	
	move	t9, t6			;nop//t9=inter_exc
2:
	/* inter_exc = b >> sh */
	lw		a0, (2*96)(s4)	//t0=L_k
	sll		t0, s6, 1
	sub		t0, t0, 1	//t0=temp1=(sh<<1)-1
	li		a2, K0
	//L_Extract
	sra		v0, a0, 16	;sra	v1, a0, 1//v0=hi
	sll		a3, v0, 14+1
	subr.s	v1, v1, a3	//v1=lo
	//Mpy_32_16
	multa2	m1l, v0, a2
	addma.s	m1l,m1l,m1l	//shift left 1
	multa2	m2l, v1, a2
	mfa		v0, m1l
	mfa		a3, m2l
	sra		a3, a3, 15
	sll		a3, a3, 1		
	addr.s	a0, v0, a3	//a0=L_acc
	blez	t0, 1f
	sub		t1, zero, t0	//t1=-temp1	
	j		2f
	sra		v0, a0, t0		//v0=L_acc=L_shr(L_acc,temp1)
1:
	jal		L_shl
	move	a1, t1
2:
	//v0=L_acc
	multa2	m0l, t9, t9
	addma.s m0l,m0l,m0l
	mfa		t0, m0l
	addr.s	a0, v0, t0	//a0=L_acc
	sw		zero, (2*92)(s4)	//Gp=0
	// }
3:	
	jal		Sqrts
	nop	
	add		t2, v0, t9	
	sub		t1, v0, t9		;absr.s	t4, t1 //t1=x1
	sub		t2, zero, t2	;li		t3, 2//t2=x2
	absr.s	t5, t2			;sub	t3, t3, s6//t3=temp1
	slt		v0, t5, t4		
	cmvnez	t1, t2, v0
	bltz	t3, 1f
	li		t4, 1
	sub		t5, t3, 1
	sll		t4, t4, t5
	addr.s	t4, t4, t1
	j		2f
	sra		t4, t4, t3	//t4=g	
1:	
	sub		t3, zero, t3//t3=-temp1
	sll		t4, t1, t3	//t4=g
2:
	// if(g>=0)	
	bltz	t4, 1f
	li		t1, G_MAX
	j		2f
	min		t4, t4, t1	
1:	// else	
	sub		t6, zero, t1//t6=-G_MAX
	slt		v0, t4, t6
	cmvnez	t4, t6, v0	//t4=g
	//max		t4, t4, t6	//t4=g
2:	
	/* Update cur_exc with ACELP excitation */
	.align	3
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 4/2-1
	mtru	t0, lps0
	mtru	t1, lpe0	;addu	a0, s4, 2*80//a-->pos[0]
	mtru	t2, lpc0	;lwp	t0, (a0)+4//t0=[p0 s0]
	move	a1, s1		;lwp	t1, (a0)+4//a1->cur_exc
1:
	mux2.lh	v0, zero, t0;mux2.ll v1, zero, t0//v0=j0
	sll		v0, v0, 1	;mux2.lh t8, zero, t1//t8=j1
	addu	a1, s1, v0	;mux2.ll t9, zero, t1//a1->cur_exc[j0]
	lh		t2, 0(a1)	;sll	t8, t8, 1
	addu	a2, s1, t8	;lwp	t0, (a0)+4//a2->cur_exc[j1]
	lh		t3, 0(a2)	;addr.s t5, t2, t4//cur_exc[j]+g
	subr.s	t6, t2, t4	;lwp	t1, (a0)+4
	cmveqz	t5, t6, v1	;addr.s	v0, t3, t4
	sh		t5, 0(a1)	;subr.s	v1, t3, t4//store cur_exc[j0]
	move	t2, v0
	cmveqz	t2, v1, t9
	sh		t2, 0(a2)	;li		a3, FLAG_DEC
2:
	sub		a3, a3, s3
	beqz	a3, 1f
	lw		a0, (2*92)(s4)//Gp
	lw		a1, (2*88)(s4)//t0	
	jal		update_exc_err
	nop
1:	
	addu	s1, s1, 2*L_SUBFR	//cur_exc += L_SUBFR
	sub		t0, s5, L_FRAME/2
	bltz	t0, 8b
	addu	s5, s5, L_SUBFR
	// } end i_subfr
	// end of loop on subframes
	
9:	/////////////////
	lw		ra, 20(sp)
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	jr		ra
	addu	sp, sp, 128

	.set	reorder
	.end	Calc_exc_rands

/*
Word16 Gauss(Word16 *seed)
NOTE. can't use a3
NOTE. can't use m1
*/
	.text
	//.section ".text.Gausss"
	.set	noreorder
	.globl	Gausss
	.ent	Gausss
Gausss:
	//////////////
	.align	3
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 12-1	;mtru	t0, lps0
	mtru	t1, lpe0	;li		t9, 0	//t9=L_acc
	lh		t4, 0(a0)	;li		t6, 13849//t4=*seed		
	mtru	t2, lpc0	;li		t5, 31821		
1:		
	multa2	m0l, t4, t5		
	mfa		v0, m0l
	addr.s	v0, v0, t6
	sll		v0, v0, 16
	sra		t4, v0, 16	
	addr.s	t9, t9, t4	//L_acc += Randoms()	
2:
	sh		t4, 0(a0)	;sra	t9, t9, 7//store *seed 	
	sll		t9, t9, 16		
	/////////////
	jr		ra
	sra		v0, t9, 16	//v0=temp
	.set	reorder
	.end	Gausss

/*
Word16 Sqrt(Word32 Num)
	a0->Num
NOTE. can't use t9	
*/
	.text
	//.section ".text.Sqrts"
	.set	noreorder
	.globl	Sqrts
	.ent	Sqrts
Sqrts:
	.align	3
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 14-1	;mtru	t0, lps0
	mfru	t3, mmd		;li		t4, 0x6//frac mpy and 32 bit sature
	mtru	t4, mmd		;nop
	mtru	t1, lpe0	;li		v0, 0		//v0=Rez
	mtru	t2, lpc0	;li		v1, 0x4000	//v1=Exp
	addr.s	t4, v0, v1	
	.align	3
1:
	addr.s	t4, v0, v1	;mta2	a0, m0l//t4=Rez+Exp
	msuba2.s m0l, t4, t4;sra	v1, v1, 1
	mfa		t1, m0l
	sge		t2, t1, zero
	cmvnez	v0, t4, t2	
2:
	mtru	t3, mmd
	jr		ra
	nop
	.set	reorder
	.end	Sqrts
