#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define L_SUBFR	40

/*
void g729_cod_ld8a_sub1(Word16 *xn, Word16 *y1, Word16 gain_pit, Word16 *xn2)
	a0->*xn			align 8
	a1->*y1			align 4
	a2->gain_pit
	a3->*xn2		align 8
*/
	.text
	.set	noreorder
	.globl	g729_cod_ld8a_sub1s
	.ent	g729_cod_ld8a_sub1s
g729_cod_ld8a_sub1s:
	mfru	t9, mmd	;li		t2, 0x6//frac mpy and 32 bit sature
	mtru	t2, mmd	
	la		t0, 1f
	lwp		t4, (a0)+4	//t4=xn[0 1]	
	la		t1, 2f-4
	lwp		t6, (a1)+4	//t6=y1[0 1]
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	;mux2.ll a2, a2, a2//a2=[gain_pit gain_pit]
	mtru	t2, lpc0
	.align	3
1:
	multa2	m0, t6, a2	;lwp	t7, (a1)+4
	addma.s m0h,m0h,m0h	;lwp	t5, (a0)+4
	addma.s m0l,m0l,m0l	;multa2	m1, t7, a2
	mfa		v0, m0h		;addma.s m1h,m1h,m1h
	mfa		v1, m0l		;addma.s m1l,m1l,m1l
	mux2.hh	v0, v0, v1	;mfa	t0, m1h
	subr2.s	v0, t4, v0	;mfa	t1, m1l
	mux2.hh	v1, t0, t1	;lwp	t6, (a1)+4
	subr2.s	v1, t5, v1	;lwp	t4, (a0)+4
	stp		v0, (a3)+8	;nop	
2:			
	jr		ra
	mtru	t9, mmd
	
	.set	reorder
	.end	g729_cod_ld8a_sub1s

/*
void g729_cod_ld8a_sub2(Word16 *pexc, Word16 gain_pit, Word16 *code, Word16 gain_code)
	a0->*pexc		align 4
	a1->gain_pit
	a2->*code		align 4
	a3->gain_code
*/
	.text
	.set	noreorder
	.globl	g729_cod_ld8a_sub2s
	.ent	g729_cod_ld8a_sub2s
g729_cod_ld8a_sub2s:
	.align	3
	mfru	t9, mmd		;li	t0, 0x6//frac mpy
	mtru	t0, mmd
	la		t4, 1f
	lwp		t0, (a0)+4	//t0=pexc[0 1]
	la		t5, 2f-4
	lwp		t2, (a2)+4	//t2=code[0 1]
	li		t6, L_SUBFR/4-1
	mtru	t4, lps0	;nop
	mtru	t5, lpe0	;mux2.ll a3, a3, a3
	mtru	t6, lpc0	;mux2.ll a1, a1, a1	
	.align	3
1:
	multa2	m0, t0, a1	;lwp	t1, (a0)+4
	madda2.s m0, t2, a3	;lwp	t3, (a2)+4
	addma.s	m0h, m0h,m0h;addma.s m0l,m0l,m0l
	multa2	m1, t1, a1	;lwp	t0, (a0)+4
	madda2.s m1, t3, a3	;lwp	t2, (a2)+4
	addma.s m1h,m1h,m1h	;addma.s m1l,m1l,m1l
	mfa		v0, m0h		;li		t8, 0x00008000	
	mfa		v1, m0l		;addr.s	v0, v0, t8
	addr.s	v1, v1, t8	;mfa	t4, m1h
	mux2.hh	v0, v0, v1	;mfa	t5, m1l
	sw		v0, -12(a0)	;addr.s	t4, t4, t8
	addr.s	t5, t5, t8
	mux2.hh	t4, t4, t5
	sw		t4, -8(a0)	;nop
2:		
	jr		ra
	mtru	t9, mmd

	.set	reorder
	.end	g729_cod_ld8a_sub2s
