#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define L_SUBFR	40

/*
void Corr_xy2(Word16 xn[], Word16 y1[], Word16 y2[], Word16 g_coeff[], Word16 exp_g_coeff[])
	a0->xn[]			//align 8
	a1->y1[]			//align 4
	a2->y2[]			//align 4
	s0->g_coeff[]		//align 4
	s1->exp_g_coeff[]	//align 4
local:
	g729_TmpVct[]->scaled_y2[]
*/
	.text	
	//.section ".text.Corr_xy2s"
	.set	noreorder
	.globl	Corr_xy2s
	.ent	Corr_xy2s
Corr_xy2s:
	lw		t0, 16(sp)	//for GNU, load exp_g_coeff[] from stack
	nop
	subu	sp, sp, 64
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)
	sw		s3, 40(sp)	;move	s0, a3//s0=g_coeff[]
	sw		s4, 44(sp)	;move	s1, t0//s1=exp_g_coeff[]
	sw		s5, 48(sp)	
	sw		s6, 52(sp)
	mfru	t4, mmd		;li		t5, 0x6
	mtru	t5, mmd
	sw		t4, 24(sp)
	////////////////	
	/* scale sown y2[] to avoid overflow */
	la		t4, 1f
	la		t5, 2f-4
	li		t6, L_SUBFR/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	.extern g729_TmpVct
	la		s2, g729_TmpVct	//s2=scaled_y2[]
	lwp		t0, (a2)+4	;multa2	m0,zero,zero
	lwp		t1, (a2)+4	;li		t2, 0x3
	lwp		t5, (a0)+4	;multa2	m1,zero,zero
	lwp		t6, (a0)+4	;multa2 m2,zero,zero
	lwp		t7, (a1)+4	;li		t4, 1
	lwp		t8, (a1)+4
	mta2	t4, m0l	//L_acc=1
	mta2	t4, m1l	//L_acc1=1
	mta2	t4, m2l	//L_acc2=1
	.align	3
1:
	srav2	t0, t0, t2	;lwp	t3, (a2)+4
	srav2	t1, t1, t2	;lwp	t4, (a2)+4
	stp		t0, (s2)+8	;madda2.s m0, t0, t0
	madda2.s m0, t1, t1	;lwp	s3, (a0)+4
	madda2.s m1, t5, t0	;lwp	s4, (a0)+4
	madda2.s m1, t6, t1	;lwp	s5, (a1)+4
	madda2.s m2, t7, t0	;lwp	s6, (a1)+4
	madda2.s m2, t8, t1	;move	t0, t3
	move	t1, t4		;move	t5, s3
	move	t6, s4		;move	t7, s5
	move	t8, s6		;nop
2:
	addma.s m0l,m0l,m0h	;subu	s2, s2, 80
	addma.s m1l,m1l,m1h//m0l=L_acc
	addma.s m2l,m2l,m2h//m1l=L_acc1
	mfa	a0, m0l		//m2l=L_acc2	
	//jal		norm_l
	//move	s6, a0		//s6=L_acc
	cls		v0, a0		;move	s6, a0//s6=L_acc
	cmveqz	v0, zero, a0
	
	sll		s6, s6, v0	;li		t4, 0x00008000
	addr.s	s6, s6, t4
	sra		s6, s6, 16	//s6=y2y2
	addi	t9, v0, 3	//t9=exp_y2y2
	sh		s6, 4(s0)	//g_coeff[2]=y2y2
	sh		t9, 4(s1)	//exp_g_coeff[2]=exp_y2y2
	
	mfa		s6, m1l		//s6=L_acc1
	//jal		norm_l
	//move	a0, s6
	cls		v0, s6
	cmveqz	v0, zero, s6
	
	sll		s6, s6, v0	;li		t4, 0x00008000
	addr.s	s6, s6, t4
	sra		s6, s6, 16	//s6=xny2
	sub		t9, v0, 6
	subr.s	s6, zero, s6
	sub		t9, t9, 1
	sh		s6, 6(s0)
	sh		t9, 6(s1)
	
	mfa		s6, m2l
	//jal		norm_l
	//move	a0, s6
	cls		v0, s6
	cmveqz	v0, zero, s6
	
	sll		s6, s6, v0	;li		t4, 0x00008000
	addr.s	s6, s6, t4
	sra		s6, s6, 16	//s6=y1y2
	sub		t9, v0, 6
	sub		t9, t9, 1
	sh		s6, 8(s0)
	sh		t9, 8(s1)
	////////////////
	lw		ra, 20(sp)
	lw		t4, 24(sp)
	lw		s0, 28(sp)	
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	Corr_xy2s


/*
void Cor_h_X(Word16 h[], Word16 X[], Word16 D[])
	a0->h[]		align 8
	a1->X[]		align 8
	a2->D[]		align 4
local:
	g729_TmpVct[0]->y32[] (Word32)
	g729_TmpVct[80]->Len[]
*/
	.text
	//.section ".text.g729_Cor_h_Xs"
	.set	noreorder
	.globl	g729_Cor_h_Xs
	.ent	g729_Cor_h_Xs
g729_Cor_h_Xs:
	.align	3
	subu	sp, sp, 64
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0
	sw		s3, 40(sp)	;move	s1, a1
	sw		s4, 44(sp)	;move	s2, a2	
	//////////////////
	mfru	t4, mmd		;li		t5, 0x6
	mtru	t5, mmd		
	sw		t4, 24(sp)
	/* first keep the result on 32 bits and find absoulte maximum */
	.extern g729_TmpVct
	la		s3, g729_TmpVct		//s3->y32[]
	li		t0, 0x00280028;nop
	move	a0, s1	;sw		t0, 160(s3)	//Len[0]=Len[1]=40
	move	a1, s0	;sw		zero, (2*L_SUBFR)(s1)
	move	a2, s3	;sw		zero, (2*(L_SUBFR+2))(s1)
	jal		g729_crossconvs
	addu	a3, s3, 160
	
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0	;move	a0, s3	//a0->y32[]
	mtru	t5, lpe0	;li		t6, L_SUBFR/2-1		
	ltp		t0, (a0)+8	;li		t9, 0	//t9=max
	mtru	t6, lpc0
	.align	3
1:
	absr.s	t0, t0		;ltp	t2, (a0)+8
	absr.s	t1, t1		;max	t9, t9, t0
	max		t9, t9, t1	;move	t0, t2
	move	t1, t3		;nop	
2:
	/* Find the number of right shifts to do on y32[] */
	/* so that maximum is on 13 bits */
	//jal		norm_l
	//move	a0, t9
	cls		v0, t9
	cmveqz	v0, zero, t9
	
	li		t4, 16
	min		v0, v0, t4
	li		t3, 18	
	sub		v0, t3, v0	//v0=j
	
	la		t4, 1f
	la		t5, 2f-4
	li		t6, L_SUBFR/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	ltp		t0, (s3)+8
	ltp		t2, (s3)+8
	.align	3
1:
	srav	t0, t0, v0	;srav	t1, t1, v0
	mux2.ll	t4, t0, t1	;srav	t2, t2, v0	
	swp		t4, (s2)+4	;srav	t3, t3, v0	
	mux2.ll t5, t2, t3	;ltp	t0, (s3)+8
	swp		t5, (s2)+4	;ltp	t2, (s3)+8
2:

	//////////////////
	lw		ra, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	g729_Cor_h_Xs

