#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define M	10

/*
void Lsp_Az(Word16 lsp[], Word16 a[])
	a0->lsp[]
	a1->a[]
local:
	f1->TmpVct[0]
	f2->TmpVct[12]	
*/
	.text
    //.section ".text.Lsp_Azs"
	.set	noreorder
	.globl	Lsp_Azs
	.ent	Lsp_Azs
Lsp_Azs:
	subu	sp, sp, 64	
	sw		s0, 24(sp)
	sw		s1, 28(sp)
	sw		ra, 20(sp)
	sw		s2, 32(sp)
	.extern g729_TmpVct
	la		s2, g729_TmpVct
	//////////////////
	move	s0, a0	;move	s1, a1//s0->lsp s1->a[]
	jal		Get_lsp_pols
	move	a1, s2
	addu	a0, s0, 2
	jal		Get_lsp_pols
	addu	a1, s2, 2*12
	
	addu	a0, s2, 4*5//a0->f1[5]
	addu	a1, s2, 24+4*5//a1->f2[5]
	la		t0, 1f
	lwp		t4, (a0)-4
	la		t1, 2f-4
	lwp		t6,	(a1)-4
	li		t2, 5-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align	3
1:
	lwp		t1, (a0)-4	;move	t0, t4//t0=f1[5] t1=f1[4]
	lwp		t3, (a1)-4	;move	t2, t6//t2=f2[5] t3=f2[4]
	addr.s	t0, t0, t1	;move	t4, t1
	subr.s	t2, t2, t3	;move	t6, t3	
	sw		t0, 8(a0)	
	sw		t2, 8(a1)
2:
	.align	3
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 5-1
	mtru	t0, lps0
	mtru	t1, lpe0	;addu	a0, s2, 4	//a0->f1[1]
	mtru	t2, lpc0	;addu	a1, s2, 24+4//a1->f2[1]
	lwp		t4, (a0)+4
	lwp		t5, (a1)+4
	addu	a2, s1, 0	;addu	a3, s1, 2*9	//a2->a[0] a3->a[9]
1:
	addr.s	t0, t4, t5	;lwp	t2, (a0)+4
	subr.s	t1, t4, t5	;lwp	t3, (a1)+4
	//L_shr_r_plus
	li		t7, 1		;li		t6, 13	
	sub		v1, t6, 1	;move	t4, t2
	sll		t8, t7, v1	;move	t5, t3//t8=1<<(var2-1)
	addr.s	v0, t0, t8	;addr.s v1, t1, t8
	sra		v0, v0, t6	;sra	v1, v1, t6
	//sra		v0, v0, 16	;sra	v1, v1, 16//v0=a[0] v1=a[9]
	mux2.hl	v0,zero, v0	;mux2.hl v1,zero,v1
	shp		v0, (a2)+2
	shp		v1, (a3)-2
2:	
	//////////////////
	lw		ra, 20(sp)
	lw		s0, 24(sp)
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	Lsp_Azs

/*
void Get_lsp_pol(Word16 *lsp, Word32 *f)
	a0->lsp
	a1->f
*/
	.text
	//.section ".text.Get_lsp_pols"
	.set	noreorder
	.globl	Get_lsp_pols
	.ent	Get_lsp_pols
Get_lsp_pols:
	li		t0, 0x01000000//L_mult(4096,2048)
	////////////////	
	.align	3
	lhp		t8, (a0)+4	;li		t9, 2	//t9=i t8=*lsp
	la		t4, 1f
	swp		t0, (a1)+4	//*f = L_mult(4096, 2048)
	sll		t1, t8, 10	//t1=(*lsp*512)<<1
	la		t5, 2f-4
	mtru	t4, lps0	;subr	t1, zero, t1
	mtru	t5, lpe0	;swp	t1, (a1)+4	//*f = L_msu(0, *lsp, 512)	
	lhp		t8, (a0)+4	//t8=*lsp
5:	// for(i=2; i<=5; i++) {
	lw		t0, -8(a1)	;sub	t2, t9, 1+1//i-1-1 t0=f[-2]
	lw		t1, -4(a1)	//t1=f[-1]
	mtru	t2, lpc0
	sw		t0, 0(a1)	//*f = f[-2]
	.align	3
1:
	//L_Extract
	sra		t4, t1, 16	;sra	t5, t1, 1//t4=hi
	sll		a3, t4, 14+1;lw		t7, 0(a1)	//t7=*f
	subr.s	t5, t5, a3	;multa2	m0l, t4, t8 //t5=lo
	//Mpy_32_16	
	addma.s	m0l,m0l,m0l	;multa2	m1l, t5, t8//shift left 1	
	mfa		v0, m0l
	mfa		a3, m1l	
	sra		a3, a3, 15
	sll		a3, a3, 1	
	addr.s	v0, v0, a3	
	addr.s	v0, v0, v0	//v0=L_shl(t0, 1)
	addr.s	t7, t7, t0	//L_add(*f,f[-2])
	subr.s	t7, t7, v0	//L_sub(*f,t0)
	sw		t7, 0(a1)	
	subu	a1, a1, 4	//f--
	lw		t0, -8(a1)	//t0=f[-2]
	lw		t1, -4(a1)	//t1=f[-1]
2:		
	lw		t7, 0(a1)	;sll	t0, t8, 10	//t7=*f		
	subr.s	t1, t7, t0
	sw		t1, 0(a1)
	sll		t4, t9, 2	;lhp	t8, (a0)+4	//lsp += 2 and load *lsp	
	addu	a1, a1, t4	;sub	t0, t9, 5//f += i	
	// }end i		
	bltz	t0, 5b
	addi	t9, t9, 1

	////////////////	
	jr		ra
	nop
	.set	reorder
	.end	Get_lsp_pols

/*
void Lsp_lsf(Word16 lsp[], Word16 lsf[], Word16 m)
	a0->lsp[]
	a1->lsf[]
	a2->m
*/
	.text
	//.section ".text.Lsp_lsfs"
	.set	noreorder
	.globl	Lsp_lsfs
	.ent	Lsp_lsfs
Lsp_lsfs:
	.extern table
	.extern slope
	la		t7, table	//t7=table
	la		t8, slope	//t8=slope
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;sub	t6, a2, 1//t6=i
	mtru	t1, lpe0	;sll	t5, t6, 1
	mtru	a2, lpc0	;addu	a0, a0, t5//a0->lsp[i]
	li		t9, 63		;addu	a1, a1, t5//a1->lsf[i]
	//t9=ind
1:
	sll		t0, t9, 1	;lhp	t1, (a0)-2//t1=lsp[i]
	addu	t0, t0, t7	//t0->table[ind]
3:	
	lhp		t2, (t0)-2	//t2=table[ind]
	nop
	sub		v0, t2, t1
	bgez	v0, 4f
	nop
	j		3b
	sub		t9, t9, 1	//ind--
4:	
	/*acos(lsp[i])=ind*256 + ((... */
	sll		v1, t9, 1
	addu	v1, v1, t8
	lh		t3, 0(v1)	//t3=slope[ind]
	sub		v0, t1, t2
	multa2	m0l, v0, t3
	addma.s m0l,m0l,m0l
	mfa		v0, m0l
	addr.s	v1, v0, v0
	addr.s	v1, v1, v1
	addr.s	v0, v1, v1	//L_shl(L_tmp,3)	
	li		t4, 0x00008000
	addr.s	v0, v0, t4	;sll	v1, t9, 8//v1=shl(ind,8)
	sra		v0, v0, 16	//v0=tmp
	add		v1, v0, v1
	shp		v1, (a1)-2	//lsf[i]
2:	
	jr		ra
	nop	
	.set	reorder
	.end	Lsp_lsfs	

/*
void Weight_Az(Word16 a[], Word16 gamma, Word16 m, Word16 ap[])
	a0->a[]
	a1->gamma
	a2->m		//
	a3->ap[]
*/
	.text
	//.section ".text.Weight_Azs"
	.set	noreorder
	.globl	Weight_Azs
	.ent	Weight_Azs
Weight_Azs:
	.align	3
	move	v0, a1		;lhp	t4, (a0)+2//v0=fac t4=a[0]
	la		t0, 1f
	la		t1, 2f-4
	mtru	t0, lps0	;li		t9, 0x00008000
	mtru	t1, lpe0	;sub	a2, a2, 1
	mtru	a2, lpc0
	.align	3
1:
	multa2	m0l, t4, v0	;lhp	t5, (a0)+2
	multa2	m1l, v0, a1	;addma.s m0l,m0l,m0l
	addma.s m1l,m1l,m1l	;mfa	t6, m0l
	mfa		v0, m1l		;addr.s	t6, t6, t9
	addr.s	v0, v0, t9	;sra	t6, t6, 16
	sra		v0, v0, 16	;shp	t6, (a3)+2//v0=fac
	move	t4, t5		;nop	//save ap[i]
2:
	jr		ra
	nop
	.set	reorder
	.end	Weight_Azs

/*
void Int_qlpc(Word16 lsp_old[], Word16 lsp_new, Word16 Az[])
	a0->lsp_old[]	align 4
	a1->lsp_new[]	align 4
	a2->Az[]
local:
	lsp[]->40(sp)
*/
	.text
    //.section ".text.Int_qlpcs"
	.set	noreorder
	.globl	Int_qlpcs
	.ent	Int_qlpcs
Int_qlpcs:
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 24(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)
	move	s0, a0		;move	s1, a1
	move	s2, a2
	////////////////
	lwp		t4, (a0)+4	
	la		t0, 1f
	lwp		t5, (a1)+4
	la		t1, 2f-4
	li		t2, M/2-1
	mtru	t0, lps0
	mtru	t1, lpe0	;addu	a2, sp, 40//a2->lsp[0]
	mtru	t2, lpc0	;li		t9, 1
	.align	3
1:
	srav2	t2, t4, t9	;lwp	t0, (a0)+4
	srav2	t3, t5, t9	;lwp	t1, (a1)+4
	addr2.s t6, t2, t3	;move	t4, t0
	swp		t6, (a2)+4	;move	t5, t1
2:
	addu	a0, sp, 40
	jal		Lsp_Azs
	move	a1, s2
	
	move	a0, s1
	jal		Lsp_Azs
	addu	a1, s2, 2*M	
	////////////////
	lw		ra, 20(sp)
	lw		s0, 24(sp)
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	jr		ra
	addu	sp, sp, 128
	.set	reorder
	.end	Int_qlpcs
	
