#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define M	10

/*
void Lsp_prev_compose(Word16 lsp_ele[], Word16 lsp[], Word16 fg[][M], Word16 freq_prev[][M], Word16 fg_sum)
	a0->lsp_ele
	a1->lsp[]
	a2->fg[][]
	a3->freq_prev[][]
	t0->fg_sum[]		//for GHS
	16(sp)->fg_sum[]	//for GNU
*/
	.text
	//.section ".text.Lsp_prev_composes"
	.set	noreorder
	.globl	Lsp_prev_composes
	.ent	Lsp_prev_composes
Lsp_prev_composes:
    lw      t0, 16(sp)  //get fg_sum[] for GNU
	la		t4, 1f
	la		t5, 2f-4
	li		t6, M/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	.align	3
1:	
	lwp		t1, (a0)+4//t1=lsp_ele[0 1]
	lwp		t2, (t0)+4//t2=fg_sum[0 1]
	
	lwp		t3, (a3)+20	;multa2	m0, t1, t2
	lwp		t4, (a2)+20
	lwp		t1, (a3)+20	
	lwp		t2, (a2)+20	;madda2.s m0, t3, t4
	lwp		t5, (a3)+20
	lwp		t6, (a2)+20
	lwp		t3, (a3)+20	;madda2.s m0, t1, t2
	lwp		t4, (a2)+20	;madda2.s m0, t5, t6
	subu	a3,a3,80-4	;subu	a2, a2, 80-4
	madda2.s m0, t3, t4
	addma.s m0h,m0h,m0h
	addma.s m0l,m0l,m0l
	mfa		v0, m0h
	mfa		v1, m0l
	mux2.hh	v0, v0, v1
	swp		v0, (a1)+4	
2:
	jr		ra
	nop
	.set	reorder
	.end	Lsp_prev_composes

/*
void Lsp_prev_extract(Word16 lsp[], Word16 lsp_ele[], Word16 fg[][], Word16 freq_prev[][], Word16 fg_sum_inv[]
	a0->lsp[]
	a1->lsp_ele]
	a2->fg[][]
	a3->freq_prev[][]
	t0->fg_sum_inv[]	//forGHS
	16(sp)->fg_sum_inv[]//for GNU
*/
	.text
	//.section ".text.Lsp_prev_extracts"
	.set	noreorder
	.globl	Lsp_prev_extracts
	.ent	Lsp_prev_extracts
Lsp_prev_extracts:
    lw      t0, 16(sp)    //get fg_sum_inv[] for GNU
	la		t4, 1f
	la		t5, 2f-4
	li		t6, M/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0	
	.align	3
1:
	lwp		t1, (a0)+4	//t1=lsp[0 1]
	lwp		t2, (a3)+20	//t2=freq_prev
	lwp		t3, (a2)+20	;mux2.hl	v0, t1, zero
	lwp		t4, (a3)+20	;mux2.lh	v1, t1, zero
	lwp		t5, (a2)+20	;multa2		m0, t2, t3
	lwp		t6, (a3)+20
	lwp		t7, (a2)+20	
	lwp		t2, (a3)+20	;madda2.s	m0, t4, t5
	lwp		t3, (a2)+20	;madda2.s	m0, t6, t7
	subu	a3, a3, 80-4;subu		a2, a2, 80-4
	madda2.s m0, t2, t3	;lwp		t4, (t0)+4//t4=fg_sum_inv
	addma.s m0h,m0h,m0h	;addma.s 	m0l,m0l,m0l
	mfa		t2, m0h		;mux2.hl	t5, t4, zero
	mfa		t3, m0l		;mux2.lh	t6, t4, zero
	subr.s	v0, v0, t2	;subr.s		v1, v1, t3	
	multa2	m0h, v0, t5
	multa2	m1h, v1, t6
	addma.s	m0h,m0h,m0h	;addma.s 	m1h,m1h,m1h
	//L_shl(L_temp,3)
	addma.s	m0h,m0h,m0h	;addma.s 	m1h,m1h,m1h
	addma.s	m0h,m0h,m0h	;addma.s 	m1h,m1h,m1h
	addma.s	m0h,m0h,m0h	;addma.s 	m1h,m1h,m1h
	mfa		v0, m0h
	mfa		v1, m1h
	mux2.hh	v0, v0, v1
	swp		v0, (a1)+4
2:
	jr		ra
	nop
	.set	reorder
	.end	Lsp_prev_extracts


