/*
 * Copyright c                  Realtek Semiconductor Corporation, 2002  
 * All rights reserved.
 * 
 * Program : SPI Header File 
 * Abstract : 
 * Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
 * $Id: spi.h,v 1.1.1.1 2006/07/26 05:38:36 blue Exp $
 */

#ifndef __SPI__
#define __SPI__

struct rtl8651_spi_dev_s
{
	uint32 gpioSCLK;
	uint32 gpioCS_;
	uint32 gpioSDI;
	uint32 gpioSDO;
	uint32 SClkDelayLoop;
};

typedef struct rtl8651_spi_dev_s rtl8651_spi_dev_t;
typedef uint32 gpioID;

int32 _rtl865x_spi_init( rtl8651_spi_dev_t* pDev, gpioID gpioSCLK, gpioID gpioCS_, gpioID gpioSDI, gpioID gpioSDO, int32 maxSpeed );
int32 _rtl865x_spi_rawRead( rtl8651_spi_dev_t* pDev, void* data, int32 bits );
int32 _rtl865x_spi_rawWrite( rtl8651_spi_dev_t* pDev, void* data, int32 bits );
int32 _rtl865x_spi_exit( rtl8651_spi_dev_t* pDev );

#endif/*__SPI__*/

